/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_andromeda_avl_offset_h_included
#define v3c_andromeda_avl_offset_h_included

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <assert.h>
#include <pthread.h>
#include <treedb/treedb.h>

/* A somewhat contrived example - usually AVL_TMPL_NS is based on TREEDB_NS. */
#define TREEDB_NS(x) AVL_TMPL_NS(x)
#define TREEDB_NBITS 16

typedef TREEDB_NS_CONCAT(uint,_t) AVL_TMPL_NS(size_t);

typedef struct AVL_TMPL_NS(container_t)
{
	char * base, * cur;
}AVL_TMPL_NS(container_t);

typedef struct AVL_TMPL_NS(runtime_t) AVL_TMPL_NS(runtime_t), * AVL_TMPL_NS(runtime_ptr_t);

#include <treedb/avl-template.h>

#ifndef avl_storage_h_included
#include "andromeda-avl-storage.h"
#endif

struct AVL_TMPL_NS(runtime_t) {
	struct AVL_TMPL_NS(storage_t) * m_pStorage;
	AVL_TMPL_NS(container_t)      * m_pContainer;
	AVL_TMPL_NS(tree_t)           * m_pTree;
	pthread_rwlock_t              m_lock;
};

#ifndef AVL_TMPL_NO_IMPL
#include <treedb/avl-template-impl.h>
#endif

#endif // #ifndef v3c_andromeda_avl_offset_h_included
