/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#undef AVL_TMPL_alloc_node
#undef AVL_TMPL_unpack_node
#undef AVL_TMPL_pack_node
#undef AVL_TMPL_cmp
#undef AVL_TMPL_free
#undef AVL_TMPL_free_node
#undef AVL_TMPL_free_item

#define treedb_storage_t_methods(Imp, Prefix, Class) \
	STDMETHOD##Imp##_(void, Prefix##read_lock) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##write_lock) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##unlock) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/) PURE; \
	STDMETHOD##Imp##_(AVL_TMPL_NS(node_ptr_t), Prefix##alloc_node) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, AVL_TMPL_input_t /*p*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##free_node) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, AVL_TMPL_NS(node_ptr_t) /*p*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##free_tree) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, AVL_TMPL_NS(tree_ptr_t) /*p*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##free_data) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, AVL_TMPL_data_ref_t /*p*/) PURE; \
	STDMETHOD##Imp##_(void *, Prefix##unpack_pointer) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, uintptr_t /*p*/) PURE; \
	STDMETHOD##Imp##_(uintptr_t, Prefix##pack_pointer) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, const void * /*p*/) PURE; \
	STDMETHOD##Imp##_(int, Prefix##compare) \
	(THIS(Class) AVL_TMPL_NS(runtime_ptr_t) /*runtime*/ \
	, AVL_TMPL_key_t /*a*/ \
	, AVL_TMPL_key_t /*b*/) PURE

#define treedb_storage_t_read_lock(This, Runtime) \
	V3C_IFACE_CALL(read_lock, This, Runtime)
#define treedb_storage_t_write_lock(This, Runtime) \
	V3C_IFACE_CALL(write_lock, This, Runtime)
#define treedb_storage_t_unlock(This, Runtime) \
	V3C_IFACE_CALL(unlock, This, Runtime)
#define treedb_storage_t_alloc_node(This, Runtime, P) \
	V3C_IFACE_CALL(alloc_node, This, Runtime, P)
#define treedb_storage_t_free_node(This, Runtime, P) \
	V3C_IFACE_CALL(free_node, This, Runtime, P)
#define treedb_storage_t_free_tree(This, Runtime, Tp) \
	V3C_IFACE_CALL(free_tree, This, Runtime, Tp)
#define treedb_storage_t_free_data(This, Runtime, Dp) \
	V3C_IFACE_CALL(free_data, This, Runtime, Dp)
#define treedb_storage_t_unpack_pointer(This, Runtime, U) \
	V3C_IFACE_CALL(unpack_pointer, This, Runtime, U)
#define treedb_storage_t_pack_pointer(This, Runtime, P) \
	V3C_IFACE_CALL(pack_pointer, This, Runtime, P)
#define treedb_storage_t_compare(This, Runtime, A, B) \
	V3C_IFACE_CALL(compare, This, Runtime, A, B)

#define treedb_storage_vtbl_t_entries(Prefix) \
  & Prefix##read_lock \
, & Prefix##write_lock \
, & Prefix##unlock \
, & Prefix##alloc_node \
, & Prefix##free_node \
, & Prefix##free_tree \
, & Prefix##free_data \
, & Prefix##unpack_pointer \
, & Prefix##pack_pointer \
, & Prefix##compare

typedef struct AVL_TMPL_NS(storage_t) AVL_TMPL_NS(storage_t)
, * AVL_TMPL_NS(storage_ptr_t);


#define AVL_TMPL_alloc_node(i) \
	treedb_storage_t_alloc_node(runtime->m_pStorage, runtime, i)

#define AVL_TMPL_unpack_pointer(p) \
	treedb_storage_t_unpack_pointer(runtime->m_pStorage, runtime, p)
#define AVL_TMPL_pack_pointer(n) \
	((uintptr_t)(treedb_storage_t_pack_pointer(runtime->m_pStorage, runtime, n)))

#define AVL_TMPL_cmp(a,b) \
	treedb_storage_t_compare(runtime->m_pStorage, runtime, a, b)
#define AVL_TMPL_free(n) \
	treedb_storage_t_free_tree(runtime->m_pStorage, runtime, n)
#define AVL_TMPL_free_node(n) \
	treedb_storage_t_free_node(runtime->m_pStorage, runtime, n)
#define AVL_TMPL_free_item_data(pNode) \
	treedb_storage_t_free_data(runtime->m_pStorage, runtime, (pNode)->m_item)

#ifdef __cplusplus
struct AVL_TMPL_NS(storage_t) {
	treedb_storage_t_methods(,,);
};

#else

typedef struct AVL_TMPL_NS(storage_vtbl_t) {
	treedb_storage_t_methods(,,AVL_TMPL_NS(storage_t));
} AVL_TMPL_NS(storage_vtbl_t), * AVL_TMPL_NS(storage_vtbl_ptr_t);
struct AVL_TMPL_NS(storage_t) {
	AVL_TMPL_NS(storage_vtbl_ptr_t) m_pVtbl;
};

#endif /* #ifdef __cplusplus */
