/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include "andromeda-avl-pointer-int.h"

int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;

	AvlPointerInt_int_storage_t storage;
#ifndef __cplusplus
	storage.m_pVtbl = & AvlPointerInt_storage_vtbl;
#endif

	AvlPointerInt_tree_t tree;
	AvlPointerInt_runtime_t han = { 0, & tree };
	han.m_pStorage = (AvlPointerInt_storage_ptr_t)(& storage);

	AvlPointerInt_init(& han, han.m_pTree);

	unsigned int n, count;
	for(n = 0; n < 10u; ++n)
		runtime_insert(& han, n);

	count = runtime_count(& han);
	printf("Inserted %d items.\n", count);

	AvlPointerInt_node_ptr_t c = runtime_head(& han);

	for(n = 0; c; ++n, c = runtime_unpack_node(&han, c->m_next))
		printf("[%u] %d\n", n, c->m_item);
	runtime_clear(& han);

	return count == 10 ? 0 : 1;
}
