/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include "andromeda-avl-pointer-string.h"

const char * items[] =
{ "apple"
, "banana"
, "pear"
, "plum"
, "orange"
, "lemon"
};
const char * sorted_items[] =
{ "apple"
, "banana"
, "lemon"
, "orange"
, "pear"
, "plum"
};

int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;

	AvlPointerString_string_storage_t storage;
#ifndef __cplusplus
	storage.m_pVtbl = & AvlPointerString_storage_vtbl;
#endif
	AvlPointerString_tree_t tree;
	AvlPointerString_runtime_t han = { 0, & tree };
	han.m_pStorage = (AvlPointerString_storage_ptr_t)(& storage);

	AvlPointerString_init(& han, han.m_pTree);

	unsigned int n, count;
	for(n = 0; n < sizeof(items)/sizeof(items[0]); ++n)
		runtime_insert(& han, items[n]);

	count = runtime_count(& han);
	printf("Inserted %d items, expected %u.\n", count, (unsigned int)(sizeof(items)/sizeof(items[0])));

	AvlPointerString_node_ptr_t c = runtime_head(&han);
	int ret = (n == sizeof(items)/sizeof(items[0])) ? 0 : 1;

	for(n = 0; c; ++n, c = runtime_unpack_node(&han, c->m_next)) {
		printf("[%u] %s [%s]\n", n, c->m_item, sorted_items[n]);
		if(strcmp(c->m_item, sorted_items[n]))
			ret = 1;
	}
	runtime_clear(& han);

	return ret;
}
