/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include "comet-impl.h"
#include <string.h>

#include <treedb/treedb.h>
#define TREEDB_NS(x) TREEDB_NS_CONCAT(V3C_JOIN3(ti_,x,_),)
#include <treedb/ns-types.h>

/* We don't know in advance how the file was created so we try each in turn. */

CometCommandStatus string_tree_process(int argc, char *argv[])
{
	CometCommandStatus ret;
	/* prg set string create <filename> */
	if(argc == 5 && ((!strcmp(argv[3], "init") || (!strcmp(argv[3], "create"))))) {
		/* Use the way we were built to choose the default. */
		return TREEDB_NS_CONCAT(string_tree,_process)(argc, argv);
	}
	ret = string_tree16_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
	ret = string_tree32_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#if HAVE_64_BITS
	ret = string_tree64_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#endif
	return eCometCommandUnknownSchema;
}
CometCommandStatus int_tree_process(int argc, char *argv[])
{
	if(argc == 5 && ((!strcmp(argv[3], "init") || (!strcmp(argv[3], "create"))))) {
		/* Use the way we were built to choose the default. */
		return TREEDB_NS_CONCAT(int_tree,_process)(argc, argv);
	}
	CometCommandStatus ret;
	ret = int_tree16_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
	ret = int_tree32_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#if HAVE_64_BITS
	ret = int_tree64_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#endif
	return eCometCommandUnknownSchema;
}
CometCommandStatus string_list_process(int argc, char *argv[])
{
	if(argc == 5 && ((!strcmp(argv[3], "init") || (!strcmp(argv[3], "create"))))) {
		/* Use the way we were built to choose the default. */
		return TREEDB_NS_CONCAT(string_list,_process)(argc, argv);
	}
	CometCommandStatus ret;
	ret = string_list16_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
	ret = string_list32_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#if HAVE_64_BITS
	ret = string_list64_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#endif
	return eCometCommandUnknownSchema;
}
CometCommandStatus int_list_process(int argc, char *argv[])
{
	if(argc == 5 && ((!strcmp(argv[3], "init") || (!strcmp(argv[3], "create"))))) {
		/* Use the way we were built to choose the default. */
		return TREEDB_NS_CONCAT(int_list,_process)(argc, argv);
	}
	CometCommandStatus ret;
	ret = int_list16_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
	ret = int_list32_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#if HAVE_64_BITS
	ret = int_list64_process(argc, argv);
	if(ret != eCometCommandUnknownSchema)
		return ret;
#endif
	return eCometCommandUnknownSchema;
}
