/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_comet_h_included
#define v3c_treedb_comet_h_included

#include <uuid.h>
#include <treedb/treedb.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef enum CometCommandStatus
{ eCometCommandSuccess
, eCometCommandFailure /* For some commands, failure is useful. */
, eCometCommandUnrecognisedCommand
, eCometCommandBadCommand /* Missing/wrong-number/invalid arguments. */
, eCometCommandOutOfResources
, eCometCommandFileOpenFailure
, eCometCommandUnknownAllocatorAlgorithm
, eCometCommandUnknownSchema
, eCometCommandHeapError /* The start of the heap errors. */
} CometCommandStatus;

#ifdef __cplusplus
} // extern "C" {
#endif

#endif /* #ifndef v3c_treedb_comet_h_included */
