/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */
/*
#undef TREEDB_DEBUG
#define TREEDB_DEBUG 1
*/
#if TREEDB_NBITS==-1
#include <stdio.h>
int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;
	printf("Not testing on a 32 bit platform.\n");
	return 0;
}
#else

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <pthread.h>
#include <stdexcept>
#include <iostream>
#include <iomanip>
#include <error.h>
#include <v3c/pretty_print_streambuf.hpp>
#include <v3c/string_utils.hpp>

using namespace std;
using namespace v3c;

#define VARRAY_print_offsets(x) varray_print_offsets(pa, x)
#define VARRAY_print_offsets_SIGNATURE \
void varray_print_offsets(TREEDB_PAYLOAD_NS(varray_array_ptr_t) pa \
	, const char * msg)

int return_value(int x)
{
	if(!x)
		return x;
	return x;
}
#define MVARRAY_RETURN(x) return return_value(x)

#define TREEDB_SHARED
#define TREEDB_HAS_RESIZABLE_HEAP
#include "multi-varray-offset-string.h"

#define VARRAY_size_t TREEDB_NS_CONCAT(uint,_t)

// b639c569-842a-457a-8777-edfa4cb07e2f
UUID_DEFINE
( UUID_treedb_multi_varray_string_schema
, 0xb6, 0x39, 0xc5, 0x69
, 0x84, 0x2a
, 0x45, 0x7a
, 0x87, 0x77
, 0xed, 0xfa, 0x4c, 0xb0, 0x7e, 0x2f
);
#define ITEMSXY(x) \
const char items##x##0[] = { 'b', 'l', 'u', 'e', '0' + x }; \
const char items##x##1[] = { 'g', 'r', 'e', 'e', 'n', '0' + x }; \
const char items##x##2[] = { 'r', 'e', 'd', '0' + x }; \
const char items##x##3[] = { 'y', 'e', 'l', 'l', 'o', 'w', '0' + x }; \
const char items##x##4[] = { 'm', 'a', 'g', 'e', 'n', 't', 'a', '0' + x }; \
const char items##x##5[] = { 'g', 'r', 'e', 'y', '0' + x }; \
const char items##x##6[] = { 's', 'i', 'l', 'v', 'e', 'r', '0' + x }; \
const char items##x##7[] = { 'g', 'o', 'l', 'd', '0' + x }; \
const char items##x##8[] = { 'o', 'r', 'a', 'n', 'g', 'e', '0' + x }; \
const char items##x##9[] = { 'b', 'l', 'a', 'c', 'k', '0' + x }
ITEMSXY(0);
ITEMSXY(1);
ITEMSXY(2);
ITEMSXY(3);
ITEMSXY(4);
ITEMSXY(5);
ITEMSXY(6);
ITEMSXY(7);
ITEMSXY(8);
ITEMSXY(9);

#define ITEMSXY_ENTRIES(x) \
  items##x##0, items##x##1, items##x##2, items##x##3, items##x##4, items##x##5 \
, items##x##6, items##x##7, items##x##8, items##x##9
const char * items[] =
{ ITEMSXY_ENTRIES(0)
, ITEMSXY_ENTRIES(1)
, ITEMSXY_ENTRIES(2)
, ITEMSXY_ENTRIES(3)
, ITEMSXY_ENTRIES(4)
, ITEMSXY_ENTRIES(5)
, ITEMSXY_ENTRIES(6)
, ITEMSXY_ENTRIES(7)
, ITEMSXY_ENTRIES(8)
, ITEMSXY_ENTRIES(9)
};
#define ITEMSXY_LEN(x) \
  sizeof(items##x##0) \
, sizeof(items##x##1) \
, sizeof(items##x##2) \
, sizeof(items##x##3) \
, sizeof(items##x##4) \
, sizeof(items##x##5) \
, sizeof(items##x##6) \
, sizeof(items##x##7) \
, sizeof(items##x##8) \
, sizeof(items##x##9)

MVARRAY_size_t items_len[] =
{ ITEMSXY_LEN(0)
, ITEMSXY_LEN(1)
, ITEMSXY_LEN(2)
, ITEMSXY_LEN(3)
, ITEMSXY_LEN(4)
, ITEMSXY_LEN(5)
, ITEMSXY_LEN(6)
, ITEMSXY_LEN(7)
, ITEMSXY_LEN(8)
, ITEMSXY_LEN(9)
};
#define ITEMSXY_SIZE(x) \
  items_sz[0 + x] + items_len[0 + x] \
, items_sz[1 + x] + items_len[1 + x] \
, items_sz[2 + x] + items_len[2 + x] \
, items_sz[3 + x] + items_len[3 + x] \
, items_sz[4 + x] + items_len[4 + x] \
, items_sz[5 + x] + items_len[5 + x] \
, items_sz[6 + x] + items_len[6 + x] \
, items_sz[7 + x] + items_len[7 + x] \
, items_sz[8 + x] + items_len[8 + x] \
, items_sz[9 + x] + items_len[9 + x]

MVARRAY_size_t items_sz[] =
{ 0
, ITEMSXY_SIZE(0)
, ITEMSXY_SIZE(1)
, ITEMSXY_SIZE(2)
, ITEMSXY_SIZE(3)
, ITEMSXY_SIZE(4)
, ITEMSXY_SIZE(5)
, ITEMSXY_SIZE(6)
, ITEMSXY_SIZE(7)
, ITEMSXY_SIZE(8)
, ITEMSXY_SIZE(9)
};
#define ITEM_COUNT (sizeof(items) / sizeof(items[0]))
#define some_sz 30
#define some_offs 40
const char * test_file = "test.3db";
TREEDB_NS(count_t) free_size;
TREEDB_NS(runtime_ptr_t) runtime;
int test_num = 0;
void dump_mvarray_data(TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad)
{
	MVARRAY_size_t n;
	if(pad->m_varray.m_offset.m_count <= 1) {
		cout << "<empty>\n";
		return;
	}
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
	char * pd
		= TREEDB_PAYLOAD_NS(varray_payload_unpack_data)
			(runtime, pad->m_varray.m_payload.m_items);
	cout << "dump " << (pad->m_varray.m_offset.m_count-1) << '\n';
	for(n = 0; n < (pad->m_varray.m_offset.m_count-1); ++n)
		cout << "\t[" << (n + pad->m_index) << "] offs " << setw(2)
			<< (po[n] + pad->m_length_offset) << ", sz "
			<< setw(2) << (po[n+1] - po[n])
			<< " : " << string(pd + po[n], po[n+1] - po[n]) << '\n';
}
void dump()
{
	MVARRAY_size_t n, count;
	TREEDB_PAYLOAD_NS(tree_runtime_t) sub_runtime
		= { runtime, PACKED_STRING_MVARRAY };
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	TREEDB_PAYLOAD_NS(tree_node_ptr_t) pn
		= TREEDB_PAYLOAD_NS(tree_unpack_node)
			(& sub_runtime, pa->m_root.m_top);
	count = pn->m_count;
	pn = TREEDB_PAYLOAD_NS(tree_unpack_node)
			(& sub_runtime, pa->m_root.m_head);
	for(n = 0; pn; pn = TREEDB_PAYLOAD_NS(tree_unpack_node)
			(& sub_runtime, pn->m_next), ++n) {
		cout << '[' << n << " of " << count << "] ";
		dump_mvarray_data(& pn->m_item);
	}
}
void varray_print_offsets
( TREEDB_PAYLOAD_NS(varray_array_ptr_t) pa
, const char * msg
) {
	unsigned int n;
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pa->m_offset.m_items);
	printf("%s (%lu) :", msg, (size_t)pa->m_offset.m_count);
	for(n = 0; n < pa->m_offset.m_count; ++n)
		printf(" [%u]%lu", n, (size_t)po[n]);
	printf("\n");
	fflush(stdout);
}

int fill_test()
{
	TREEDB_NS(runtime_t) han = TREEDB_STORAGE_RUNTIME_INIT;
	runtime = &han;
	int ret = TREEDB_NS(heap_create)
		( runtime
		, UUID_treedb_multi_varray_string_schema
		, test_file
		, eHeapOpenWrite
		, eHeapCreateOwnerRead | eHeapCreateOwnerWrite | eHeapCreateGroupRead
			| eHeapCreateOtherRead
		, eHeapAccessRead | eHeapAccessWrite | eHeapAccessShared
		, 0
		, TREEDB_PAGE_SIZE
		);
	if(ret) {
		cout << "heap_create() failed : " << ret << '.' << endl;
		return 1;
	}

	TREEDB_NSA(node_ptr_t) pFirstNode = 0;
	TreedbSearchResult res = TREEDB_NSF(search_closest)
		(runtime, TREEDB_ALLOC_free_tree, 0, & pFirstNode);
	if(res == eTreedbSearchEmpty)
		return 1;

	free_size = pFirstNode->m_uLength;

	TREEDB_PAYLOAD_NS(init)(runtime, PACKED_STRING_MVARRAY, 0,0,0,0);

	unsigned int n;
	TREEDB_NS(dump_trees)(runtime);
	for(n = 0; n < ITEM_COUNT; ++n) {
		ret = TREEDB_PAYLOAD_NS(push_back)(runtime, PACKED_STRING_MVARRAY, items[n]
			, items_len[n]);
		if(ret) {
			cout << '[' << n << "] push_back() failed : " << ret << '.' << endl;
			return 1;
		}
	}
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(pa->m_count != ITEM_COUNT) {
		cerr << "pa->m_count(" << pa->m_count << ") != "
			<< ITEM_COUNT << '.' << endl;
		return 2;
	}

	TREEDB_NS(heap_unlock)(&han);
	TREEDB_NS(heap_close)(&han);
	return 0;
}

typedef int (*PFN)();

struct TestEntry
{
	PFN fn;
	const char * name;
};
int clear_fn()
{
	TREEDB_PAYLOAD_NS(clear)(runtime, PACKED_STRING_MVARRAY);
	return 0;
}
int push_front_many()
{
	if(TREEDB_PAYLOAD_NS(push_front_many)(runtime, PACKED_STRING_MVARRAY
			, some_sz, items_len))
		return 1;
	/* The entries can span more than one varray. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad;
	MVARRAY_size_t * po;
	char * pd;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	MVARRAY_size_t n, ndx = 0, offset = 0, count = some_sz, sz;
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, 0);
	if(!pad) {
		printf("No data for index(%lu).\n", (size_t)ndx);
		return 2;
	}
	for(;; ++ndx) {
		po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
		pd = TREEDB_PAYLOAD_NS(varray_payload_unpack_data)
			(runtime, pad->m_varray.m_payload.m_items);
		sz = pad->m_varray.m_offset.m_count - 1;
		if(sz > count)
			sz = count;
		if(count >= sz)
			count -= sz;
		else
			count = 0;
		for(n = 0; n < sz; ++n)
			memcpy(pd + po[n], items[n + offset], items_len[n + offset]);
		if(!count)
			break;
		offset += count;
		pad = TREEDB_PAYLOAD_NS(next_tree_item)(runtime, pa, pad);
		if(!pad) {
			printf("No next data for index(%lu).\n", (size_t)ndx);
			return 2;
		}
	}
	MVARRAY_size_t expected = items_sz[some_sz] + items_sz[ITEM_COUNT];
	/* The short way. */
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 3;
	}
	/* The long way. */
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
		(runtime, pad->m_varray.m_offset.m_items);
	if((po[ITEM_COUNT + some_sz] + pad->m_length_offset) != expected) {
		printf("(po[(ITEM_COUNT + %u)(%lu)](%lu) + pn->m_item.m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, some_sz
			, (size_t)(ITEM_COUNT + some_sz)
			, (size_t)po[ITEM_COUNT + some_sz]
			, (size_t)pad->m_length_offset
			, (size_t)(po[ITEM_COUNT + some_sz] + pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 4;
	}
	return 0;
}
int push_back_many()
{
	if(TREEDB_PAYLOAD_NS(push_back_many)(runtime, PACKED_STRING_MVARRAY, some_sz
			, items_len))
		return 1;
	/* The entries can span more than one varray. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad;
	MVARRAY_size_t * po;
	char * pd;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	MVARRAY_size_t n, ndx, offset = 0, count = some_sz, sz, start;
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, ITEM_COUNT);
	if(!pad) {
		printf("No data for index(%lu).\n", (size_t)ITEM_COUNT);
		return 2;
	}
	if(pad->m_index < ITEM_COUNT)
		start = ITEM_COUNT - pad->m_index;
	else
		start = 0;
	for(ndx = 0;; ++ndx) {
		po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
		pd = TREEDB_PAYLOAD_NS(varray_payload_unpack_data)
			(runtime, pad->m_varray.m_payload.m_items);
		sz = pad->m_varray.m_offset.m_count - 1;
		if(sz > count)
			sz = count;
		if(count >= sz)
			count -= sz;
		else
			count = 0;
		for(n = start; n < sz; ++n)
			memcpy(pd + po[n + start], items[n + offset]
				, items_len[n + offset]);
		if(!count)
			break;
		offset += count;
		pad = TREEDB_PAYLOAD_NS(next_tree_item)(runtime, pa, pad);
		if(!pad) {
			printf("No next data for index(%lu).\n", (size_t)ndx);
			return 2;
		}
		start = 0;
	}
	MVARRAY_size_t expected = items_sz[some_sz] + items_sz[ITEM_COUNT];
	/* The short way. */
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 3;
	}
	/* The long way. */
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
		(runtime, pad->m_varray.m_offset.m_items);
	if((po[ITEM_COUNT + some_sz] + pad->m_length_offset) != expected) {
		printf("(po[(ITEM_COUNT + %u)(%lu)](%lu) + pn->m_item.m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, some_sz
			, (size_t)(ITEM_COUNT + some_sz)
			, (size_t)po[ITEM_COUNT + some_sz]
			, (size_t)pad->m_length_offset
			, (size_t)(po[ITEM_COUNT + some_sz] + pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 4;
	}
	return 0;
}
int insert_many()
{
	if(TREEDB_PAYLOAD_NS(insert_many)(runtime, PACKED_STRING_MVARRAY, some_offs
			, some_sz, items_len))
		return 1;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(pa->m_count != (ITEM_COUNT + some_sz)) {
		printf("pa->m_count(%lu) != (ITEM_COUNT(%lu) + %u)(%lu).\n"
			, (size_t)pa->m_count
			, (size_t)ITEM_COUNT
			, some_sz
			, (size_t)(ITEM_COUNT + some_sz + 1)
		);
		return 2;
	}
	/* The entries can span more than one varray. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad;
	MVARRAY_size_t * po;
	char * pd;
	MVARRAY_size_t n, ndx, offset = 0, count = some_sz, sz, start;
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, some_offs);
	if(!pad) {
		printf("No data for index(%lu).\n", (size_t)some_offs);
		return 2;
	}
	if(pad->m_index < some_offs)
		start = some_offs - pad->m_index;
	else
		start = 0;
	for(ndx = 0;; ++ndx) {
		po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
		pd = TREEDB_PAYLOAD_NS(varray_payload_unpack_data)
			(runtime, pad->m_varray.m_payload.m_items);
		sz = pad->m_varray.m_offset.m_count - 1;
		if(sz > count)
			sz = count;
		if(count >= sz)
			count -= sz;
		else
			count = 0;
		for(n = start; n < sz; ++n)
			memcpy(pd + po[n + start], items[n + offset]
				, items_len[n + offset]);
		if(!count)
			break;
		offset += count;
		pad = TREEDB_PAYLOAD_NS(next_tree_item)(runtime, pa, pad);
		if(!pad) {
			printf("No next data for index(%lu).\n", (size_t)ndx);
			return 2;
		}
		start = 0;
	}
	MVARRAY_size_t expected = items_sz[some_sz] + items_sz[ITEM_COUNT];
	/* The short way. */
	pa = STRING_MVARRAY;
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 3;
	}
	/* The long way. */
	pad = TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	po = TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
		(runtime, pad->m_varray.m_offset.m_items);
	if((po[ITEM_COUNT + some_sz] + pad->m_length_offset) != expected) {
		printf("(po[(ITEM_COUNT + %u)(%lu)](%lu) + pn->m_item.m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, some_sz
			, (size_t)(ITEM_COUNT + some_sz)
			, (size_t)po[ITEM_COUNT + some_sz]
			, (size_t)pad->m_length_offset
			, (size_t)(po[ITEM_COUNT + some_sz] + pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 4;
	}
	return 0;
}
int pop_front_many()
{
	if(TREEDB_PAYLOAD_NS(pop_front_many)
			(runtime, PACKED_STRING_MVARRAY, some_sz))
		return 1;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	MVARRAY_size_t expected = items_sz[ITEM_COUNT] - items_sz[some_sz];
	/* The short way. */
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 2;
	}
	/* The long way. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad
		= TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	MVARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
	if((po[pad->m_varray.m_offset.m_count-1] + pad->m_length_offset)
			!= expected) {
		printf("(po[pad->m_varray.m_offset.m_count(%lu) - 1](%lu) "
			"+ pn->m_item.m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, (size_t)pad->m_varray.m_offset.m_count
			, (size_t)po[pad->m_varray.m_offset.m_count-1]
			, (size_t)pad->m_length_offset
			, (size_t)(po[pad->m_varray.m_offset.m_count-1]
				+ pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 3;
	}
	return 0;
}
int pop_back_many()
{
	if(TREEDB_PAYLOAD_NS(pop_back_many)
			(runtime, PACKED_STRING_MVARRAY, some_sz))
		return 1;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	MVARRAY_size_t expected = items_sz[ITEM_COUNT - some_sz];
	/* The short way. */
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 2;
	}
	/* The long way. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad
		= TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	MVARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
			(runtime, pad->m_varray.m_offset.m_items);
	if((po[pad->m_varray.m_offset.m_count-1] + pad->m_length_offset)
			!= expected) {
		printf("(po[pad->m_varray.m_offset.m_count(%lu) - 1](%lu) "
			"+ pn->m_item.m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, (size_t)pad->m_varray.m_offset.m_count
			, (size_t)po[pad->m_varray.m_offset.m_count-1]
			, (size_t)pad->m_length_offset
			, (size_t)(po[pad->m_varray.m_offset.m_count-1]
				+ pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 3;
	}
	return 0;
}
int remove_many()
{
	if(TREEDB_PAYLOAD_NS(remove_many)(runtime, PACKED_STRING_MVARRAY, some_offs
			, some_sz))
		return 1;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	MVARRAY_size_t expected = items_sz[ITEM_COUNT]
		- (items_sz[ITEM_COUNT - some_offs]
			- items_sz[ITEM_COUNT - some_offs - some_sz]);
	/* The short way. */
	if(pa->m_length != expected) {
		printf("pa->m_length(%lu) !="
			" (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))(%lu).\n"
			, (size_t)(pa->m_length)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 1;
	}
	/* The long way. */
	TREEDB_PAYLOAD_NS(tree_item_ptr_t) pad
		= TREEDB_PAYLOAD_NS(tree_item_for)(runtime, pa, pa->m_count-1);
	MVARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(varray_offset_unpack_data)
		(runtime, pad->m_varray.m_offset.m_items);
	if((po[ITEM_COUNT + some_sz] + pad->m_length_offset) != expected) {
		printf("(po[(ITEM_COUNT + %u)(%lu)](%lu) + pad->m_length_offset"
			"(%lu))(%lu) != (items_sz[%u](%lu) + items_sz[ITEM_COUNT](%lu))"
			"(%lu).\n"
			, some_sz
			, (size_t)(ITEM_COUNT + some_sz)
			, (size_t)po[ITEM_COUNT + some_sz]
			, (size_t)pad->m_length_offset
			, (size_t)(po[ITEM_COUNT + some_sz] + pad->m_length_offset)
			, some_sz
			, (size_t)items_sz[some_sz]
			, (size_t)items_sz[ITEM_COUNT]
			, (size_t)(items_sz[some_sz] + items_sz[ITEM_COUNT])
		);
		return 2;
	}
	return 0;
}
int remove_all()
{
	TREEDB_PAYLOAD_NS(clear)(runtime, PACKED_STRING_MVARRAY);
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(pa->m_count != 0)
		return 1;
	return 0;
}
#ifdef LATER
int reverse_some_start()
{
	unsigned int n;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(TREEDB_PAYLOAD_NS(reverse_some)(runtime, pa, 0, some_sz)) {
		printf("reverse_some() failed.\n");
		return 1;
	}
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(offset_unpack_data)(runtime, pa->m_offset.m_items);
	char * pd
		= TREEDB_PAYLOAD_NS(payload_unpack_data)(runtime, pa->m_payload.m_items);
	VARRAY_size_t size = 0;
	for(n = 0; n < some_sz; ++n) {
		if(po[n] != size) {
			printf("reversed [%u] po[n](%ld) != size(%ld).\n"
				, n, (size_t)po[n], (size_t)size);
			return 1;
		}
		size += items_len[some_sz - 1 - n];
		if((po[n+1] - po[n]) != items_len[some_sz - 1 - n]) {
			printf("reversed [%u] (po[n+1] - po[n])(%ld) "
				"!= items_len[some_sz - 1 - n](%ld)\n"
				, n, (size_t)(po[n+1] - po[n])
				, (size_t)items_len[some_sz - 1 - n]);
			return 2;
		}
		if(memcmp(items[some_sz - 1 - n], pd + po[n]
				, items_len[some_sz - 1 - n])) {
			printf("reversed [%u] memcmp() failed.\n", n);
			return 3;
		}
	}
	for(; n < ITEM_COUNT; ++n) {
		if(po[n] != size) {
			printf("above [%u] po[n](%ld) != size(%ld).\n"
				, n, (size_t)po[n], (size_t)size);
			return 4;
		}
		size += items_len[n];
		if((po[n+1] - po[n]) != items_len[n]) {
			printf("above [%u] (po[n+1] - po[n])(%ld) != items_len[n](%ld)\n"
				, n, (size_t)(po[n+1] - po[n]), (size_t)items_len[n]);
			return 5;
		}
		if(memcmp(items[n], pd + po[n], items_len[n])) {
			printf("above [%u] memcmp() failed.\n", n);
			return 6;
		}
	}
	return 0;
}
int reverse_some_middle()
{
	unsigned int n;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(TREEDB_PAYLOAD_NS(reverse_some)(runtime, pa, some_offs, some_sz)) {
		printf("reverse_some() failed.\n");
		return 1;
	}
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(offset_unpack_data)(runtime, pa->m_offset.m_items);
	char * pd
		= TREEDB_PAYLOAD_NS(payload_unpack_data)(runtime, pa->m_payload.m_items);
	VARRAY_size_t size = 0;
	for(n = 0; n < some_offs; ++n) {
		if(po[n] != size)
			return 2;
		size += items_len[n];
		if((po[n+1] - po[n]) != items_len[n])
			return 3;
		if(memcmp(items[n], pd + po[n], po[n+1] - po[n]))
			return 4;
	}
	for(; n < (some_offs + some_sz); ++n) {
		unsigned int cmp = ITEM_COUNT - n;
		if(po[n] != size) {
			printf("reversed [%u] po[n](%ld) != size(%ld).\n"
				, n, (size_t)po[n], (size_t)size);
			return 5;
		}
		size += items_len[cmp];
		if((po[n+1] - po[n]) != items_len[cmp]) {
			printf("reversed [%u] (po[n+1] - po[n])(%ld) "
				"!= items_len[%u](%ld)\n"
				, n, (size_t)(po[n+1] - po[n]), cmp, (size_t)items_len[cmp]);
			return 6;
		}
		if(memcmp(items[cmp], pd + po[n], items_len[cmp])) {
			cout << "reversed [" << n << "] memcmp("
				<< string(items[cmp], items_len[cmp]) << ", "
				<< string(pd + po[n], items_len[cmp]) << ") failed." << endl;
			return 7;
		}
	}
	for(; n < ITEM_COUNT; ++n) {
		if(po[n] != size)
			return 8;
		size += items_len[n];
		if((po[n+1] - po[n]) != items_len[n])
			return 9;
		if(memcmp(items[n], pd + po[n], po[n+1] - po[n]))
			return 10;
	}
	return 0;
}
int reverse_some_end()
{
	unsigned int n;
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	if(TREEDB_PAYLOAD_NS(reverse_some)(runtime, pa, ITEM_COUNT - some_sz
			, some_sz)) {
		printf("reverse_some() failed.\n");
		return 1;
	}
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(offset_unpack_data)(runtime, pa->m_offset.m_items);
	char * pd
		= TREEDB_PAYLOAD_NS(payload_unpack_data)(runtime, pa->m_payload.m_items);
	VARRAY_size_t size = 0;
	for(n = 0; n < (ITEM_COUNT - some_sz); ++n) {
		if(po[n] != size)
			return 2;
		size += items_len[n];
		if((po[n+1] - po[n]) != items_len[n])
			return 3;
		if(memcmp(items[n], pd + po[n], po[n+1] - po[n]))
			return 4;
	}
	for(; n < ITEM_COUNT; ++n) {
		unsigned int cmp = ITEM_COUNT - n + (ITEM_COUNT - some_sz - 1);
		if(po[n] != size) {
			printf("reversed [%u] po[n](%ld) != size(%ld).\n"
				, n, (size_t)po[n], (size_t)size);
			return 5;
		}
		size += items_len[cmp];
		if((po[n+1] - po[n]) != items_len[cmp]) {
			printf("reversed [%u] (po[n+1] - po[n])(%ld) "
				"!= items_len[%u](%ld)\n"
				, n, (size_t)(po[n+1] - po[n]), cmp, (size_t)items_len[cmp]);
			return 6;
		}
		if(memcmp(items[cmp], pd + po[n], items_len[cmp])) {
			cout << "reversed [" << n << "] memcmp("
				<< string(items[cmp], items_len[cmp]) << ", "
				<< string(pd + po[n], items_len[cmp]) << ") failed." << endl;
			return 7;
		}
	}
	return 0;
}
int reverse_all()
{
	unsigned int n;
	TREEDB_PAYLOAD_NS(reverse)(runtime, STRING_MVARRAY);
	TREEDB_PAYLOAD_NS(array_ptr_t) pa = STRING_MVARRAY;
	VARRAY_size_t * po
		= TREEDB_PAYLOAD_NS(offset_unpack_data)(runtime, pa->m_offset.m_items);
	char * pd
		= TREEDB_PAYLOAD_NS(payload_unpack_data)(runtime, pa->m_payload.m_items);
	VARRAY_size_t size = 0;
	for(n = 0; n < (ITEM_COUNT - 1); ++n) {
		if(po[n] != size)
			return 4;
		size += items_len[ITEM_COUNT - 1 - n];
		if((po[n+1] - po[n]) != items_len[ITEM_COUNT - 1 - n])
			return 2;
		if(memcmp(items[ITEM_COUNT - 1 - n], pd + po[n], po[n+1] - po[n]))
			return 3;
	}
	return 0;
}
#endif
#define TEST_ENTRY(name) {& name, #name}
TestEntry tests[] =
{
	TEST_ENTRY(clear_fn),
	TEST_ENTRY(push_front_many),
	TEST_ENTRY(push_back_many),
	TEST_ENTRY(insert_many),
	TEST_ENTRY(pop_front_many),
	TEST_ENTRY(pop_back_many),
	TEST_ENTRY(remove_many),
	TEST_ENTRY(remove_all),
#ifdef LATER
	TEST_ENTRY(reverse_some_start),
	TEST_ENTRY(reverse_some_middle),
	TEST_ENTRY(reverse_some_end),
	TEST_ENTRY(reverse_all)
#endif
};

int empty_test()
{
	TREEDB_NS(runtime_t) han = TREEDB_STORAGE_RUNTIME_INIT;
	int res = TREEDB_NS(heap_open)
		(& han
		, UUID_treedb_multi_varray_string_schema
		, test_file
		, eHeapOpenRead | eHeapOpenWrite
		, eHeapAccessRead | eHeapAccessWrite | eHeapAccessShared
		, 0
		);
	if(res) {
		printf("empty_test: TREEDB_NS(heap_open)() failed: %d.\n", res);
		return 1;
	}
	runtime = &han;
	TREEDB_NS(heap_unlock)(runtime);
	TREEDB_NS(heap_write_lock)(runtime);

	if(!TREEDB_PAYLOAD_NS(remove)(runtime, PACKED_STRING_MVARRAY, ITEM_COUNT)) {
		printf("empty_test: remove(%lu) XPASS.\n", ITEM_COUNT);
		return 2;
	}
	printf("Testing %s\n", tests[test_num].name);
	res = tests[test_num].fn();
	if(res) {
		printf("Test \"%s\" failed(%d).\n", tests[test_num].name, res);
		dump();
		return 3;
	}
	dump();
	TREEDB_PAYLOAD_NS(clear)(runtime, PACKED_STRING_MVARRAY);

	TREEDB_NS(heap_unlock)(runtime);
	TREEDB_NS(heap_read_lock)(runtime);

	TREEDB_NSA(node_ptr_t) pFirstNode = 0;
	res = TREEDB_NSF(search_closest)
		(runtime, TREEDB_ALLOC_free_tree, 0, & pFirstNode);
	if(free_size != pFirstNode->m_uLength) {
		printf("Free size(%lu) != %lu.\n", (size_t)free_size
			, (size_t)pFirstNode->m_uLength);
		return 4;
	}
	TREEDB_NS(heap_unlock)(runtime);
	TREEDB_NS(heap_close)(&han);
	return 0;
}

int test()
{
	int res = fill_test();
	if(res) {
		printf("fill test failed.\n");
		return res;
	}
	res = empty_test();
	if(res) {
		return res;
	}
	return 0;
}
int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;

	int res;
	for(test_num = 0; test_num < (int)(sizeof(tests)/sizeof(tests[0]));
			++test_num) {
		res = test();
		unlink(test_file);
		if(res)
			break;
	}
	return res;
}
#endif /* #if TREEDB_NBITS==-1 */
