/* Copyright (C) 2011  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef treedb_malloc_h_included
#define treedb_malloc_h_included

#include <treedb/treedb.h>

#define KIBIBYTE ((size_t)1024)
#define MEBIBYTE (KIBIBYTE * KIBIBYTE)
#define GIBIBYTE (KIBIBYTE * MEBIBYTE)

#if TREEDB_NBITS >= 64
  // 256GiB for 64 bits - a mmap onto a sparse file.
  #define OVERLAY_PAGES_SIZE ((size_t)256 * GIBIBYTE)
#else
  // 1GiB for 32 bits - a mmap onto a sparse file.
  #define OVERLAY_PAGES_SIZE GIBIBYTE
#endif

// Use 1 bit for each page.
#define OVERLAY_BITMAP_SIZE (OVERLAY_PAGES_SIZE / (TREEDB_PAGE_SIZE * 8UL))

/* We use exit(127) - process not found as it's the only generic failure return
value available that doesn't have a program-specific meaning. */

/* A problem we can't handle is if the program or some library installs their
own atfork handlers that allocate or free memory.
*/

#endif /* #ifndef treedb_malloc_h_included */
