/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include "treedb-malloc.h"
#include <stdio.h>

int main(int argc, char *argv[])
{
	(void)argc;
	(void)argv;
	treedb_allocator_runtime h = create_treedb_allocator(0);
	if(!h)
		return 1;

	void * p1 = treedb_allocator_malloc(h, 32);
	if(!p1) {
		free_treedb_allocator(h);
		return 2;
	}
	printf("Got 32 bytes : %p.\n", p1);
	if(!treedb_allocator_free(h, (void *)32)) {
		free_treedb_allocator(h);
		return 3;
	}
	void * p2 = treedb_allocator_malloc(h, 4096);
	if(!p2) {
		free_treedb_allocator(h);
		return 4;
	}
	printf("Got 4096 bytes : %p.\n", p2);
	void * p3 = treedb_allocator_malloc(h, 128 * 1024);
	if(!p3) {
		free_treedb_allocator(h);
		return 5;
	}
	printf("Got %u bytes : %p.\n", 128 * 1024, p3);
	if(treedb_allocator_free(h, p1)) {
		free_treedb_allocator(h);
		return 6;
	}
	if(treedb_allocator_free(h, p2)) {
		free_treedb_allocator(h);
		return 7;
	}
	if(treedb_allocator_free(h, p3)) {
		free_treedb_allocator(h);
		return 8;
	}
	int res = free_treedb_allocator(h);
	return res;
}
