/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_malloc_impl_h_included
#define v3c_treedb_malloc_impl_h_included

/* THIS IS NOT A DISK BASED IMPLEMENTATION */

#define TREEDB_NO_TYPES

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* Allocator16                                                                */
/******************************************************************************/
#define TREEDB_NBITS 16
#ifdef DOXYGEN_processing
{
#endif

#include <treedb/avl-cleardefs.h>

#ifdef DOXYGEN_processing
}
#endif

#define TREEDB_NS(x) A16(x)
#define TREEDB_NBITS 16

#ifdef DOXYGEN_processing
{
#endif

#define AVL_ALLOCATOR_prefix
#include <treedb/storage.h>

#ifdef DOXYGEN_processing
}
#endif

A16(runtime_t) A16(runtime_init) = TREEDB_STORAGE_RUNTIME_INIT;

#define TREEDB_OMIT_treedb_init
#define TREEDB_OMIT_treedb_init_header
#define AVL_ALLOCATOR_prefix
#include <treedb/treedb-impl.h>
#undef TREEDB_NS
#undef TREEDB_NBITS

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/avl-cleardefs.h>

#ifdef DOXYGEN_processing
}
#endif

/******************************************************************************/
/* Allocator32                                                                */
/******************************************************************************/
#define TREEDB_NS(x) A32(x)
#define TREEDB_NBITS 32
#include <treedb/storage.h>
A32(runtime_t) A32(runtime_init) = TREEDB_STORAGE_RUNTIME_INIT;

#ifdef DOXYGEN_processing
{
#endif

#define AVL_ALLOCATOR_prefix
#include <treedb/treedb-impl.h>

#ifdef DOXYGEN_processing
{
#endif

#undef TREEDB_NS
#undef TREEDB_NBITS
#undef TREEDB_STORAGE_RUNTIME_INIT
#undef TREEDB_STORAGE_RUNTIME_CONDITION_INIT
#undef TREEDB_STORAGE_RUNTIME_OFFSET_INIT
#undef TREEDB_STORAGE_RUNTIME_FILELOCK_INIT

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/avl-cleardefs.h>

#ifdef DOXYGEN_processing
}
#endif

/******************************************************************************/
/* Large Allocation                                                           */
/******************************************************************************/
LG(runtime_t) LG(runtime_init) = { PTHREAD_MUTEX_INITIALIZER, {0} };
/******************************************************************************/
/* HEAP - treedb heap                                                         */
/******************************************************************************/
#define TREEDB_NBITS ptr
treedb_malloc_allocator_runtime_t treedb_malloc_allocator_runtime_init =
{ PTHREAD_MUTEX_INITIALIZER
, LIST_TMPL_init
, LIST_TMPL_init
, AVL_TMPL_init
, /* free_emptied_heaps =*/ 0
, /* small_allocation_threshold = */ 4096
, /* medium_allocation_threshold = */ 128 * 1024
, /* small_allocation_heap_size = */ 64 * 1024
, /* medium_allocation_heap_size = */ 4UL * 1024UL * 1024UL
};

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/avl-cleardefs.h>

#ifdef DOXYGEN_processing
}
#endif

#define TREEDB_NS(x) HEAP(x)
#define AVL_TMPL_NS(x) HEAP(x)
//#define treedb_malloc_tree_count_t uint32_t
#define treedb_malloc_heap_runtime_ptr_t treedb_malloc_heap_tree_ptr_t
#define AVL_TMPL_key_t const char *

#define AVL_TMPL_packed_node_ptr_t treedb_malloc_avl_tree_packed_node_ptr_t
#define AVL_TMPL_packed_tree_ptr_t treedb_malloc_avl_tree_packed_tree_ptr_t

#define TREEDB_OMIT_typedef_runtime_t
#define AVL_TMPL_omit_insert
#define AVL_TMPL_omit_remove
#define AVL_TMPL_unpack_pointer(u) ((void *)(u))
#define AVL_TMPL_pack_pointer(pv) ((uintptr_t)(pv))
#define AVL_TMPL_unpack_key(a) \
	treedb_malloc_get_base((malloc_heap_node_ptr_t)a)
#define AVL_TMPL_omit_clear
#define AVL_TMPL_omit_delete_node
#define AVL_TMPL_omit_impl_alloc_node
#define AVL_TMPL_omit_impl_unpack_item
#define AVL_TMPL_omit_impl_pack_item
#define AVL_TMPL_omit_impl_unpack_key
#define AVL_TMPL_omit_impl_pack_key
#define AVL_TMPL_cmp(a, b) ((a) < (b) ? -1 : (a) == (b) ? 0 : 1)
#define AVL_TMPL_next m_heap_next
#define AVL_TMPL_prev m_heap_prev
#define AVL_TMPL_parent m_heap_parent
#define AVL_TMPL_left m_heap_left
#define AVL_TMPL_right m_heap_right

#define AVL_TMPL_omit_impl_alloc_node
#define AVL_TMPL_omit_impl_free_node
#define AVL_TMPL_omit_impl_pack_unpack_node
#define AVL_TMPL_omit_impl_pack_unpack_item

#ifdef DOXYGEN_processing
{
#endif

#define AVL_TMPL_prefix extern
#include <treedb/avl-template-impl.h>
#include <treedb/avl-cleardefs.h>

#ifdef DOXYGEN_processing
}
#endif

#undef TREEDB_NS

/******************************************************************************/
/* LIST                                                                       */
/******************************************************************************/
#define TREEDB_NS(x) L2(Treedb##x)
#define TREEDB_NBITS ptr
#define LIST_NS(x) L2(x)
#define LIST_MEMBER m_list

//#define LIST_count_t uint32_t
#define treedb_malloc_list_runtime_t treedb_malloc_list_list_t
#define treedb_malloc_list_Treedbruntime_ptr_t treedb_malloc_list_list_ptr_t
#define treedb_malloc_list_data_t malloc_heap_node_ptr_t
#define treedb_malloc_list_packed_data_t malloc_heap_node_ptr_t

#define LIST_TMPL_alloc_node(i) LIST_NS(impl_alloc_node)(runtime, i)

#undef LIST_TMPL_omit_node_t
/* Called by pop front/back.
The treedb_allocator_runtime is needed so this is a no-op. */
#define LIST_TMPL_free_node(x)
#define LIST_TMPL_omit_impl_free_node
#define LIST_TMPL_omit_delete_node
#define LIST_TMPL_omit_push
#define LIST_TMPL_omit_pop

#define LIST_TMPL_packed_list_ptr_t L2(packed_list_ptr_t)
#define LIST_TMPL_packed_node_ptr_t L2(packed_node_ptr_t)

#define LIST_TMPL_unpack_pointer(u) ((void *)(u))
#define LIST_TMPL_pack_pointer(pv) ((uintptr_t)(pv))
#define LIST_NO_TYPES
#define LIST_omit_runtime_t_typedef
#define LIST_prefix
#define LIST_omit_impl_alloc_node
#define LIST_omit_impl_free_node
#define LIST_omit_impl_free_list
#define LIST_omit_treedb_impl
#ifdef DOXYGEN_processing
{
#endif

#include <treedb/list.h>

#ifdef DOXYGEN_processing
}
#endif

#undef TREEDB_NS
#undef TREEDB_NBITS

/******************************************************************************/
/* treedb_malloc_allocator                                                    */
/******************************************************************************/

#ifdef __cplusplus
} // extern "C" {
#endif

#endif /* #ifndef v3c_treedb_malloc_impl_h_included */
