/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_malloc_h_included
#define v3c_treedb_malloc_h_included

#include <stdlib.h>
#include <stdint.h>
#include <treedb/treedb.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef void * treedb_allocator_runtime;

extern treedb_allocator_runtime create_treedb_allocator(int free_emptied);
extern TreedbFreeResult free_treedb_allocator(treedb_allocator_runtime h);

extern void * treedb_allocator_malloc(treedb_allocator_runtime h, size_t size);
extern void * treedb_allocator_calloc(treedb_allocator_runtime h, size_t count, size_t size);
extern void * treedb_allocator_realloc(treedb_allocator_runtime h, void * p, size_t size);
extern char * treedb_allocator_strdup(treedb_allocator_runtime h, const char * p);
extern uint16_t * treedb_allocator_wcsdup(treedb_allocator_runtime h, const uint16_t * p);
extern TreedbFreeResult treedb_allocator_free(treedb_allocator_runtime h, void * p);

#ifdef __cplusplus
} // extern "C" {
#endif

#endif /* #ifndef v3c_treedb_malloc_h_included */
