/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

/* This file is designed to be included more than once
- hence no header guard. */

#ifndef ARRAY_TMPL_NS
  #define ARRAY_TMPL_NS(x) ARRAY_NS(x)
#endif
#ifdef ARRAY_prefix
  #define ARRAY_TMPL_prefix ARRAY_prefix
#else
  #define ARRAY_TMPL_prefix static inline
#endif

#ifdef ARRAY_size_t
  #define ARRAY_TMPL_size_t ARRAY_size_t
#else
  #define ARRAY_TMPL_size_t ARRAY_TMPL_NS(size_t)
#endif

#ifdef ARRAY_count_t
  #define ARRAY_TMPL_count_t ARRAY_count_t
#else
  #define ARRAY_TMPL_count_t ARRAY_TMPL_size_t
#endif

#ifdef ARRAY_packed_array_ptr_t
  #define ARRAY_TMPL_packed_array_ptr_t ARRAY_packed_array_ptr_t
#else
  #define ARRAY_TMPL_packed_array_ptr_t ARRAY_TMPL_count_t
#endif

#ifdef ARRAY_input_t
  #define ARRAY_TMPL_input_t ARRAY_input_t
#else
  #define ARRAY_TMPL_input_t int32_t
#endif

#ifdef ARRAY_data_t
  #define ARRAY_TMPL_data_t ARRAY_data_t
#else
  #define ARRAY_TMPL_data_t ARRAY_TMPL_input_t
#endif

#define ARRAY_unpack_array(h) \
  (ARRAY_TMPL_NS(array_ptr_t))(ARRAY_TMPL_unpack_pointer(h))

#define ARRAY_unpack_data(h) \
  (ARRAY_TMPL_data_t *)(ARRAY_TMPL_unpack_pointer(h))

#ifndef ARRAY_TMPL_alloc
  #define ARRAY_TMPL_alloc(count) ARRAY_NS(impl_alloc)(runtime, count)
#endif
#ifndef ARRAY_TMPL_free
  #define ARRAY_TMPL_free(pv) ARRAY_NS(impl_free)(runtime, pv)
#endif
#ifndef ARRAY_TMPL_realloc_packed
  #define ARRAY_TMPL_realloc_packed(ha, count) \
    ARRAY_NS(impl_realloc_packed)(runtime, ha, count)
#endif
#ifndef ARRAY_TMPL_unpack_pointer
  #define ARRAY_TMPL_unpack_pointer(p) \
    TREEDB_NS(impl_unpack_pointer)(runtime, p)
#endif
#ifndef ARRAY_TMPL_pack_pointer
  #define ARRAY_TMPL_pack_pointer(p) \
    TREEDB_NS(impl_pack_pointer)(runtime, p)
#endif

#ifndef ARRAY_TMPL_runtime_ptr_t
  #define ARRAY_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)
#endif

#define ARRAY_TMPL_omit_unpack_array
#define ARRAY_TMPL_omit_unpack_array_DECLARE
#define ARRAY_TMPL_unpack_array(ha) \
  ((ARRAY_TMPL_array_ptr_t)TREEDB_unpack_pointer(ha))

#define ARRAY_TMPL_omit_pack_array
#define ARRAY_TMPL_omit_pack_array_DECLARE
#define ARRAY_TMPL_pack_array(p) \
  TREEDB_pack_pointer(p)

#ifndef ARRAY_clear_entries
  #define ARRAY_clear_entries(ha, begin, size) 0
#endif
#ifndef ARRAY_TMPL_clear_entries
  #define ARRAY_TMPL_clear_entries(ha, begin, size) \
    ARRAY_clear_entries(ha, begin, size)
#endif

#include <treedb/array-template-defines.h>
