/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_h_included
  #error Include "treedb.h" before this file.
#endif

/* 4. must-defines */
#ifndef ARRAY_TMPL_NS
  #error ARRAY_TMPL_NS is not defined. e.g. #define ARRAY_TMPL_NS(x) v3c_##x.
#endif

/* 5. types */
#ifndef ARRAY_TMPL_runtime_ptr_t
  #define ARRAY_TMPL_runtime_ptr_t ARRAY_TMPL_NS(runtime_ptr_t)
#endif
#ifndef ARRAY_TMPL_size_t
  #define ARRAY_TMPL_size_t uintptr_t
#endif
#ifndef ARRAY_TMPL_count_t
  #define ARRAY_TMPL_count_t TREEDB_NS_CONCAT(uint,_t)
#endif
#ifndef ARRAY_TMPL_array_ptr_t
  #define ARRAY_TMPL_array_ptr_t ARRAY_TMPL_NS(array_ptr_t)
#endif
#ifndef ARRAY_TMPL_packed_array_ptr_t
  #define ARRAY_TMPL_packed_array_ptr_t ARRAY_TMPL_count_t
#endif
#ifndef ARRAY_TMPL_data_t
  #define ARRAY_TMPL_data_t ARRAY_TMPL_NS(data_t)
#endif
#ifndef ARRAY_TMPL_packed_data_ptr_t
  #define ARRAY_TMPL_packed_data_ptr_t ARRAY_TMPL_count_t
#endif
#ifndef ARRAY_TMPL_packed_ptr_t
  #define ARRAY_TMPL_packed_ptr_t ARRAY_TMPL_count_t
#endif
#ifndef ARRAY_TMPL_input_t
  #define ARRAY_TMPL_input_t ARRAY_TMPL_NS(input_t)
#endif

/* 6. optional */
#ifndef ARRAY_TMPL_prefix
  #define ARRAY_TMPL_prefix extern
#endif

/* 7. header - constants */
#ifndef ARRAY_TMPL_init_DEFAULT
  #define ARRAY_TMPL_init_DEFAULT { 0,0,1,0 }
#endif
#ifndef ARRAY_TMPL_init
  #define ARRAY_TMPL_init ARRAY_TMPL_init_DEFAULT
#endif

/* 8. array_t members */
#ifndef ARRAY_TMPL_count
  #define ARRAY_TMPL_count m_count
#endif
#ifndef ARRAY_TMPL_reserve
  #define ARRAY_TMPL_reserve m_reserve
#endif
#ifndef ARRAY_TMPL_increment
  #define ARRAY_TMPL_increment m_increment
#endif
#ifndef ARRAY_TMPL_items
  #define ARRAY_TMPL_items m_items
#endif

#ifndef ARRAY_TMPL_omit_template_impl_defines

  /* 8. must-defines
  */
  #ifndef ARRAY_TMPL_free
    #error ARRAY_TMPL_free is not defined.
  #endif
  #ifndef ARRAY_TMPL_alloc
    #error ARRAY_TMPL_alloc is not defined.
  #endif
  #ifndef ARRAY_TMPL_realloc_packed
    #error ARRAY_TMPL_realloc_packed is not defined.
  #endif
  #ifndef ARRAY_TMPL_unpack_pointer
    #error ARRAY_TMPL_unpack_pointer is not defined.
  #endif
  #ifndef ARRAY_TMPL_pack_pointer
    #error ARRAY_TMPL_pack_pointer is not defined.
  #endif

/* 9. optional
*/
  #ifndef ARRAY_TMPL_alloc_array
    #define ARRAY_TMPL_alloc_array \
      ((ARRAY_TMPL_array_ptr_t)ARRAY_TMPL_alloc(sizeof(ARRAY_TMPL_NS(array_t))))
  #endif
  #ifndef ARRAY_TMPL_auto_data
    #define ARRAY_TMPL_auto_data(x) ARRAY_TMPL_data_t x
  #endif
  #ifndef ARRAY_TMPL_clear_entries
    #define ARRAY_TMPL_clear_entries(ha, begin, count) \
      ARRAY_TMPL_NS(clear_entries)(runtime, ha, begin, count)
  #endif
  #ifndef ARRAY_TMPL_memmove
    #define ARRAY_TMPL_memmove(to, from, size) memmove(to, from, size)
  #endif
  #ifndef ARRAY_TMPL_assign
    #define ARRAY_TMPL_assign(to, from) to = from
  #endif
  #ifndef ARRAY_TMPL_assign_to_auto
    #define ARRAY_TMPL_assign_to_auto(to, from) ARRAY_TMPL_assign(to, from)
  #endif
  #ifndef ARRAY_TMPL_assign_from_auto
    #define ARRAY_TMPL_assign_from_auto(to, from) ARRAY_TMPL_assign(to, from)
  #endif
  #ifndef ARRAY_TMPL_item
    #define ARRAY_TMPL_item(pa, n) \
      (ARRAY_TMPL_unpack_data(ARRAY_TMPL_items_MEMBER(pa))[n])
  #endif
  #ifndef ARRAY_TMPL_item_ptr
    #define ARRAY_TMPL_item_ptr(pa, n) (& ARRAY_TMPL_item(pa, n))
  #endif
  #ifndef ARRAY_TMPL_exceeds_count_limit
    #ifdef TREEDB_need_exceed_check
      #define ARRAY_TMPL_exceeds_count_limit(x) \
        ((x) > ((ARRAY_TMPL_size_t)((ARRAY_TMPL_count_t)-1)))
    #else
      #define ARRAY_TMPL_exceeds_count_limit(x) 0
    #endif
  #endif

  #ifndef ARRAY_TMPL_entry_size
    #define ARRAY_TMPL_entry_size sizeof(ARRAY_TMPL_data_t)
  #endif
  #ifndef ARRAY_TMPL_entry_align
    #define ARRAY_TMPL_entry_align __alignof(ARRAY_TMPL_data_t)
  #endif
  #ifndef ARRAY_TMPL_memcopy
    #define ARRAY_TMPL_memcopy(to, from, size) memcpy(to, from, size)
  #endif

  #ifndef ARRAY_TMPL_count_MEMBER
    #define ARRAY_TMPL_count_MEMBER(x) (x)->ARRAY_TMPL_count
  #endif
  #ifndef ARRAY_TMPL_reserve_MEMBER
    #define ARRAY_TMPL_reserve_MEMBER(x) (x)->ARRAY_TMPL_reserve
  #endif
  #ifndef ARRAY_TMPL_increment_MEMBER
    #define ARRAY_TMPL_increment_MEMBER(x) (x)->ARRAY_TMPL_increment
  #endif
  #ifndef ARRAY_TMPL_items_MEMBER
    #define ARRAY_TMPL_items_MEMBER(x) (x)->ARRAY_TMPL_items
  #endif

  #ifndef ARRAY_TMPL_count_MEMBER_SET
    #define ARRAY_TMPL_count_MEMBER_SET(x,v) ARRAY_TMPL_count_MEMBER(x) = (v)
  #endif
  #ifndef ARRAY_TMPL_count_MEMBER_INCREMENT
    #define ARRAY_TMPL_count_MEMBER_INCREMENT(x) ++ARRAY_TMPL_count_MEMBER(x)
  #endif
  #ifndef ARRAY_TMPL_count_MEMBER_DECREMENT
    #define ARRAY_TMPL_count_MEMBER_DECREMENT(x) --ARRAY_TMPL_count_MEMBER(x)
  #endif
  #ifndef ARRAY_TMPL_count_MEMBER_ADD
    #define ARRAY_TMPL_count_MEMBER_ADD(x,v) ARRAY_TMPL_count_MEMBER(x) += (v)
  #endif
  #ifndef ARRAY_TMPL_count_MEMBER_SUBTRACT
    #define ARRAY_TMPL_count_MEMBER_SUBTRACT(x,v) \
      ARRAY_TMPL_count_MEMBER(x) -= (v)
  #endif
  #ifndef ARRAY_TMPL_reserve_MEMBER_SET
    #define ARRAY_TMPL_reserve_MEMBER_SET(x,v) \
      ARRAY_TMPL_reserve_MEMBER(x) = (v)
  #endif
  #ifndef ARRAY_TMPL_increment_MEMBER_SET
    #define ARRAY_TMPL_increment_MEMBER_SET(x,v) \
      ARRAY_TMPL_increment_MEMBER(x) = (v)
  #endif
  #ifndef ARRAY_TMPL_items_MEMBER_SET
    #define ARRAY_TMPL_items_MEMBER_SET(x,v) ARRAY_TMPL_items_MEMBER(x) = (v)
  #endif

#endif /* #ifndef ARRAY_TMPL_omit_template_impl_defines */
