/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/array-template-defines.h>
#undef ARRAY_TMPL_omit_template_impl_defines

#ifdef DOXYGEN_processing
}
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ARRAY_TMPL_omit_array_t
  #ifndef ARRAY_TMPL_omit_array_t_typedefs
typedef struct ARRAY_TMPL_NS(array_t) ARRAY_TMPL_NS(array_t)
  , * ARRAY_TMPL_NS(array_ptr_t);
  #endif
struct ARRAY_TMPL_NS(array_t) {
  ARRAY_TMPL_count_t ARRAY_TMPL_count, ARRAY_TMPL_reserve, ARRAY_TMPL_increment;
  ARRAY_TMPL_packed_data_ptr_t ARRAY_TMPL_items;
};
#endif

#ifndef ARRAY_TMPL_omit_unpack_array_DECLARE
ARRAY_TMPL_prefix ARRAY_TMPL_array_ptr_t
ARRAY_TMPL_NS(unpack_array)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t p
);
#else
  #define ARRAY_TMPL_omit_unpack_array
#endif
#ifndef ARRAY_TMPL_omit_pack_array_DECLARE
ARRAY_TMPL_prefix ARRAY_TMPL_packed_array_ptr_t
ARRAY_TMPL_NS(pack_array)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_array_ptr_t p
);
#else
  #define ARRAY_TMPL_omit_pack_array
#endif

#ifndef ARRAY_TMPL_omit_unpack_data_DECLARE
ARRAY_TMPL_prefix ARRAY_TMPL_data_t *
ARRAY_TMPL_NS(unpack_data)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_data_ptr_t p
);
#else
  #define ARRAY_TMPL_omit_unpack_data
#endif
#ifndef ARRAY_TMPL_omit_pack_data_DECLARE
ARRAY_TMPL_prefix ARRAY_TMPL_packed_data_ptr_t
ARRAY_TMPL_NS(pack_data)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_data_t * p
);
#else
  #define ARRAY_TMPL_omit_pack_data
#endif

ARRAY_TMPL_prefix int ARRAY_TMPL_NS(init)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t reserve
, ARRAY_TMPL_size_t increment
);
#ifndef ARRAY_TMPL_omit_init_empty_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(init_empty)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t increment
);
#else
  #define ARRAY_TMPL_omit_init_empty
#endif
#ifndef ARRAY_TMPL_omit_init_empty_ptr_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(init_empty_ptr)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_array_ptr_t pa
, ARRAY_TMPL_size_t increment
);
#else
  #define ARRAY_TMPL_omit_init_empty_ptr
#endif
#ifndef ARRAY_TMPL_omit_new_DECLARE
ARRAY_TMPL_prefix ARRAY_TMPL_packed_array_ptr_t ARRAY_TMPL_NS(new)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_size_t reserve
, ARRAY_TMPL_size_t increment
);
#else
  #define ARRAY_TMPL_omit_new
#endif
#ifndef ARRAY_TMPL_omit_free_DECLARE
ARRAY_TMPL_prefix void ARRAY_TMPL_NS(free)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
);
#else
  #define ARRAY_TMPL_omit_free
#endif

ARRAY_TMPL_prefix void ARRAY_TMPL_NS(clear)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
);
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(clone)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha_to
, ARRAY_TMPL_packed_array_ptr_t ha_from
);
#ifndef ARRAY_TMPL_omit_insert_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(insert)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t where
, ARRAY_TMPL_input_t d
);
#else
  #define ARRAY_TMPL_omit_insert
#endif
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(insert_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t where
, ARRAY_TMPL_size_t count
);
#ifndef ARRAY_TMPL_omit_remove_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(remove)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t where
);
#else
  #define ARRAY_TMPL_omit_remove
#endif
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(remove_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t where
, ARRAY_TMPL_size_t count
);
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(copy_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha_to
, ARRAY_TMPL_size_t to_where
, ARRAY_TMPL_size_t to_count
, ARRAY_TMPL_packed_array_ptr_t ha_from
, ARRAY_TMPL_size_t from_where
, ARRAY_TMPL_size_t from_count
);
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(move_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha_to
, ARRAY_TMPL_size_t to_where
, ARRAY_TMPL_size_t to_count
, ARRAY_TMPL_packed_array_ptr_t ha_from
, ARRAY_TMPL_size_t from_where
, ARRAY_TMPL_size_t from_count
);
#ifndef ARRAY_TMPL_omit_push_back_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(push_back)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_input_t d
);
#else
  #define ARRAY_TMPL_omit_push_back
#endif
#ifndef ARRAY_TMPL_omit_push_back_many_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(push_back_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t count
);
#else
  #define ARRAY_TMPL_omit_push_back_many
#endif
#ifndef ARRAY_TMPL_omit_push_front_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(push_front)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_input_t d
);
#else
  #define ARRAY_TMPL_omit_push_front
#endif
#ifndef ARRAY_TMPL_omit_push_front_many_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(push_front_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t count
);
#else
  #define ARRAY_TMPL_omit_push_front_many
#endif
#ifndef ARRAY_TMPL_omit_pop_back_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(pop_back)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
);
#else
  #define ARRAY_TMPL_omit_pop_back
#endif
#ifndef ARRAY_TMPL_omit_pop_back_many_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(pop_back_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t count
);
#else
  #define ARRAY_TMPL_omit_pop_back_many
#endif
#ifndef ARRAY_TMPL_omit_pop_front_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(pop_front)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
);
#else
  #define ARRAY_TMPL_omit_pop_front
#endif
#ifndef ARRAY_TMPL_omit_pop_front_many_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(pop_front_many)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_size_t count
);
#else
  #define ARRAY_TMPL_omit_pop_front_many
#endif
#ifndef ARRAY_TMPL_omit_reverse_some_DECLARE
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(reverse_some)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_array_ptr_t pa
, ARRAY_TMPL_size_t where
, ARRAY_TMPL_size_t count
);
#else
  #define ARRAY_TMPL_omit_reverse_some
#endif
#ifndef ARRAY_TMPL_omit_reverse_DECLARE
ARRAY_TMPL_prefix void ARRAY_TMPL_NS(reverse)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_array_ptr_t pa
);
#else
  #define ARRAY_TMPL_omit_reverse
#endif

#ifdef __cplusplus
} /* extern "C" { */
#endif
