/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/offset.hpp>

#ifndef ARRAY_NS
  #define ARRAY_NS(x) TREEDB_NS(IntArray_##x)
#endif

#ifndef ARRAY_NS_unpack
  #define ARRAY_NS_unpack(x) TREEDB_NS(unpack)(runtime, x)
#endif

#ifndef MAKE_ARRAY
  #define MAKE_ARRAY(x) (& runtime->m_pTreedb->x)
#endif

#ifndef ARRAY_size_t
  #define ARRAY_size_t uintptr_t
#endif

#ifndef ARRAY_NO_TYPES

  #ifndef ARRAY_omit_treedb_impl

    #ifndef ARRAY_MEMBER
      #define ARRAY_MEMBER m_int_array
    #endif
    #ifndef ARRAY
      #define ARRAY (& runtime->m_pTreedb->ARRAY_MEMBER)
    #endif
    #ifndef PACKED_ARRAY
      #define PACKED_ARRAY v3c_offsetof(TREEDB_NS(treedb_t), ARRAY_MEMBER)
    #endif

    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) ARRAY_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER ARRAY_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(array_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef ARRAY_omit_treedb_impl */

  #include <treedb/array-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) ARRAY_NS(runtime_t);
  #define ARRAY_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/array-template.h>
  #include <treedb/array-template-cleardefs.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef ARRAY_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef AVL_NO_TYPES */

#ifndef ARRAY_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/array-defines.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifndef ARRAY_omit_impl_alloc
ARRAY_TMPL_prefix PVOID ARRAY_TMPL_NS(impl_alloc)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_count_t size
) {
	return TREEDB_malloc(size);
}
  #endif

  #ifndef ARRAY_omit_impl_realloc_packed
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(impl_realloc_packed)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, ARRAY_TMPL_count_t count
) {
	ARRAY_TMPL_count_t size = count * ARRAY_TMPL_entry_size;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_unpack_array(ha);
	ARRAY_TMPL_data_t * pd
		= (ARRAY_TMPL_data_t *)
          TREEDB_realloc(ARRAY_unpack_data(pa->ARRAY_TMPL_items), size);
	if(!pd)
		return 1;
	pa = ARRAY_TMPL_unpack_array(ha);
	pa->ARRAY_TMPL_items = ARRAY_TMPL_pack_pointer(pd);
	return 0;
}
  #endif

  #ifndef ARRAY_omit_impl_free
ARRAY_TMPL_prefix void ARRAY_TMPL_NS(impl_free)
( ARRAY_TMPL_runtime_ptr_t runtime
, PVOID p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/array-template-impl.h>
  #include <treedb/array-template-cleardefs.h>

  #ifndef ARRAY_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef ARRAY_NO_IMPL */

#ifndef ARRAY_NO_CLEARDEFS
  #include <treedb/array-cleardefs.h>
#else
  #undef ARRAY_NO_CLEARDEFS
#endif
