/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* AvlAllocator                                                               */
/* The "payload" of an allocator node is it's length, followed by that amount */
/* of memory.                                                                 */
/******************************************************************************/
#define AVL2_omit_alloc_node

/******************************************************************************/
/* The used tree is sorted by address (offset).                               */
/******************************************************************************/
#define AVL2_TMPL_omit_helper_alloc_node_DECLARE
#define AVL2_TMPL_omit_helper_free_node_DECLARE

#define AVL2_NS(x) TREEDB_NSU(x)
#define AVL2_TMPL_item m_uLength
#define AVL2_TMPL_omit_node_t
#define AVL2_TMPL_omit_tree_t
#define AVL2_TMPL_omit_impl_unpack_item
#define AVL2_TMPL_omit_impl_unpack_key

#define AVL2_TMPL_packed_node_ptr_t TREEDB_NSA(packed_node_ptr_t)
#define AVL2_TMPL_packed_tree_ptr_t TREEDB_NSA(packed_tree_ptr_t)

#define AVL2_TMPL_node_ptr_t TREEDB_NSA(node_ptr_t)
#define AVL2_TMPL_tree_ptr_t TREEDB_NSU(tree_ptr_t)

#define AVL2_key_t TREEDB_NSA(count_t)

/* Given a node pointer, return the packed node value */
#define AVL2_unpack_key(pNode) TREEDB_pack_pointer(pNode)

#undef AVL2_TMPL_omit_node_t
#undef AVL2_TMPL_omit_tree_t

#define TREEDB_MULTIPLE_PAYLOAD_ENTRIES
#define TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
#define AVL2_NO_TYPES
#define AVL2_omit_treedb_storage
#define AVL2_omit_treedb_impl

#ifdef AVL_ALLOCATOR_prefix
  #define AVL2_prefix AVL_ALLOCATOR_prefix
#endif

#include <treedb/avl2.h>

/******************************************************************************/
/* The free tree is sorted by size.                                           */
/******************************************************************************/
#define AVL2_TMPL_omit_delete_node
#define AVL2_TMPL_omit_insert

#define AVL2_TMPL_omit_helper_alloc_node_DECLARE
#define AVL2_TMPL_omit_helper_free_node_DECLARE

#define AVL2_NS(x) TREEDB_NSF(x)
#define AVL2_TMPL_item m_uLength
#define AVL2_TMPL_omit_node_t
#define AVL2_TMPL_omit_tree_t

#define AVL2_TMPL_packed_node_ptr_t TREEDB_NSA(packed_node_ptr_t)
#define AVL2_TMPL_packed_tree_ptr_t TREEDB_NSA(packed_tree_ptr_t)

#define AVL2_TMPL_node_ptr_t TREEDB_NSA(node_ptr_t)
#define AVL2_TMPL_tree_ptr_t TREEDB_NSF(tree_ptr_t)

#define AVL2_key_t TREEDB_NSA(count_t)

/* Given a node pointer, return the length */
#define AVL2_unpack_key(pNode) (pNode)->m_uLength

#define AVL2_TMPL_allow_duplicates 1

#undef AVL2_TMPL_omit_node_t
#undef AVL2_TMPL_omit_tree_t
#define AVL2_NO_TYPES
#define AVL2_omit_treedb_storage
#define AVL2_omit_treedb_impl

#ifdef AVL_ALLOCATOR_prefix
  #define AVL2_prefix AVL_ALLOCATOR_prefix
#endif

#include <treedb/avl2.h>

#undef AVL2_TMPL_omit_node_t

#undef AVL2_TMPL_omit_delete_node
#undef AVL2_TMPL_omit_impl_alloc_node
#undef AVL2_TMPL_omit_impl_free_node

#undef DEFINE_AVL2_NODE
#undef TREEDB_OMIT_AVL2_PACK_UNPACK_NODE

#undef AVL2_TMPL_omit_insert
#undef AVL2_TMPL_omit_remove
#undef AVL2_TMPL_omit_clear

#undef AVL2_TMPL_omit_helper_alloc_node_DECLARE
#undef AVL2_TMPL_omit_helper_free_node_DECLARE
#undef AVL2_TMPL_omit_node_t
#undef AVL2_TMPL_omit_tree_t
#undef Allocator_packed_nodeptr_t
#undef TREEDB_OMIT_Allocator_allocator_t_declare

#undef AVL_ALLOCATOR_prefix

#ifdef __cplusplus
} // extern "C" {
#endif
