/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/string_utils.h> /* for v3c_strcpy */

/* AVL - define macros we use. */

#ifndef STRING_KEY_TREE_NS
  #define STRING_KEY_TREE_NS(x) TREEDB_NS(AvlStringKeyTree_##x)
#endif
#ifndef STRING_KEY_TREE_MEMBER
  #define STRING_KEY_TREE_MEMBER m_string_key_tree
#endif
#ifndef STRING_KEY_TREE
  #define STRING_KEY_TREE MAKE_AVL_TREE(STRING_KEY_TREE_MEMBER)
#endif
#ifndef PACKED_STRING_KEY_TREE
  #define PACKED_STRING_KEY_TREE \
	MAKE_PACKED_AVL_TREE(STRING_KEY_TREE_NS, STRING_KEY_TREE_MEMBER)
#endif

#ifndef STRING_KEY_TREE_NS_unpack_tree
  #define STRING_KEY_TREE_NS_unpack_tree(x) \
    (STRING_KEY_TREE_NS(tree_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef STRING_KEY_TREE_NS_unpack_node
  #define STRING_KEY_TREE_NS_unpack_node(x) \
    (STRING_KEY_TREE_NS(node_ptr_t))TREEDB_unpack_pointer(x)
#endif

#ifndef STRING_KEY_TREE_KEY_TYPE
  #define STRING_KEY_TREE_KEY_TYPE char
#endif
#ifndef STRING_KEY_TREE_KEY_NAME
  #define STRING_KEY_TREE_KEY_NAME m_key
#endif
#ifndef STRING_KEY_TREE_KEY_SUFFIX
  #define STRING_KEY_TREE_KEY_SUFFIX []
#endif
#ifndef STRING_KEY_TREE_KEY_REF_TYPE
  #define STRING_KEY_TREE_KEY_REF_TYPE const char *
#endif
#ifndef STRING_KEY_TREE_VALUE_TYPE
  #define STRING_KEY_TREE_VALUE_TYPE int32_t
#endif
#ifndef STRING_KEY_TREE_VALUE_NAME
  #define STRING_KEY_TREE_VALUE_NAME m_value
#endif


#ifndef STRING_KEY_TREE_EXTRA_ALLOC_SIZE
  #define STRING_KEY_TREE_EXTRA_ALLOC_SIZE(d) \
    (strlen(d->STRING_KEY_TREE_KEY_NAME) + 1)
#endif
#ifndef STRING_KEY_TREE_KEY_CMP
  #define STRING_KEY_TREE_KEY_CMP(a, b) strcmp(a, b)
#endif
#ifndef STRING_KEY_TREE_KEY_ASSIGN
  #define STRING_KEY_TREE_KEY_ASSIGN(to, from) v3c_strcpy((to), from)
#endif
#ifndef STRING_KEY_TREE_VALUE_ASSIGN
  #define STRING_KEY_TREE_VALUE_ASSIGN(to, from) to = from
#endif

#ifndef STRING_KEY_TREE_KEY_IN_HEAP
  #define STRING_KEY_TREE_KEY_IN_HEAP(d) \
    TREEDB_in_heap(d->STRING_KEY_TREE_KEY_NAME)
#endif

#ifndef STRING_KEY_TREE_DATA_TO_INPUT
  #define STRING_KEY_TREE_DATA_TO_INPUT(pd) \
    { pd->STRING_KEY_TREE_KEY_NAME, pd->STRING_KEY_TREE_VALUE_NAME }
#endif

/* AVL- define macros avl.h uses - it will undefine them. */

#ifndef AVL_NS
  #define AVL_NS(x) STRING_KEY_TREE_NS(x)
#endif
#ifndef AVL_key_t
  #define AVL_key_t         STRING_KEY_TREE_KEY_REF_TYPE
#endif
#ifndef AVL_input_t
  #define AVL_input_t       STRING_KEY_TREE_NS(const_input_ptr)
#endif
#ifndef AVL_data_t
  #define AVL_data_t        STRING_KEY_TREE_NS(data)
#endif
#ifndef AVL_TREE_MEMBER
  #define AVL_TREE_MEMBER   STRING_KEY_TREE_MEMBER
#endif

#ifndef AVL_TMPL_clone_node
  #define AVL_TMPL_clone_node(pn) \
    STRING_KEY_TREE_NS(impl_clone_node)(runtime, & pn->AVL_TMPL_item)
#endif

#ifndef AVL_TMPL_alloc_node
  #define AVL_TMPL_alloc_node(d) STRING_KEY_TREE_NS(impl_alloc_node)(runtime, d)
#endif

#ifndef AVL_unpack_key
  #define AVL_unpack_key(pNode) (pNode)->m_item.STRING_KEY_TREE_KEY_NAME
#endif
#ifndef AVL_cmp
  #define AVL_cmp(a, b) STRING_KEY_TREE_KEY_CMP(a, b)
#endif

#include <treedb/avl-defines.h>
