/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/ns-types.h>

#ifndef STRING_KEY_TREE_NO_TYPES

  #include <treedb/avl-string-key-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef struct STRING_KEY_TREE_NS(data) {
	STRING_KEY_TREE_VALUE_TYPE STRING_KEY_TREE_VALUE_NAME;
	STRING_KEY_TREE_KEY_TYPE STRING_KEY_TREE_KEY_NAME STRING_KEY_TREE_KEY_SUFFIX;
} STRING_KEY_TREE_NS(data), * STRING_KEY_TREE_NS(data_ptr);
typedef const STRING_KEY_TREE_NS(data) * STRING_KEY_TREE_NS(const_data_ptr);

typedef struct STRING_KEY_TREE_NS(input) {
	STRING_KEY_TREE_KEY_REF_TYPE STRING_KEY_TREE_KEY_NAME;
	STRING_KEY_TREE_VALUE_TYPE STRING_KEY_TREE_VALUE_NAME;
} STRING_KEY_TREE_NS(input), * STRING_KEY_TREE_NS(input_ptr);
typedef const STRING_KEY_TREE_NS(input) * STRING_KEY_TREE_NS(const_input_ptr);

  #ifdef __cplusplus
} // extern "C"
  #endif

  #define AVL_omit_impl_alloc_node
  #define AVL_NO_IMPL
  #include <treedb/avl.h>
  #undef AVL_NO_IMPL

#endif /* #ifndef STRING_KEY_TREE_NO_TYPES */

#ifndef STRING_KEY_TREE_NO_IMPL

  #include <treedb/avl-string-key-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

  #define AVL_TMPL_omit_node_t_typedefs
typedef struct STRING_KEY_TREE_NS(node_t) STRING_KEY_TREE_NS(node_t)
, * STRING_KEY_TREE_NS(node_ptr_t);

/** AVL_TMPL_NS(impl_alloc_node)

We need to take extra steps in case we're called from clone() as we're passed
a reference to data in the heap.
*/
static inline STRING_KEY_TREE_NS(node_ptr_t) STRING_KEY_TREE_NS(impl_alloc_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_KEY_TREE_NS(const_input_ptr) d
);
static inline STRING_KEY_TREE_NS(node_ptr_t) STRING_KEY_TREE_NS(impl_clone_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_KEY_TREE_NS(const_data_ptr) pd
);

  #ifdef __cplusplus
} /* extern "C" { */
  #endif

  #define AVL_omit_impl_alloc_node
  #define AVL_NO_TYPES
  #include <treedb/avl.h>
  #undef AVL_NO_TYPES

  #include <treedb/avl-string-key-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

/**

We need to take extra steps in case we're called from clone() as we're passed
a reference to data in the heap.
*/
static inline STRING_KEY_TREE_NS(node_ptr_t) STRING_KEY_TREE_NS(impl_alloc_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_KEY_TREE_NS(const_input_ptr) d
) {
	size_t sz = sizeof(STRING_KEY_TREE_NS(node_t))
		+ STRING_KEY_TREE_EXTRA_ALLOC_SIZE(d);
	STRING_KEY_TREE_KEY_REF_TYPE key = d->STRING_KEY_TREE_KEY_NAME;
	AVL_TMPL_packed_ptr_t hkey = 0;
	int in_heap = STRING_KEY_TREE_KEY_IN_HEAP(d);
	if(in_heap)
		hkey = TREEDB_pack_pointer(key);
	AVL_TMPL_NS(node_ptr_t) ret = (AVL_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	STRING_KEY_TREE_VALUE_ASSIGN(ret->m_item.STRING_KEY_TREE_VALUE_NAME
		, d->STRING_KEY_TREE_VALUE_NAME);
	if(in_heap)
		key = (STRING_KEY_TREE_KEY_REF_TYPE)TREEDB_unpack_pointer(hkey);
	STRING_KEY_TREE_KEY_ASSIGN(ret->m_item.STRING_KEY_TREE_KEY_NAME, key);
	return ret;
}
static inline STRING_KEY_TREE_NS(node_ptr_t) STRING_KEY_TREE_NS(impl_clone_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_KEY_TREE_NS(const_data_ptr) pd
) {
	STRING_KEY_TREE_NS(input) in = STRING_KEY_TREE_DATA_TO_INPUT(pd);
	return STRING_KEY_TREE_NS(impl_alloc_node)(runtime, & in);
}
  #ifdef __cplusplus
} /* extern "C" { */
  #endif

#endif /* #ifndef STRING_KEY_TREE_NO_IMPL */

#ifndef STRING_KEY_TREE_NO_CLEARDEFS
  #include <treedb/avl-string-key-cleardefs.h>
#else
  #undef STRING_KEY_TREE_NO_CLEARDEFS
#endif

#ifdef DOXYGEN_processing
}
#endif
