/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/ns-types.h>

#ifndef AVL_STRING_VALUE_NO_TYPES

  #include <treedb/avl-string-value-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef struct STRING_VALUE_TREE_NS(data) {
	STRING_VALUE_TREE_KEY_TYPE STRING_VALUE_TREE_KEY_NAME;
	char STRING_VALUE_TREE_VALUE_NAME[];
} STRING_VALUE_TREE_NS(data), * STRING_VALUE_TREE_NS(data_ptr);
typedef const STRING_VALUE_TREE_NS(data) * STRING_VALUE_TREE_NS(const_data_ptr);

typedef struct STRING_VALUE_TREE_NS(input) {
	STRING_VALUE_TREE_KEY_TYPE STRING_VALUE_TREE_KEY_NAME;
	const char * STRING_VALUE_TREE_VALUE_NAME;
} STRING_VALUE_TREE_NS(input), * STRING_VALUE_TREE_NS(input_ptr);
typedef const STRING_VALUE_TREE_NS(input) * STRING_VALUE_TREE_NS(const_input_ptr);

  #ifdef __cplusplus
} // extern "C"
  #endif

  #define AVL_omit_impl_alloc_node
  #define AVL_NO_IMPL
  #include <treedb/avl.h>
  #undef AVL_NO_IMPL

#endif /* #ifndef AVL_STRING_VALUE_NO_TYPES */

#ifndef AVL_STRING_VALUE_NO_IMPL

  #include <treedb/avl-string-value-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

  #define AVL_TMPL_omit_node_t_typedefs
typedef struct STRING_VALUE_TREE_NS(node_t) STRING_VALUE_TREE_NS(node_t)
, * STRING_VALUE_TREE_NS(node_ptr_t);

/** AVL_TMPL_NS(impl_alloc_node)

We need to take extra steps in case we're called from clone() as we're passed
a reference to data in the heap.
*/
static inline STRING_VALUE_TREE_NS(node_ptr_t) STRING_VALUE_TREE_NS(impl_alloc_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_VALUE_TREE_NS(const_input_ptr) d
);
static inline STRING_VALUE_TREE_NS(node_ptr_t) STRING_VALUE_TREE_NS(impl_clone_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_VALUE_TREE_NS(data) * pd
);

  #ifdef __cplusplus
} /* extern "C" { */
  #endif

  #define AVL_omit_impl_alloc_node
  #define AVL_NO_TYPES
  #include <treedb/avl.h>
  #undef AVL_NO_TYPES

  #include <treedb/avl-string-value-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

/**

We need to take extra steps in case we're called from clone() as we're passed
a reference to data in the heap.
*/
static inline STRING_VALUE_TREE_NS(node_ptr_t) STRING_VALUE_TREE_NS(impl_alloc_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_VALUE_TREE_NS(const_input_ptr) d
) {
	size_t sz = sizeof(STRING_VALUE_TREE_NS(node_t))
		+ strlen(d->STRING_VALUE_TREE_VALUE_NAME) + 1;
	const char * value = d->STRING_VALUE_TREE_VALUE_NAME;
	AVL_TMPL_packed_ptr_t hValue = 0;
	int in_heap = TREEDB_in_heap(d->STRING_VALUE_TREE_VALUE_NAME);
	if(in_heap)
		hValue = TREEDB_pack_pointer(d->STRING_VALUE_TREE_VALUE_NAME);
	AVL_TMPL_NS(node_ptr_t) ret = (AVL_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	ret->m_item.STRING_VALUE_TREE_KEY_NAME = d->STRING_VALUE_TREE_KEY_NAME;
	if(in_heap)
		value = (const char *)TREEDB_unpack_pointer(hValue);
	v3c_strcpy(ret->m_item.STRING_VALUE_TREE_VALUE_NAME, value);
	return ret;
}
static inline AVL_NS(node_ptr_t) AVL_NS(impl_clone_node)
( TREEDB_NS(runtime_ptr_t) runtime
, STRING_VALUE_TREE_NS(data) * pd
) {
	STRING_VALUE_TREE_NS(input) in
		= { pd->STRING_VALUE_TREE_KEY_NAME, pd->STRING_VALUE_TREE_VALUE_NAME };
	return STRING_VALUE_TREE_NS(impl_alloc_node)(runtime, & in);
}
  #ifdef __cplusplus
} /* extern "C" { */
  #endif

#endif /* #ifndef AVL_STRING_VALUE_NO_IMPL */

#ifndef STRING_VALUE_TREE_NO_CLEARDEFS
  #include <treedb/avl-string-value-cleardefs.h>
#else
  #undef STRING_VALUE_TREE_NO_CLEARDEFS
#endif

#ifdef DOXYGEN_processing
}
#endif
