/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/string_utils.h> /* for v3c_strcpy */

#ifdef DOXYGEN_processing
{
#endif

/* AVL - define macros we use. */

#ifndef STRING_TREE_NS
  #define STRING_TREE_NS(x) TREEDB_NS(AvlStringTree_##x)
#endif
#ifndef STRING_TREE_MEMBER
  #define STRING_TREE_MEMBER m_string_tree
#endif
#ifndef STRING_TREE
  #define STRING_TREE MAKE_AVL_TREE(STRING_TREE_MEMBER)
#endif
#ifndef PACKED_STRING_TREE
  #define PACKED_STRING_TREE \
	MAKE_PACKED_AVL_TREE(STRING_TREE_NS, STRING_TREE_MEMBER)
#endif

#define STRING_TREE_NS_unpack_tree(x) \
	(STRING_TREE_NS(tree_ptr_t))TREEDB_unpack_pointer(x)
#define STRING_TREE_NS_unpack_node(x) \
	(STRING_TREE_NS(node_ptr_t))TREEDB_unpack_pointer(x)

/* AVL- define macros avl.h uses - it will undefine them. */

#define AVL_NS_ALLOC_SIZE(ctx, data) \
	(offsetof(STRING_TREE_NS(node_t), AVL_TMPL_item) + strlen(data) + 1)
#define AVL_NS_STORE_DATA(ret, data) v3c_strcpy(ret->AVL_TMPL_item, data)

#define AVL_NS(x) STRING_TREE_NS(x)
#define AVL_TREE STRING_TREE
#define PACKED_AVL_TREE PACKED_STRING_TREE
#define AVL_TREE_MEMBER STRING_TREE_MEMBER
#define AVL_NS_CAN_CLONE_POINTER
#define AVL_key_t const char *
#define AVL_data_t char
#define AVL_TMPL_item_SUFFIX []
#define AVL_cmp(a, b) strcmp(a,b)

#include <treedb/avl.h>

#ifndef STRING_TREE_NO_CLEARDEFS
  #include <treedb/avl-string-cleardefs.h>
#else
  #undef STRING_TREE_NO_CLEARDEFS
#endif

#ifdef DOXYGEN_processing
}
#endif
