/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "avl-template-defines.h"

#ifdef DOXYGEN_processing
}
#endif

#ifdef AVL_TMPL_omit_node_at_index
  #ifndef AVL_TMPL_omit_index
	#define AVL_TMPL_omit_index
  #endif
#endif

#ifdef AVL_TMPL_omit_insert_node_top
  #ifndef AVL_TMPL_omit_insert_node
	#define AVL_TMPL_omit_insert_node
  #endif
  #ifndef AVL_TMPL_omit_insert_node_before
	#define AVL_TMPL_omit_insert_node_before
  #endif
  #ifndef AVL_TMPL_omit_insert_node_after
	#define AVL_TMPL_omit_insert_node_after
  #endif
#endif

#ifdef AVL_TMPL_omit_insert_node_before
  #ifndef AVL_TMPL_omit_insert_node
	#define AVL_TMPL_omit_insert_node
  #endif
  #ifndef AVL_TMPL_omit_insert_node_after
	#define AVL_TMPL_omit_insert_node_after
  #endif
#endif

#ifdef AVL_TMPL_omit_insert_node_after
  #ifndef AVL_TMPL_omit_insert_node
	#define AVL_TMPL_omit_insert_node
  #endif
  #ifndef AVL_TMPL_omit_insert_node_before
	#define AVL_TMPL_omit_insert_node_before
  #endif
#endif

#ifdef AVL_TMPL_omit_unlink_node
  #ifndef AVL_TMPL_omit_delete_node
	#define AVL_TMPL_omit_delete_node
  #endif
#endif

#ifdef AVL_TMPL_omit_delete_node
  #ifndef AVL_TMPL_omit_clear
	#define AVL_TMPL_omit_clear
  #endif
  #ifndef AVL_TMPL_omit_remove
	#define AVL_TMPL_omit_remove
  #endif
  #ifndef AVL_TMPL_omit_remove_between
	#define AVL_TMPL_omit_remove_between
  #endif
#endif

#ifdef AVL_TMPL_omit_remove_between
  #ifndef AVL_TMPL_omit_remove_many
	#define AVL_TMPL_omit_remove_many
  #endif
#endif

#ifdef AVL_TMPL_omit_search_closest
  #ifndef AVL_TMPL_omit_search
	#define AVL_TMPL_omit_search
  #endif
#endif

#if (defined AVL_TMPL_omit_node_index \
	|| defined AVL_TMPL_omit_search_le \
	|| defined AVL_TMPL_omit_search_ge \
	)
  #ifndef AVL_TMPL_omit_distance
	#define AVL_TMPL_omit_distance
  #endif
#endif

#ifdef AVL_TMPL_omit_clear
  #ifndef AVL_TMPL_omit_free
	#define AVL_TMPL_omit_free
  #endif
  #ifndef AVL_TMPL_omit_clone
	#define AVL_TMPL_omit_clone
  #endif
#endif

#if (defined AVL_TMPL_omit_insert_node_before || \
	defined AVL_TMPL_omit_insert_node_after)
  #ifndef AVL_TMPL_omit_relink_node
	#define AVL_TMPL_omit_relink_node
  #endif
#endif

#ifndef AVL_TMPL_omit_clone
  #ifndef AVL_TMPL_clone_node
    #define AVL_TMPL_clone_node(pn) AVL_TMPL_alloc_node(pn->AVL_TMPL_item)
  #endif
#endif

/* 9. implementation : must-defines */
#ifndef AVL_TMPL_omit_free
  #ifndef AVL_TMPL_free
    #error AVL_TMPL_free is not defined.
  #endif
#endif
#ifndef AVL_TMPL_omit_insert
  #ifndef AVL_TMPL_alloc_node
    #error AVL_TMPL_alloc_node is not defined.
  #endif
#endif
#ifndef AVL_TMPL_omit_delete_node
  #ifndef AVL_TMPL_free_node
    #error AVL_TMPL_free_node is not defined.
  #endif
#endif
#ifndef AVL_TMPL_unpack_pointer
  #error AVL_TMPL_unpack_pointer is not defined.
#endif
#ifndef AVL_TMPL_pack_pointer
  #error AVL_TMPL_pack_pointer is not defined.
#endif
#ifndef AVL_TMPL_cmp
  #error AVL_TMPL_cmp is not defined.
#endif

/* 10. implementation : optional */
#ifndef AVL_TMPL_free_item_data
  #define AVL_TMPL_free_item_data(pNode)
#endif
#ifndef AVL_TMPL_unpack_key
  #define AVL_TMPL_unpack_key(pNode) (pNode)->AVL_TMPL_item
#endif
#ifndef AVL_TMPL_free_packed_tree
  #define AVL_TMPL_free_packed_tree(pktree) \
	AVL_TMPL_free(AVL_TMPL_unpack_tree(pktree))
#endif
#ifndef AVL_TMPL_free_tree_pointer
  #define AVL_TMPL_free_tree_pointer(ptree) \
	AVL_TMPL_free(ptree)
#endif
#ifndef AVL_TMPL_free_packed_node
#define AVL_TMPL_free_packed_node(pknode) \
	AVL_TMPL_free_node(AVL_TMPL_unpack_node(pknode))
#endif
#ifndef AVL_TMPL_free_node_pointer
#define AVL_TMPL_free_node_pointer(node) \
	AVL_TMPL_free_node(node)
#endif
#ifndef AVL_TMPL_allow_duplicates
  #define AVL_TMPL_allow_duplicates 0
#endif
#ifndef AVL_TMPL_exceeds_count_limit
  #ifdef TREEDB_need_exceed_check
	#define AVL_TMPL_exceeds_count_limit(x) \
	  ((x) > ((AVL_TMPL_size_t)((AVL_TMPL_count_t)-1)))
  #else
	#define AVL_TMPL_exceeds_count_limit(x) 0
  #endif
#endif

/* 11. implementation : insertion / extraction */
#ifndef AVL_TMPL_omit_unpack_tree
  #ifndef AVL_TMPL_unpack_tree
    #define AVL_TMPL_unpack_tree(x) AVL_TMPL_NS(unpack_tree)(runtime, x)
  #endif
static inline
AVL_TMPL_tree_ptr_t
AVL_TMPL_NS(unpack_tree)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t p
) {
	(void)runtime;
	void * c = AVL_TMPL_unpack_pointer(p);
	AVL_TMPL_tree_ptr_t ret = (AVL_TMPL_tree_ptr_t)c;
	TREEDB_printf8("unpack_tree : %lu[0x%lx] -> %p\n"
		, (uintptr_t)p/*.tree.value*/
		, (uintptr_t)p/*.tree.value*/
		, (void *)(uintptr_t)ret);
	return ret;
}
#endif

#ifndef AVL_TMPL_omit_pack_tree
  #ifndef AVL_TMPL_pack_tree
    #define AVL_TMPL_pack_tree(x) AVL_TMPL_NS(pack_tree)(runtime, x)
  #endif
static inline
AVL_TMPL_packed_tree_ptr_t
AVL_TMPL_NS(pack_tree)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t p
) {
	(void)runtime;
	AVL_TMPL_packed_tree_ptr_t ret
		= (AVL_TMPL_packed_tree_ptr_t)AVL_TMPL_pack_pointer(p);
	TREEDB_printf8("pack_tree : %p -> %lu[0x%lx]\n"
		, (void *)(uintptr_t)p
		, (uintptr_t)ret/*.tree.value*/
		, (uintptr_t)ret/*.tree.value*/
		);
	return ret;
}
#endif

#ifndef AVL_TMPL_omit_unpack_node
  #ifndef AVL_TMPL_unpack_node
    #define AVL_TMPL_unpack_node(x) AVL_TMPL_NS(unpack_node)(runtime, x)
  #endif
static inline
AVL_TMPL_node_ptr_t
AVL_TMPL_NS(unpack_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_node_ptr_t p
) {
	(void)runtime;
	void * c = AVL_TMPL_unpack_pointer(p);
	AVL_TMPL_node_ptr_t ret = (AVL_TMPL_node_ptr_t)c;
	TREEDB_printf8("unpack_node : %lu[0x%lx] -> %p\n"
		, (uintptr_t)p
		, (uintptr_t)p
		, (void *)(uintptr_t)ret);
	return ret;
}
#endif

#ifndef AVL_TMPL_omit_pack_node
  #ifndef AVL_TMPL_pack_node
    #define AVL_TMPL_pack_node(x) AVL_TMPL_NS(pack_node)(runtime, x)
  #endif
static inline
AVL_TMPL_packed_node_ptr_t
AVL_TMPL_NS(pack_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_node_ptr_t p
) {
	(void)runtime;
	AVL_TMPL_packed_node_ptr_t ret
		= (AVL_TMPL_packed_node_ptr_t)AVL_TMPL_pack_pointer(p);
	TREEDB_printf8("pack_node : %p -> %lu[0x%lx]\n"
		, (void *)(uintptr_t)p
		, (uintptr_t)ret
		, (uintptr_t)ret
		);
	return ret;
}
#endif

/* For internal use */
#define AVL_TMPL_node_count(n)  ((n) ? (n)->m_count : 0)
#define AVL_TMPL_l_count(n) \
	(AVL_TMPL_node_count(AVL_TMPL_unpack_node((n)->AVL_TMPL_left)))
#define AVL_TMPL_r_count(n) \
	(AVL_TMPL_node_count(AVL_TMPL_unpack_node((n)->AVL_TMPL_right)))
#define AVL_TMPL_calc_count(n)  (AVL_TMPL_l_count(n) + AVL_TMPL_r_count(n) + 1)

#define AVL_TMPL_node_depth(n)  ((n) ? (n)->m_depth : 0)
#define AVL_TMPL_l_depth(n) \
	(AVL_TMPL_node_depth(AVL_TMPL_unpack_node((n)->AVL_TMPL_left)))
#define AVL_TMPL_r_depth(n) \
	(AVL_TMPL_node_depth(AVL_TMPL_unpack_node((n)->AVL_TMPL_right)))
#define AVL_TMPL_calc_depth(n)  ((AVL_TMPL_l_depth(n) > AVL_TMPL_r_depth(n) ? \
	AVL_TMPL_l_depth(n) : AVL_TMPL_r_depth(n)) + 1)

static void AVL_TMPL_NS(rebalance)
( AVL_TMPL_runtime_ptr_t
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t node);

#ifndef AVL_TMPL_has_depth
/* Also known as ffs() (from BSD) */
static int AVL_TMPL_NS(lg)(AVL_TMPL_size_t u) {
	if(!u) return 0;
	int r = 1;
	if(sizeof(AVL_TMPL_size_t) > 4)
		if(u & 0xffffffff00000000) { u >>= 32; r += 32; }
	if(sizeof(AVL_TMPL_size_t) > 2)
		if(u & 0xffff0000) { u >>= 16; r += 16; }
	if(u & 0x0000ff00) { u >>= 8; r += 8; }
	if(u & 0x000000f0) { u >>= 4; r += 4; }
	if(u & 0x0000000c) { u >>= 2; r += 2; }
	if(u & 0x00000002) r++;
	return r;
}
#endif

static int AVL_TMPL_NS(check_balance)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_node_ptr_t avlnode
) {
	(void)runtime;
#ifdef AVL_TMPL_has_depth
	int d;
	d = AVL_TMPL_r_depth(avlnode) - AVL_TMPL_l_depth(avlnode);
	return d<-1?-1:d>1?1:0;
#else
/*	int d;
 *	d = AVL_TMPL_NS(lg)(R_COUNT(avlnode)) - lg(L_COUNT(avlnode));
 *	d = d<-1?-1:d>1?1:0;
 */
  #ifdef AVL_TMPL_has_count
	int pl, r;

	pl = AVL_TMPL_NS(lg)(AVL_TMPL_l_count(avlnode));
	r = AVL_TMPL_r_count(avlnode);

	if(r>>(pl+1))
		return 1;
	if(pl<2 || r>>(pl-2))
		return 0;
	return -1;
  #else
    #error No balancing possible.
  #endif
#endif
}

AVL_TMPL_prefix AVL_TMPL_size_t AVL_TMPL_NS(count)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
) {
#ifdef AVL_TMPL_has_count
	(void)runtime;
	AVL_TMPL_size_t ret
		= AVL_TMPL_node_count(AVL_TMPL_unpack_node(pt->AVL_TMPL_top));
#else
	AVL_TMPL_size_t n, ret = 0;
	AVL_TMPL_node_ptr_t pn = AVL_TMPL_unpack_node(pt->AVL_TMPL_head);
	for(n = 0; pn; pn = AVL_TMPL_unpack_node(pn->AVL_TMPL_next))
		++ret;
#endif
	return ret;
}

#ifndef AVL_TMPL_omit_init
AVL_TMPL_prefix AVL_TMPL_tree_ptr_t AVL_TMPL_NS(init)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
) {
	(void)runtime;
	if(pt)
		pt->AVL_TMPL_head = pt->AVL_TMPL_tail = pt->AVL_TMPL_top = 0;
	return pt;
}
#endif

#ifndef AVL_TMPL_omit_clear
/** Free AVL tree nodes.

The storage used must be write locked.
*/
AVL_TMPL_prefix void AVL_TMPL_NS(clear)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
) {
	AVL_TMPL_node_ptr_t node
		= AVL_TMPL_unpack_node(AVL_TMPL_unpack_tree(ht)->AVL_TMPL_head);
	AVL_TMPL_packed_node_ptr_t next, pknode;
	for(; node; node = AVL_TMPL_unpack_node(next)) {
		next = node->AVL_TMPL_next;
		/* Store the offset as the memory may move. */
		pknode = AVL_TMPL_pack_node(node);
		AVL_TMPL_free_item_data(node);
		AVL_TMPL_free_packed_node(pknode);
	}
	AVL_TMPL_NS(init)(runtime, AVL_TMPL_unpack_tree(ht));
}
#endif
#ifndef AVL_TMPL_omit_free
AVL_TMPL_prefix void AVL_TMPL_NS(free)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
) {
	AVL_TMPL_NS(clear)(runtime, ht);
	AVL_TMPL_free_packed_tree(ht);
}
#endif

#ifndef AVL_TMPL_omit_clone
/** Make a copy (clone) of another tree.

The storage used must be write locked.

The destination tree must be initialised first.

If the destination tree isn't empty, it is cleared.

If the allocator runs out of memory, the copy is cleared and clone fails.

There's probably a faster way of doing this that avoids rebalancing.
*/
AVL_TMPL_prefix int AVL_TMPL_NS(clone)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht_to
, AVL_TMPL_packed_tree_ptr_t ht_from
) {
	AVL_TMPL_node_ptr_t node2
		= AVL_TMPL_unpack_node(AVL_TMPL_unpack_tree(ht_to)->AVL_TMPL_head);
	if(node2)
		AVL_TMPL_NS(clear)(runtime, ht_to);
	AVL_TMPL_node_ptr_t node
		= AVL_TMPL_unpack_node(AVL_TMPL_unpack_tree(ht_from)->AVL_TMPL_head);
	AVL_TMPL_packed_node_ptr_t next;
	for(; node; node = AVL_TMPL_unpack_node(next)) {
		next = node->AVL_TMPL_next;
		node2 = AVL_TMPL_clone_node(node);
		if(!node2) {
			AVL_TMPL_NS(clear)(runtime, ht_to);
			return 1;
		}
		AVL_TMPL_NS(insert_node)(runtime, AVL_TMPL_unpack_tree(ht_to), node2);
	}
	return 0;
}
#endif

/** Initialise a node.

The storage used must be write locked.
*/
static void AVL_TMPL_NS(init_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_node_ptr_t newnode
) {
	(void)runtime;
	newnode->AVL_TMPL_left = newnode->AVL_TMPL_right = 0;
#ifdef AVL_TMPL_has_count
	newnode->m_count = 1;
#endif
#ifdef AVL_TMPL_has_depth
	newnode->m_depth = 1;
#endif
}

/** Insert a node as the top node of an AVL tree.

The storage used must be write locked.
*/
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(insert_node_top)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t newnode
) {
	AVL_TMPL_NS(init_node)(runtime, newnode);
	newnode->AVL_TMPL_prev = newnode->AVL_TMPL_next = newnode->AVL_TMPL_parent
		= 0;
	pt->AVL_TMPL_head = pt->AVL_TMPL_tail = pt->AVL_TMPL_top
		= AVL_TMPL_pack_node(newnode);
	return newnode;
}

/** Insert a node before another node in an AVL tree.

The storage used must be write locked.
*/
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(insert_node_before)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t node
, AVL_TMPL_node_ptr_t newnode
) {
	if(!node)
		return AVL_TMPL_unpack_node(pt->AVL_TMPL_tail)
			? AVL_TMPL_NS(insert_node_after)(runtime, pt
				, AVL_TMPL_unpack_node(pt->AVL_TMPL_tail), newnode)
			: AVL_TMPL_NS(insert_node_top)(runtime, pt, newnode);

	if(AVL_TMPL_unpack_node(node->AVL_TMPL_left))
		return AVL_TMPL_NS(insert_node_after)(runtime, pt
			, AVL_TMPL_unpack_node(node->AVL_TMPL_prev), newnode);

	AVL_TMPL_NS(init_node)(runtime, newnode);

	newnode->AVL_TMPL_next = newnode->AVL_TMPL_parent
		= AVL_TMPL_pack_node(node);

	newnode->AVL_TMPL_prev = node->AVL_TMPL_prev;
	if(AVL_TMPL_unpack_node(node->AVL_TMPL_prev))
		AVL_TMPL_unpack_node(node->AVL_TMPL_prev)->AVL_TMPL_next
			= AVL_TMPL_pack_node(newnode);
	else
		pt->AVL_TMPL_head = AVL_TMPL_pack_node(newnode);
	node->AVL_TMPL_prev = AVL_TMPL_pack_node(newnode);

	node->AVL_TMPL_left = AVL_TMPL_pack_node(newnode);
	AVL_TMPL_NS(rebalance)(runtime, pt, node);
	return newnode;
}

/** Insert a node after another node in an AVL tree.

The storage used must be write locked.

O(1)*/
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(insert_node_after)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t node
, AVL_TMPL_node_ptr_t newnode
) {
	if(!node)
		return AVL_TMPL_unpack_node(pt->AVL_TMPL_head)
			? AVL_TMPL_NS(insert_node_before)(runtime, pt
				, AVL_TMPL_unpack_node(pt->AVL_TMPL_head), newnode)
			: AVL_TMPL_NS(insert_node_top)(runtime, pt, newnode);

	if(AVL_TMPL_unpack_node(node->AVL_TMPL_right))
		return AVL_TMPL_NS(insert_node_before)(runtime, pt
			, AVL_TMPL_unpack_node(node->AVL_TMPL_next), newnode);

	AVL_TMPL_NS(init_node)(runtime, newnode);

	newnode->AVL_TMPL_prev = newnode->AVL_TMPL_parent
		= AVL_TMPL_pack_node(node);

	newnode->AVL_TMPL_next = node->AVL_TMPL_next;
	if(AVL_TMPL_unpack_node(node->AVL_TMPL_next))
		AVL_TMPL_unpack_node(node->AVL_TMPL_next)->AVL_TMPL_prev
			= AVL_TMPL_pack_node(newnode);
	else
		pt->AVL_TMPL_tail = AVL_TMPL_pack_node(newnode);
	node->AVL_TMPL_next = AVL_TMPL_pack_node(newnode);

	node->AVL_TMPL_right = AVL_TMPL_pack_node(newnode);
	AVL_TMPL_NS(rebalance)(runtime, pt, node);
	return newnode;
}
/** Relink a node into the AVL tree.

The storage used must be write locked.

O(1)*/
AVL_TMPL_prefix void AVL_TMPL_NS(relink_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t node
) {
	if(node->AVL_TMPL_prev)
		AVL_TMPL_NS(insert_node_after)(runtime, pt, node
			, AVL_TMPL_unpack_node(node->AVL_TMPL_prev));
	else
		AVL_TMPL_NS(insert_node_before)(runtime, pt
			, AVL_TMPL_unpack_node(node->AVL_TMPL_next), node);
}
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(insert_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t newnode
) {
	(void)runtime;
	AVL_TMPL_node_ptr_t node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);
	if(!node)
		return AVL_TMPL_NS(insert_node_top)(runtime, pt, newnode);
	switch(AVL_TMPL_NS(search_closest)(runtime, pt
			, AVL_TMPL_unpack_key(newnode), &node)) {
	case eTreedbSearchGreater:
		return AVL_TMPL_NS(insert_node_before)(runtime, pt, node, newnode);
	case eTreedbSearchLess:
	case eTreedbSearchEmpty:
		return AVL_TMPL_NS(insert_node_after)(runtime, pt, node, newnode);
	case eTreedbSearchEqual:
		if(AVL_TMPL_allow_duplicates)
			return AVL_TMPL_NS(insert_node_after)(runtime, pt, node, newnode);
		break;
	}
	return (AVL_TMPL_node_ptr_t)NULL;
}

#ifndef AVL_TMPL_omit_insert
AVL_TMPL_prefix TreedbInsertResult AVL_TMPL_NS(insert)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_input_t in
, AVL_TMPL_node_ptr_t * pret
) {
	AVL_TMPL_node_ptr_t newnode;

	newnode = AVL_TMPL_alloc_node(in);
	if(!newnode)
		return eTreedbInsertNoMem;
	if(AVL_TMPL_NS(insert_node)(runtime, AVL_TMPL_unpack_tree(ht), newnode)) {
		if(pret)
			* pret = newnode;
		return eTreedbInsertSuccess;
	}
	AVL_TMPL_free_node_pointer(newnode);
	return eTreedbInsertExists;
}
#endif

AVL_TMPL_prefix void AVL_TMPL_NS(unlink_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t avlnode
) {
	AVL_TMPL_node_ptr_t parent;
	AVL_TMPL_packed_node_ptr_t * superparent;
	AVL_TMPL_node_ptr_t subst, left, right;
	AVL_TMPL_node_ptr_t balnode;

	if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_prev))
		AVL_TMPL_unpack_node(avlnode->AVL_TMPL_prev)->AVL_TMPL_next
			= avlnode->AVL_TMPL_next;
	else
		pt->AVL_TMPL_head = avlnode->AVL_TMPL_next;

	if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_next))
		AVL_TMPL_unpack_node(avlnode->AVL_TMPL_next)->AVL_TMPL_prev
			= avlnode->AVL_TMPL_prev;
	else
		pt->AVL_TMPL_tail = avlnode->AVL_TMPL_prev;

	parent = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_parent);

	superparent = parent
		? avlnode == AVL_TMPL_unpack_node(parent->AVL_TMPL_left)
			? &parent->AVL_TMPL_left : &parent->AVL_TMPL_right
			: &pt->AVL_TMPL_top;

	left = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left);
	right = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right);
	if(!left) {
		*superparent = AVL_TMPL_pack_node(right);
		if(right)
			right->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
		balnode = parent;
	} else if(!right) {
		*superparent = AVL_TMPL_pack_node(left);
		left->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
		balnode = parent;
	} else {
		subst = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_prev);
		if(subst == left) {
			balnode = subst;
		} else {
			balnode = AVL_TMPL_unpack_node(subst->AVL_TMPL_parent);
			balnode->AVL_TMPL_right = subst->AVL_TMPL_left;
			if(AVL_TMPL_unpack_node(balnode->AVL_TMPL_right))
				AVL_TMPL_unpack_node(balnode->AVL_TMPL_right)
					->AVL_TMPL_parent
					= AVL_TMPL_pack_node(balnode);
			subst->AVL_TMPL_left = AVL_TMPL_pack_node(left);
			left->AVL_TMPL_parent = AVL_TMPL_pack_node(subst);
		}
		subst->AVL_TMPL_right = AVL_TMPL_pack_node(right);
		subst->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
		right->AVL_TMPL_parent = AVL_TMPL_pack_node(subst);
		*superparent = AVL_TMPL_pack_node(subst);
	}

	AVL_TMPL_NS(rebalance)(runtime, pt, balnode);
}

#ifndef AVL_TMPL_omit_delete_node
AVL_TMPL_prefix int AVL_TMPL_NS(delete_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_node_ptr_t node
) {
	if(!node)
		return 1;
	AVL_TMPL_NS(unlink_node)
		(runtime, AVL_TMPL_unpack_tree(ht), node);
	/* Store the offset as the memory may move. */
	AVL_TMPL_packed_node_ptr_t pknode = AVL_TMPL_pack_node(node);
	AVL_TMPL_free_item_data(node);
	AVL_TMPL_free_packed_node(pknode);
	return 0;
}
#endif

#ifndef AVL_TMPL_omit_remove
AVL_TMPL_prefix int AVL_TMPL_NS(remove)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_key_t key
) {
	return AVL_TMPL_NS(delete_node)(runtime, ht
		, AVL_TMPL_NS(search)
			(runtime, AVL_TMPL_unpack_tree(ht), key));
}
#endif
#ifndef AVL_TMPL_omit_remove_between
static void AVL_TMPL_NS(remove_between_impl)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_packed_node_ptr_t hlower
, AVL_TMPL_packed_node_ptr_t hupper
, TreedbNodeDistanceFlags flags
) {
	if((hlower == hupper) && !(flags.include_lower && flags.include_upper))
		return;
	AVL_TMPL_node_ptr_t lower = AVL_TMPL_unpack_node(hlower);
	if(!flags.include_lower) {
		hlower = lower->AVL_TMPL_next;
		if(!hlower)
			return;
		if((hlower == hupper) && !flags.include_upper)
			return;
		lower = AVL_TMPL_unpack_node(hlower);
	}
	AVL_TMPL_node_ptr_t upper = AVL_TMPL_unpack_node(hupper);
	if(!flags.include_upper) {
		hupper = upper->AVL_TMPL_prev;
		if(!hupper)
			return;
		if((hlower == hupper) && !flags.include_lower)
			return;
		upper = AVL_TMPL_unpack_node(hupper);
	}
	for(;;) {
		if(hlower == hupper) {
			AVL_TMPL_NS(delete_node)(runtime, ht, lower);
			return;
		}
		hlower = lower->AVL_TMPL_next;
		AVL_TMPL_NS(delete_node)(runtime, ht, lower);
		lower = AVL_TMPL_unpack_node(hlower);
	}
	return;
}
AVL_TMPL_prefix int AVL_TMPL_NS(remove_between)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_packed_node_ptr_t hlower
, AVL_TMPL_packed_node_ptr_t hupper
, TreedbNodeDistanceFlags flags
) {
	if(!hlower || !hupper) {
		AVL_TMPL_tree_ptr_t pt = AVL_TMPL_unpack_tree(ht);
		if(!hlower)
			hlower = pt->AVL_TMPL_head;
		if(!hupper)
			hupper = pt->AVL_TMPL_tail;
	}
	AVL_TMPL_node_ptr_t lower = AVL_TMPL_unpack_node(hlower);
	AVL_TMPL_node_ptr_t upper = AVL_TMPL_unpack_node(hupper);
	int cmp = AVL_TMPL_cmp(AVL_TMPL_unpack_key(lower)
		, AVL_TMPL_unpack_key(upper));
	if((!cmp) && (!flags.include_lower || !flags.include_upper))
		return 0;
	if(cmp < 0)
		AVL_TMPL_NS(remove_between_impl)(runtime, ht, hlower, hupper, flags);
	else
		AVL_TMPL_NS(remove_between_impl)(runtime, ht, hupper, hlower, flags);
	return 0;
}
#endif
#ifndef AVL_TMPL_omit_remove_many
static int AVL_TMPL_NS(remove_many_impl)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_key_t lower_key
, AVL_TMPL_key_t upper_key
, TreedbKeyDistanceFlags flags
) {
	AVL_TMPL_node_ptr_t lower, upper;

	AVL_TMPL_tree_ptr_t pt = AVL_TMPL_unpack_tree(ht);
	TreedbSearchResult res;
	res = AVL_TMPL_NS(search_ge)(runtime, pt, lower_key, &lower);
	if((res != eTreedbSearchEqual) && flags.exact_lower)
		return 1;
	if((res == eTreedbSearchLess) || !lower)
		return 2;
	if(res == eTreedbSearchGreater)
		flags.include_lower = 1;
	res = AVL_TMPL_NS(search_le)(runtime, pt, upper_key, &upper);
	if((res != eTreedbSearchEqual) && flags.exact_upper)
		return 3;
	if((res == eTreedbSearchGreater) || !upper)
		return 4;
	if(res == eTreedbSearchLess)
		flags.include_upper = 1;
	AVL_TMPL_NS(remove_between_impl)(runtime, ht
		, AVL_TMPL_pack_node(lower), AVL_TMPL_pack_node(upper)
		, flags.node_distance);
	return 0;
}
AVL_TMPL_prefix int AVL_TMPL_NS(remove_many)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_packed_tree_ptr_t ht
, AVL_TMPL_key_t lower_key
, AVL_TMPL_key_t upper_key
, TreedbKeyDistanceFlags flags
) {
	TREEDB_printf4("remove_many(lk %ld, uk %ld, exact_lower %d"
		", include_lower %d, exact_upper %d, include_upper %d)\n"
		, (size_t)lower_key, (size_t)upper_key, flags.exact_lower
		, flags.include_lower, flags.exact_upper, flags.include_upper);
	int cmp = AVL_TMPL_cmp(lower_key, upper_key);
	if((!cmp) && (!flags.include_lower || !flags.include_upper))
		return 0;
	if(cmp <= 0) {
		return AVL_TMPL_NS(remove_many_impl)(runtime, ht, lower_key, upper_key
			, flags);
	}else{
		return AVL_TMPL_NS(remove_many_impl)(runtime, ht, upper_key, lower_key
			, flags);
	}
}
#endif
#ifndef AVL_TMPL_omit_node_distance
/*! Get the distance between nodes.
*/
AVL_TMPL_prefix AVL_TMPL_ssize_t AVL_TMPL_NS(node_distance)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t lower
, AVL_TMPL_node_ptr_t upper
, TreedbNodeDistanceFlags flags
) {
	AVL_TMPL_ssize_t res;
	if(lower == upper) {
		res = (flags.include_lower && flags.include_upper);
		TREEDB_printf4("node_distance([%s]) returning %ld.\n"
			, TreedbNodeDistanceFlagsDesc(flags),(size_t)res);
	}else{
		AVL_TMPL_size_t lx = AVL_TMPL_NS(node_index)(runtime, pt, lower);
		AVL_TMPL_size_t ux = AVL_TMPL_NS(node_index)(runtime, pt, upper);
		res = ux - lx;
		if(res > 0) {
			res -= 1; /* The exclusive distance */
			res += flags.include_lower + flags.include_upper;
		}else{
			res += 1; /* The exclusive distance */
			res -= flags.include_lower + flags.include_upper;
		}
		TREEDB_printf4("node_distance([%s]) got (%ld, %ld), returning %ld.\n"
			, TreedbNodeDistanceFlagsDesc(flags), (size_t)lx, (size_t)ux
			, (size_t)res);
	}
	return res;
}
#endif
#ifndef AVL_TMPL_omit_key_distance
AVL_TMPL_prefix int AVL_TMPL_NS(key_distance)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t lower_key
, AVL_TMPL_key_t upper_key
, TreedbKeyDistanceFlags flags
, AVL_TMPL_ssize_t * pres
) {
	TREEDB_printf4("key_distance(%lu, %lu, [%s]).\n"
		, (size_t)lower_key
		, (size_t)upper_key
		, TreedbKeyDistanceFlagsDesc(flags));

	AVL_TMPL_node_ptr_t lower, upper;

	TreedbSearchResult lower_res
		= AVL_TMPL_NS(search_ge)(runtime, pt, lower_key, &lower);
	if((lower_res != eTreedbSearchEqual) && flags.exact_lower)
		return 1;
	if((lower_res == eTreedbSearchLess) || !lower)
		return 2;
	if(lower_res == eTreedbSearchGreater)
		flags.include_lower = 1;

	TreedbSearchResult upper_res
		= AVL_TMPL_NS(search_le)(runtime, pt, upper_key, &upper);
	if((upper_res != eTreedbSearchEqual) && flags.exact_upper)
		return 3;
	if((upper_res == eTreedbSearchGreater) || !upper)
		return 4;
	if(upper_res == eTreedbSearchLess)
		flags.include_upper = 1;
	if(!pres)
		return 0; /* useful for checking if the keys are present. */

	if((lower_res == eTreedbSearchGreater) && (upper_res == eTreedbSearchLess))
		flags.include_lower = flags.include_upper = 1;

	*pres = AVL_TMPL_NS(node_distance)(runtime, pt, lower, upper
		, flags.node_distance);
	return 0;
}
#endif
#ifndef AVL_TMPL_omit_search_closest
AVL_TMPL_prefix TreedbSearchResult AVL_TMPL_NS(search_closest)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
, AVL_TMPL_node_ptr_t * pnode
) {
	AVL_TMPL_node_ptr_t node, node2;
	int c;

	if(!pnode)
		pnode = &node;

	node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);

	if(!node) {
		*pnode = (AVL_TMPL_node_ptr_t)NULL;
		return eTreedbSearchEmpty;
	}
	for(;;) {
		c = AVL_TMPL_cmp(key, AVL_TMPL_unpack_key(node));
		if(c < 0) {
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
			if(node2)
				node = node2;
			else{
				*pnode = node;
				return eTreedbSearchGreater;
			}
		}else if(c > 0) {
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
			if(node2)
				node = node2;
			else{
				*pnode = node;
				return eTreedbSearchLess;
			}
		}else{
			*pnode = node;
			return eTreedbSearchEqual;
		}
	}
}
#endif
#ifndef AVL_TMPL_omit_search_le
AVL_TMPL_prefix TreedbSearchResult AVL_TMPL_NS(search_le)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
, AVL_TMPL_node_ptr_t * avlnode
) {
	AVL_TMPL_node_ptr_t node, node2, most_le = 0;
	int c;

	if(!avlnode)
		avlnode = &node;

	node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);

	if(!node) {
		*avlnode = (AVL_TMPL_node_ptr_t)NULL;
		return eTreedbSearchEmpty;
	}

	for(;;) {
		c = AVL_TMPL_cmp(key, AVL_TMPL_unpack_key(node));
		if(c > 0) {
			most_le = node;
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
			if(node2)
				node = node2;
			else{
				*avlnode = node;
				return eTreedbSearchLess;
			}
		}else if(c < 0) {
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
			if(node2)
				node = node2;
			else{
				if(most_le) {
					*avlnode = most_le;
					return eTreedbSearchLess;
				}else{
					/* No item in this tree is <. */
					*avlnode = node;
					return eTreedbSearchGreater;
				}
			}
		}else{
			*avlnode = node;
			return eTreedbSearchEqual;
		}
	}
}
#endif
#ifndef AVL_TMPL_omit_search_ge
AVL_TMPL_prefix TreedbSearchResult AVL_TMPL_NS(search_ge)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
, AVL_TMPL_node_ptr_t * avlnode
) {
	AVL_TMPL_node_ptr_t node, node2, least_ge = 0;
	int c;

	if(!avlnode)
		avlnode = &node;

	node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);

	if(!node) {
		*avlnode = (AVL_TMPL_node_ptr_t)NULL;
		return eTreedbSearchEmpty;
	}

	for(;;) {
		c = AVL_TMPL_cmp(key, AVL_TMPL_unpack_key(node));
		if(c < 0) {
			least_ge = node;
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
			if(node2)
				node = node2;
			else{
				*avlnode = node;
				return eTreedbSearchGreater;
			}
		}else if(c > 0) {
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
			if(node2)
				node = node2;
			else{
				if(least_ge) {
					*avlnode = least_ge;
					return eTreedbSearchGreater;
				}else{
					/* No item in this tree is >. */
					*avlnode = node;
					return eTreedbSearchLess;
				}
			}
		}else{
			*avlnode = node;
			return eTreedbSearchEqual;
		}
	}
}
#endif

#ifndef AVL_TMPL_omit_node_index
  #ifdef TREEDB_AVL_DEBUG_node_index
	#define TREEDB_AVL_node_index_printf(fmt, ...) \
	  printf(fmt, ## __VA_ARGS__); fflush(stdout)
  #else
	#define TREEDB_AVL_node_index_printf(fmt, ...)
  #endif
AVL_TMPL_prefix AVL_TMPL_size_t AVL_TMPL_NS(node_index)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t pn
) {
	(void)pt;
  #ifdef AVL_TMPL_has_count
	AVL_TMPL_count_t index = 0;
	AVL_TMPL_node_ptr_t left, parent;
	TREEDB_AVL_node_index_printf("node_index %u\n", AVL_TMPL_pack_node(pn));
	left = AVL_TMPL_unpack_node(pn->AVL_TMPL_left);
	if(left) {
		TREEDB_AVL_node_index_printf("\tadding %u\n", left->AVL_TMPL_count);
		index += left->AVL_TMPL_count;
	}
	while(pn) {
		parent = AVL_TMPL_unpack_node(pn->AVL_TMPL_parent);
		if(!parent)
			break;
		left = AVL_TMPL_unpack_node(parent->AVL_TMPL_left);
		TREEDB_AVL_node_index_printf("\tparent %u\n"
			, AVL_TMPL_pack_node(parent));
		if(left == pn) {
			TREEDB_AVL_node_index_printf("\t\tleft\n");fflush(stdout);
		}else{
			TREEDB_AVL_node_index_printf("\t\tadding %u\n"
				, left->AVL_TMPL_count + 1);
			index += left->AVL_TMPL_count + 1;
		}
		pn = parent;
	}
  #else
	AVL_TMPL_node_ptr_t lower = AVL_TMPL_unpack_node(pt->AVL_TMPL_head);
	AVL_TMPL_count_t index = 0;
	for(;;) {
		if(lower == pn)
			break;
		++index;
		lower = AVL_TMPL_unpack_node(lower->AVL_TMPL_next);
	}
  #endif
	TREEDB_AVL_node_index_printf("\treturning %u\n", index);
	return index;
}
#endif

#ifndef AVL_TMPL_omit_node_at_index
  #ifdef TREEDB_AVL_DEBUG_index
	#define TREEDB_AVL_INDEX_printf(fmt, ...) \
	  printf(fmt, ## __VA_ARGS__); fflush(stdout)
  #else
	#define TREEDB_AVL_INDEX_printf(fmt, ...)
  #endif
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(node_at_index)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_node_ptr_t node
, AVL_TMPL_size_t u
) {
	(void)runtime;
	if(AVL_TMPL_exceeds_count_limit(u))
		return 0;
  #ifdef AVL_TMPL_has_count
	TREEDB_AVL_INDEX_printf("%u: get : u : %lu.\n", __LINE__, (size_t)u);
	if(!node) {
		TREEDB_AVL_INDEX_printf("%u: get : no nodes!\n", __LINE__);
		return 0;
	}
	if(u >= node->m_count) {
		TREEDB_AVL_INDEX_printf("%u: get : u : %lu >= count : %lu.\n"
			, __LINE__, (size_t)u, (size_t)node->m_count);
		return 0;
	}
	AVL_TMPL_node_ptr_t node2;
	AVL_TMPL_size_t u0 = u;
	(void)u0;
	++u; /* Now 1-based. */
	while(node) {
		TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu : "
			"while(node).\n"
			, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
		if(u == 1) {
			TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu :"
				" u == 1.\n"
				, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
			while((node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left)))
				node = node2;
			return node;
		}
		if(u == node->m_count) {
			TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu :"
				" u == node->count. Will return rightmost node.\n"
				, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
			while((node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right)))
				node = node2;
			return node;
		}
		node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
		if(node2) {
			if(u == ((AVL_TMPL_size_t)node2->m_count + 1)) {
				TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : "
					"%lu : u == left->m_count[%lu] + 1.\n"
					, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count
					, (size_t)node2->m_count);
				return node;
			}else if(u > node2->m_count) {
				TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : "
					"%lu : u > left->m_count[%lu]. Going right.\n"
					, __LINE__, (size_t)u0, (size_t)u
					, (size_t)node->m_count, (size_t)node2->m_count);
				u -= node2->m_count + 1;
				node = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
				continue;
			}else{
				TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : "
					"%lu : else : Going left.\n"
					, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
				node = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
				continue;
			}
		}
		TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu : "
			"No left branch.\n"
			, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
		node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
		if(!node2) {
			TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu :"
				" No right branch.\n"
				, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
			return 0;
		}
		TREEDB_AVL_INDEX_printf("%u: get : u0 : %lu, u : %lu, count : %lu : "
			"else Going right.\n"
			, __LINE__, (size_t)u0, (size_t)u, (size_t)node->m_count);
		node = node2;
	}
	return 0;
  #else
	AVL_TMPL_size_t n;
	for(n = 0; n < u; ++n)
		node = (AVL_TMPL_node_ptr_t)AVL_TMPL_unpack_pointer(node->m_next);
	return node;
  #endif
}
#endif
#ifndef AVL_TMPL_omit_index
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(index)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_size_t u
) {
	AVL_TMPL_node_ptr_t node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);
	return AVL_TMPL_NS(node_at_index)(runtime, node, u);
}
#endif
#ifndef AVL_TMPL_omit_search
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(search)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
) {
	AVL_TMPL_node_ptr_t node;
	return AVL_TMPL_NS(search_closest)(runtime, pt, key, &node)
		== eTreedbSearchEqual ? node : (AVL_TMPL_node_ptr_t)NULL;
}
#endif
#ifndef AVL_TMPL_omit_search_lt
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(search_lt)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
) {
	AVL_TMPL_node_ptr_t node, node2, most_lt = 0;
	int c;

	node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);

	if(!node)
		return 0;

	for(;;) {
		c = AVL_TMPL_cmp(key, AVL_TMPL_unpack_key(node));
		if(c > 0) {
			most_lt = node;
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
			if(node2)
				node = node2;
			else
				return node;
		}else{
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
			if(node2)
				node = node2;
			else{
				if(most_lt)
					return most_lt;
				else /* No item in this tree is <. */
					return 0;
			}
		}
	}
}
#endif
#ifndef AVL_TMPL_omit_search_gt
AVL_TMPL_prefix AVL_TMPL_node_ptr_t AVL_TMPL_NS(search_gt)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_key_t key
) {
	AVL_TMPL_node_ptr_t node, node2, least_gt = 0;
	int c;

	node = AVL_TMPL_unpack_node(pt->AVL_TMPL_top);

	if(!node)
		return 0;

	for(;;) {
		c = AVL_TMPL_cmp(key, AVL_TMPL_unpack_key(node));
		if(c < 0) {
			least_gt = node;
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_left);
			if(node2)
				node = node2;
			else
				return node;
		}else{
			node2 = AVL_TMPL_unpack_node(node->AVL_TMPL_right);
			if(node2)
				node = node2;
			else{
				if(least_gt)
					return least_gt;
				else /* No item in this tree is >. */
					return 0;
			}
		}
	}
}
#endif
/** Rebalances the tree if one side becomes too heavy.

This function assumes that both subtrees are AVL-trees with consistant data.

The function has the additional side effect of recalculating the count of
the tree at this node.

It should be noted that at the return of this function, if a rebalance takes
place, the top of this subtree may longer be the same node.

The storage used must be write locked.

O(n)*/
static void AVL_TMPL_NS(rebalance)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_tree_ptr_t pt
, AVL_TMPL_node_ptr_t avlnode
) {
	AVL_TMPL_node_ptr_t child;
	AVL_TMPL_node_ptr_t gchild;
	AVL_TMPL_node_ptr_t parent;
	AVL_TMPL_packed_node_ptr_t * superparent;

	parent = avlnode;

	while(avlnode) {
		parent = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_parent);

		superparent = parent
			? avlnode == AVL_TMPL_unpack_node(parent->AVL_TMPL_left)
				? &parent->AVL_TMPL_left
				: &parent->AVL_TMPL_right
			: &pt->AVL_TMPL_top;

		switch(AVL_TMPL_NS(check_balance)(runtime, avlnode)) {
		case -1:
			child = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left);
			#ifdef AVL_TMPL_has_depth
			if(AVL_TMPL_l_depth(child) >= AVL_TMPL_r_depth(child))
			#else
			  #ifdef AVL_TMPL_has_count
			if(AVL_TMPL_l_count(child) >= AVL_TMPL_r_count(child))
			  #else
			    #error No balancing possible.
			  #endif
			#endif
			{
				avlnode->AVL_TMPL_left = child->AVL_TMPL_right;
				if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left))
					AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(avlnode);
				child->AVL_TMPL_right = AVL_TMPL_pack_node(avlnode);
				avlnode->AVL_TMPL_parent = AVL_TMPL_pack_node(child);
				*superparent = AVL_TMPL_pack_node(child);
				child->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
				#ifdef AVL_TMPL_has_count
				avlnode->m_count = AVL_TMPL_calc_count(avlnode);
				child->m_count = AVL_TMPL_calc_count(child);
				#endif
				#ifdef AVL_TMPL_has_depth
				avlnode->m_depth = AVL_TMPL_calc_depth(avlnode);
				child->m_depth = AVL_TMPL_calc_depth(child);
				#endif
			} else {
				gchild = AVL_TMPL_unpack_node(child->AVL_TMPL_right);
				avlnode->AVL_TMPL_left = gchild->AVL_TMPL_right;
				if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left))
					AVL_TMPL_unpack_node(avlnode->AVL_TMPL_left)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(avlnode);
				child->AVL_TMPL_right = gchild->AVL_TMPL_left;
				if(AVL_TMPL_unpack_node(child->AVL_TMPL_right))
					AVL_TMPL_unpack_node(child->AVL_TMPL_right)->AVL_TMPL_parent
						= AVL_TMPL_pack_node(child);
				gchild->AVL_TMPL_right = AVL_TMPL_pack_node(avlnode);
				if(AVL_TMPL_unpack_node(gchild->AVL_TMPL_right))
					AVL_TMPL_unpack_node(gchild->AVL_TMPL_right)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(gchild);
				gchild->AVL_TMPL_left = AVL_TMPL_pack_node(child);
				if(AVL_TMPL_unpack_node(gchild->AVL_TMPL_left))
					AVL_TMPL_unpack_node(gchild->AVL_TMPL_left)->AVL_TMPL_parent
						= AVL_TMPL_pack_node(gchild);
				*superparent = AVL_TMPL_pack_node(gchild);
				gchild->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
				#ifdef AVL_TMPL_has_count
				avlnode->m_count = AVL_TMPL_calc_count(avlnode);
				child->m_count = AVL_TMPL_calc_count(child);
				gchild->m_count = AVL_TMPL_calc_count(gchild);
				#endif
				#ifdef AVL_TMPL_has_depth
				avlnode->m_depth = AVL_TMPL_calc_depth(avlnode);
				child->m_depth = AVL_TMPL_calc_depth(child);
				gchild->m_depth = AVL_TMPL_calc_depth(gchild);
				#endif
			}
			break;
		case 1:
			child = AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right);
			#ifdef AVL_TMPL_has_depth
			if(AVL_TMPL_r_depth(child) >= AVL_TMPL_l_depth(child))
			#else
			  #ifdef AVL_TMPL_has_count
			if(AVL_TMPL_r_count(child) >= AVL_TMPL_l_count(child))
			  #else
			    #error No balancing possible.
			  #endif
			#endif
			{
				avlnode->AVL_TMPL_right = child->AVL_TMPL_left;
				if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right))
					AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(avlnode);
				child->AVL_TMPL_left = AVL_TMPL_pack_node(avlnode);
				avlnode->AVL_TMPL_parent = AVL_TMPL_pack_node(child);
				*superparent = AVL_TMPL_pack_node(child);
				child->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
				#ifdef AVL_TMPL_has_count
				avlnode->m_count = AVL_TMPL_calc_count(avlnode);
				child->m_count = AVL_TMPL_calc_count(child);
				#endif
				#ifdef AVL_TMPL_has_depth
				avlnode->m_depth = AVL_TMPL_calc_depth(avlnode);
				child->m_depth = AVL_TMPL_calc_depth(child);
				#endif
			} else {
				gchild = AVL_TMPL_unpack_node(child->AVL_TMPL_left);
				avlnode->AVL_TMPL_right = gchild->AVL_TMPL_left;
				if(AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right))
					AVL_TMPL_unpack_node(avlnode->AVL_TMPL_right)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(avlnode);
				child->AVL_TMPL_left = gchild->AVL_TMPL_right;
				if(AVL_TMPL_unpack_node(child->AVL_TMPL_left))
					AVL_TMPL_unpack_node(child->AVL_TMPL_left)->AVL_TMPL_parent
						= AVL_TMPL_pack_node(child);
				gchild->AVL_TMPL_left = AVL_TMPL_pack_node(avlnode);
				if(AVL_TMPL_unpack_node(gchild->AVL_TMPL_left))
					AVL_TMPL_unpack_node(gchild->AVL_TMPL_left)->AVL_TMPL_parent
						= AVL_TMPL_pack_node(gchild);
				gchild->AVL_TMPL_right = AVL_TMPL_pack_node(child);
				if(AVL_TMPL_unpack_node(gchild->AVL_TMPL_right))
					AVL_TMPL_unpack_node(gchild->AVL_TMPL_right)
						->AVL_TMPL_parent = AVL_TMPL_pack_node(gchild);
				*superparent = AVL_TMPL_pack_node(gchild);
				gchild->AVL_TMPL_parent = AVL_TMPL_pack_node(parent);
				#ifdef AVL_TMPL_has_count
				avlnode->m_count = AVL_TMPL_calc_count(avlnode);
				child->m_count = AVL_TMPL_calc_count(child);
				gchild->m_count = AVL_TMPL_calc_count(gchild);
				#endif
				#ifdef AVL_TMPL_has_depth
				avlnode->m_depth = AVL_TMPL_calc_depth(avlnode);
				child->m_depth = AVL_TMPL_calc_depth(child);
				gchild->m_depth = AVL_TMPL_calc_depth(gchild);
				#endif
			}
			break;
		default:
			#ifdef AVL_TMPL_has_count
			avlnode->m_count = AVL_TMPL_calc_count(avlnode);
			#endif
			#ifdef AVL_TMPL_has_depth
			avlnode->m_depth = AVL_TMPL_calc_depth(avlnode);
			#endif
		}
		avlnode = parent;
	}
}

/* For internal use */
#undef AVL_TMPL_node_count
#undef AVL_TMPL_l_count
#undef AVL_TMPL_r_count
#undef AVL_TMPL_calc_count
#undef AVL_TMPL_node_depth
#undef AVL_TMPL_l_depth
#undef AVL_TMPL_r_depth
#undef AVL_TMPL_calc_depth
