/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef AVL_NS_NAME
  #error AVL_NS_NAME is defunct.
#endif
#ifdef AVL_TMPL_NS_NAME
  #error AVL_TMPL_NS_NAME is defunct.
#endif

#ifndef AVL_NS
  #define AVL_NS(x) TREEDB_NS(AvlIntTree_##x)
#endif

#ifndef AVL_NS_unpack_node_DEFAULT
  #define AVL_NS_unpack_node_DEFAULT(x) \
    (AVL_NS(node_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef AVL_NS_unpack_node
  #define AVL_NS_unpack_node(x) AVL_NS_unpack_node_default(x)
#endif

#ifndef AVL_NS_unpack_tree_DEFAULT
  #define AVL_NS_unpack_tree_DEFAULT(x) \
    (AVL_NS(tree_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef AVL_NS_unpack_tree
  #define AVL_NS_unpack_tree(x) AVL_NS_unpack_tree_default(x)
#endif

#ifndef MAKE_AVL_TREE
  #define MAKE_AVL_TREE(x) (& runtime->m_pTreedb->x)
#endif

#ifndef MAKE_PACKED_AVL_TREE
  #define MAKE_PACKED_AVL_TREE(NS, X) \
    NS(pack_tree)(runtime, MAKE_AVL_TREE(X))
#endif

#ifndef AVL_cmp
  #define AVL_cmp(a, b) ((a) < (b) ? -1 : (a) == (b) ? 0 : 1)
#endif

#ifndef AVL_NO_TYPES

  #ifndef AVL_omit_treedb_impl

    #ifndef AVL_TREE_MEMBER
      #error Define AVL_TREE_MEMBER to something like m_int_tree.
    #endif
    #ifndef AVL_TREE
      #define AVL_TREE (& runtime->m_pTreedb->AVL_TREE_MEMBER)
    #endif

    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) AVL_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER AVL_TREE_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(tree_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef AVL_omit_treedb_impl */

  #include <treedb/avl-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) AVL_TMPL_NS(runtime_t);
  #define AVL_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-template.h>
  #include <treedb/avl-template-cleardefs.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef AVL_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef AVL_NO_TYPES */

#ifndef AVL_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-defines.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifndef AVL_omit_impl_alloc_node
    #ifdef AVL_CAN_CLONE_POINTER

/** AVL_TMPL_NS(impl_alloc_node)

We need to take extra steps in case we're called from clone() as we're passed
a pointer to data in the heap.
*/
AVL_TMPL_prefix AVL_TMPL_NS(node_ptr_t) AVL_TMPL_NS(impl_alloc_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_input_t d
) {
	AVL_TMPL_input_t data = d;
	AVL_TMPL_packed_ptr_t hdata = 0;
	int in_heap = TREEDB_in_heap(d);
	if(in_heap)
		hdata = TREEDB_pack_pointer(data);
	AVL_TMPL_size_t sz = AVL_NS_ALLOC_SIZE(runtime, d);
	AVL_TMPL_NS(node_ptr_t) ret
		= (AVL_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	if(in_heap)
		data = (AVL_TMPL_input_t)TREEDB_unpack_pointer(hdata);
	AVL_NS_STORE_DATA(ret, data);
	return ret;
}
    #else
AVL_TMPL_prefix AVL_TMPL_NS(node_ptr_t) AVL_TMPL_NS(impl_alloc_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_input_t d
) {
	AVL_TMPL_size_t sz = AVL_NS_ALLOC_SIZE(runtime, d);
	AVL_TMPL_NS(node_ptr_t) ret = (AVL_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	AVL_NS_STORE_DATA(ret, d);
	return ret;
}
    #endif /*#ifdef AVL_CAN_CLONE_POINTER*/
  #endif /* #ifndef AVL_omit_alloc_node */

  #ifndef AVL_omit_impl_free_node
AVL_TMPL_prefix void AVL_TMPL_NS(impl_free_node)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_NS(node_ptr_t) p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifndef AVL_omit_impl_free_tree
AVL_TMPL_prefix void AVL_TMPL_NS(impl_free_tree)
( AVL_TMPL_runtime_ptr_t runtime
, AVL_TMPL_NS(tree_ptr_t) p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-template-impl.h>

  #include <treedb/avl-template-cleardefs.h>
  #ifndef AVL_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef AVL_NO_IMPL */

#ifndef AVL_NO_CLEARDEFS
  #include <treedb/avl-cleardefs.h>
#else
  #undef AVL_NO_CLEARDEFS
#endif
