/*
This file is a modified version of avl2.h generated by Makefile.am
*/
/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef AVL2_NS_NAME
  #error AVL2_NS_NAME is defunct.
#endif
#ifdef AVL2_TMPL_NS_NAME
  #error AVL2_TMPL_NS_NAME is defunct.
#endif

#ifndef AVL2_NS
  #define AVL2_NS(x) TREEDB_NS(AvlIntTree_##x)
#endif

#ifndef AVL2_NS_unpack_node_DEFAULT
  #define AVL2_NS_unpack_node_DEFAULT(x) \
    (AVL2_NS(node_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef AVL2_NS_unpack_node
  #define AVL2_NS_unpack_node(x) AVL2_NS_unpack_node_default(x)
#endif

#ifndef AVL2_NS_unpack_tree_DEFAULT
  #define AVL2_NS_unpack_tree_DEFAULT(x) \
    (AVL2_NS(tree_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef AVL2_NS_unpack_tree
  #define AVL2_NS_unpack_tree(x) AVL2_NS_unpack_tree_default(x)
#endif

#ifndef MAKE_AVL2_TREE
  #define MAKE_AVL2_TREE(x) (& runtime->m_pTreedb->x)
#endif

#ifndef MAKE_PACKED_AVL2_TREE
  #define MAKE_PACKED_AVL2_TREE(NS, X) \
    NS(pack_tree)(runtime, MAKE_AVL2_TREE(X))
#endif

#ifndef AVL2_cmp
  #define AVL2_cmp(a, b) ((a) < (b) ? -1 : (a) == (b) ? 0 : 1)
#endif

#ifndef AVL2_NO_TYPES

  #ifndef AVL2_omit_treedb_impl

    #ifndef AVL2_TREE_MEMBER
      #error Define AVL2_TREE_MEMBER to something like m_int_tree.
    #endif
    #ifndef AVL2_TREE
      #define AVL2_TREE (& runtime->m_pTreedb->AVL2_TREE_MEMBER)
    #endif

    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) AVL2_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER AVL2_TREE_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(tree_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef AVL2_omit_treedb_impl */

  #include <treedb/avl-defines2.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) AVL2_TMPL_NS(runtime_t);
  #define AVL2_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-template2.h>
  #include <treedb/avl-template-cleardefs2.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef AVL2_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef AVL2_NO_TYPES */

#ifndef AVL2_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-defines2.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifndef AVL2_omit_impl_alloc_node
    #ifdef AVL2_CAN_CLONE_POINTER

/** AVL2_TMPL_NS(impl_alloc_node)

We need to take extra steps in case we're called from clone() as we're passed
a pointer to data in the heap.
*/
AVL2_TMPL_prefix AVL2_TMPL_NS(node_ptr_t) AVL2_TMPL_NS(impl_alloc_node)
( AVL2_TMPL_runtime_ptr_t runtime
, AVL2_TMPL_input_t d
) {
	AVL2_TMPL_input_t data = d;
	AVL2_TMPL_packed_ptr_t hdata = 0;
	int in_heap = TREEDB_in_heap(d);
	if(in_heap)
		hdata = TREEDB_pack_pointer(data);
	AVL2_TMPL_size_t sz = AVL2_NS_ALLOC_SIZE(runtime, d);
	AVL2_TMPL_NS(node_ptr_t) ret
		= (AVL2_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	if(in_heap)
		data = (AVL2_TMPL_input_t)TREEDB_unpack_pointer(hdata);
	AVL2_NS_STORE_DATA(ret, data);
	return ret;
}
    #else
AVL2_TMPL_prefix AVL2_TMPL_NS(node_ptr_t) AVL2_TMPL_NS(impl_alloc_node)
( AVL2_TMPL_runtime_ptr_t runtime
, AVL2_TMPL_input_t d
) {
	AVL2_TMPL_size_t sz = AVL2_NS_ALLOC_SIZE(runtime, d);
	AVL2_TMPL_NS(node_ptr_t) ret = (AVL2_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	AVL2_NS_STORE_DATA(ret, d);
	return ret;
}
    #endif /*#ifdef AVL2_CAN_CLONE_POINTER*/
  #endif /* #ifndef AVL2_omit_alloc_node */

  #ifndef AVL2_omit_impl_free_node
AVL2_TMPL_prefix void AVL2_TMPL_NS(impl_free_node)
( AVL2_TMPL_runtime_ptr_t runtime
, AVL2_TMPL_NS(node_ptr_t) p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifndef AVL2_omit_impl_free_tree
AVL2_TMPL_prefix void AVL2_TMPL_NS(impl_free_tree)
( AVL2_TMPL_runtime_ptr_t runtime
, AVL2_TMPL_NS(tree_ptr_t) p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/avl-template-impl2.h>

  #include <treedb/avl-template-cleardefs2.h>
  #ifndef AVL2_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef AVL2_NO_IMPL */

#ifndef AVL2_NO_CLEARDEFS
  #include <treedb/avl-cleardefs2.h>
#else
  #undef AVL2_NO_CLEARDEFS
#endif
