/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_h_included
  #error Include "treedb.h" before this file.
#endif

/* 4. must-defines */
#ifndef ARRAY_TMPL_NS
  #error ARRAY_TMPL_NS is not defined. e.g. #define ARRAY_TMPL_NS(x) v3c_##x.
#endif

/* 5. types */
#ifndef ARRAY_TMPL_runtime_ptr_t
  #define ARRAY_TMPL_runtime_ptr_t ARRAY_TMPL_NS(runtime_ptr_t)
#endif
#ifndef ARRAY_TMPL_size_t
  #define ARRAY_TMPL_size_t uintptr_t
#endif
#ifndef ARRAY_TMPL_count_t
  #define ARRAY_TMPL_count_t TREEDB_NS_CONCAT(uint,_t)
#endif
#ifndef ARRAY_TMPL_ptr_t
  #define ARRAY_TMPL_ptr_t ARRAY_TMPL_NS(ptr_t)
#endif
#ifndef ARRAY_TMPL_ptr_ptr_t
  #define ARRAY_TMPL_ptr_ptr_t ARRAY_TMPL_NS(ptr_ptr_t)
#endif
#ifndef ARRAY_TMPL_packed_ptr_t
  #define ARRAY_TMPL_packed_ptr_t ARRAY_TMPL_count_t
#endif
#ifndef ARRAY_TMPL_packed2_ptr_t
  #define ARRAY_TMPL_packed2_ptr_t ARRAY_TMPL_count_t
#endif
#ifndef ARRAY_TMPL_data_t
  #define ARRAY_TMPL_data_t ARRAY_TMPL_NS(data_t)
#endif
#ifndef ARRAY_TMPL_input_t
  #define ARRAY_TMPL_input_t ARRAY_TMPL_NS(input_t)
#endif

/* 6. optional */
#ifndef ARRAY_TMPL_prefix
  #define ARRAY_TMPL_prefix static inline
#endif

/* 7. header - constants */

/* 8. array_t members */
#ifndef ARRAY_TMPL_count
  #define ARRAY_TMPL_count m_count
#endif
#ifndef ARRAY_TMPL_reserve
  #define ARRAY_TMPL_reserve m_reserve
#endif
#ifndef ARRAY_TMPL_increment
  #define ARRAY_TMPL_increment m_increment
#endif
#ifndef ARRAY_TMPL_items
  #define ARRAY_TMPL_items m_items
#endif

#ifndef ARRAY_TMPL_omit_template_impl_defines

  /* 9. must-defines
  */
  #if !(defined ARRAY_TMPL_omit_free || defined ARRAY_TMPL_omit_free_DECLARE)
    #if ! (defined ARRAY_TMPL_free || defined ARRAY_TMPL_free_packed)
      #error Neither ARRAY_TMPL_free_packed nor ARRAY_TMPL_free is defined.
    #endif
  #endif
  #ifndef ARRAY_TMPL_alloc
    #error ARRAY_TMPL_alloc is not defined.
  #endif
  #ifndef ARRAY_TMPL_realloc_packed
    #error ARRAY_TMPL_realloc_packed is not defined.
  #endif

  #ifndef ARRAY_TMPL_unpack_pointer
    #error ARRAY_TMPL_unpack_pointer is not defined.
  #endif
  #ifndef ARRAY_TMPL_pack_pointer
    #error ARRAY_TMPL_pack_pointer is not defined.
  #endif

  #ifndef ARRAY_TMPL_unpack_pointer2
    #define ARRAY_TMPL_unpack_pointer2(x) \
      (ARRAY_TMPL_unpack_pointer(*(ARRAY_TMPL_packed_ptr_t*) \
        ARRAY_TMPL_unpack_pointer(x)))
  #endif

  /* 10. optional
  */
  #ifndef ARRAY_TMPL_auto_data
    #define ARRAY_TMPL_auto_data(x) ARRAY_TMPL_data_t x
  #endif
  #ifndef ARRAY_TMPL_clear_entries
    #define ARRAY_TMPL_clear_entries(ha, begin, size) \
      ARRAY_TMPL_NS(clear_entries)(runtime, ha, begin, size)
  #endif
  #if !(defined ARRAY_TMPL_omit_free || defined ARRAY_TMPL_omit_free_DECLARE)
    #ifndef ARRAY_TMPL_free_packed
      #define ARRAY_TMPL_free_packed(ha) ARRAY_TMPL_free(ARRAY_TMPL_unpack(ha))
    #endif
  #endif
  #ifndef ARRAY_TMPL_memmove
    #define ARRAY_TMPL_memmove(to, from, size) memmove(to, from, size)
  #endif
  #ifndef ARRAY_TMPL_assign
    #define ARRAY_TMPL_assign(to, from) to = from
  #endif
  #ifndef ARRAY_TMPL_assign_to_auto
    #define ARRAY_TMPL_assign_to_auto(to, from) ARRAY_TMPL_assign(to, from)
  #endif
  #ifndef ARRAY_TMPL_assign_from_auto
    #define ARRAY_TMPL_assign_from_auto(to, from) ARRAY_TMPL_assign(to, from)
  #endif
  #ifndef ARRAY_TMPL_item
    #define ARRAY_TMPL_item(pa, n) (pa)->ARRAY_TMPL_items[n]
  #endif
  #ifndef ARRAY_TMPL_item_ptr
    #define ARRAY_TMPL_item_ptr(pa, n) (& ARRAY_TMPL_item(pa, n))
  #endif

  #ifndef ARRAY_TMPL_entry_size
    #define ARRAY_TMPL_entry_size sizeof(ARRAY_TMPL_data_t)
  #endif
  #ifndef ARRAY_TMPL_entry_align
    #define ARRAY_TMPL_entry_align __alignof(ARRAY_TMPL_data_t)
  #endif
  #ifndef ARRAY_TMPL_memcopy
    #define ARRAY_TMPL_memcopy(to, from, size) memcpy(to, from, size)
  #endif
  #ifndef ARRAY_TMPL_exceeds_count_limit
    #ifdef TREEDB_need_exceed_check
      #define ARRAY_TMPL_exceeds_count_limit(x) \
        ((x) > ((ARRAY_TMPL_size_t)((ARRAY_TMPL_count_t)-1)))
    #else
      #define ARRAY_TMPL_exceeds_count_limit(x) 0
    #endif
  #endif

  #ifndef ARRAY_TMPL_assign_array
    #define ARRAY_TMPL_assign_array(hha, pa) \
      *((ARRAY_TMPL_packed_ptr_t *)ARRAY_TMPL_unpack_pointer(hha)) \
        = ARRAY_TMPL_pack(pa);
  #endif

#endif /* #ifndef ARRAY_TMPL_omit_template_impl_defines */
