/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/offset.hpp>

#ifndef ARRAY_NS
  #define ARRAY_NS(x) TREEDB_NS(IntHandleArray_##x)
#endif

#ifndef MAKE_ARRAY
  #define MAKE_ARRAY(x) (& runtime->m_pTreedb->x)
#endif

#ifndef MAKE_PACKED_ARRAY
  #define MAKE_PACKED_ARRAY(NS, X) \
	NS(pack_array)(runtime, MAKE_ARRAY(X))
#endif

#ifndef ARRAY_size_t
  #define ARRAY_size_t uintptr_t
#endif

#ifndef ARRAY_NO_TYPES

  #ifndef ARRAY_omit_treedb_impl

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef ARRAY_omit_treedb_impl */

  #include <treedb/handle-array-defines.h>

  #ifndef ARRAY_omit_treedb_impl

    #ifndef ARRAY_MEMBER
      #define ARRAY_MEMBER m_int_handle_array
    #endif
    #ifndef PACKED_ARRAY
      #define PACKED_ARRAY (runtime->m_pTreedb->ARRAY_MEMBER)
    #endif
    #ifndef PACKED2_ARRAY
      #define PACKED2_ARRAY v3c_offsetof(TREEDB_NS(treedb_t), ARRAY_MEMBER)
    #endif
    #ifndef ARRAY
      #define ARRAY ((ARRAY_NS(ptr_t))ARRAY_unpack_pointer(PACKED_ARRAY))
    #endif
    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) ARRAY_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER ARRAY_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD ARRAY_count_t TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

  #endif /* #ifndef ARRAY_omit_treedb_impl */

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) ARRAY_TMPL_NS(runtime_t);
  #define ARRAY_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/handle-array-template.h>
  #include <treedb/handle-array-template-cleardefs.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef ARRAY_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef AVL_NO_TYPES */

#ifndef ARRAY_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/handle-array-defines.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifndef ARRAY_omit_impl_alloc
ARRAY_TMPL_prefix ARRAY_TMPL_NS(ptr_t) ARRAY_TMPL_NS(impl_alloc)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_count_t count
)
{
	ARRAY_TMPL_count_t size
		= V3C_ROUND_UP_T(ARRAY_TMPL_count_t, sizeof(ARRAY_TMPL_NS(array_t))
			, ARRAY_TMPL_entry_align) + count * ARRAY_TMPL_entry_size;
	return (ARRAY_TMPL_NS(ptr_t))TREEDB_malloc(size);
}
  #endif

  #ifndef ARRAY_omit_impl_realloc_packed
ARRAY_TMPL_prefix int ARRAY_TMPL_NS(impl_realloc_packed)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_packed2_ptr_t hha
, ARRAY_TMPL_count_t count
) {
	ARRAY_TMPL_count_t size
		= V3C_ROUND_UP_T(ARRAY_TMPL_count_t, sizeof(ARRAY_TMPL_NS(array_t))
			, ARRAY_TMPL_entry_align) + count * ARRAY_TMPL_entry_size;

	ARRAY_TMPL_ptr_t pa = (ARRAY_TMPL_ptr_t)TREEDB_realloc(ARRAY_TMPL_unpack2(hha), size);
	if(!pa)
		return 1;

	ARRAY_TMPL_assign_array(hha, pa);
	return 0;
}
  #endif

  #ifndef ARRAY_omit_impl_free
ARRAY_TMPL_prefix void ARRAY_TMPL_NS(impl_free)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_ptr_t p
)
{
	if(p) TREEDB_free(p);
}
  #endif

  #ifndef ARRAY_omit_impl_free_data
ARRAY_TMPL_prefix void ARRAY_TMPL_NS(impl_free_data)
( ARRAY_TMPL_runtime_ptr_t runtime
, ARRAY_TMPL_data_t p
)
{
	(void)runtime;
	(void)p;
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/handle-array-template-impl.h>
  #include <treedb/handle-array-template-cleardefs.h>

  #ifndef ARRAY_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef ARRAY_NO_IMPL */

#ifndef ARRAY_NO_CLEARDEFS
  #include <treedb/handle-array-cleardefs.h>
#else
  #undef ARRAY_NO_CLEARDEFS
#endif
