/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "list-template-defines.h"

#ifdef DOXYGEN_processing
}
#endif

#ifdef LIST_TMPL_omit_delete_node
  #ifndef LIST_TMPL_omit_clear
	#define LIST_TMPL_omit_clear
  #endif
  #ifndef LIST_TMPL_omit_remove_nodes
	#define LIST_TMPL_omit_remove_nodes
  #endif
#endif

#ifdef LIST_TMPL_omit_clear
  #ifndef LIST_TMPL_omit_free
	#define LIST_TMPL_omit_free
  #endif
  #ifndef LIST_TMPL_omit_clone
	#define LIST_TMPL_omit_clone
  #endif
#endif

#ifdef LIST_TMPL_omit_remove_nodes
  #ifndef LIST_TMPL_omit_remove_many
	#define LIST_TMPL_omit_remove_many
  #endif
#endif

#ifdef LIST_TMPL_omit_remove_many
  #ifndef LIST_TMPL_omit_remove
	#define LIST_TMPL_omit_remove
  #endif
#endif

/* 9. implementation : must-defines */
#ifndef LIST_TMPL_omit_free
  #ifndef LIST_TMPL_free
    #error LIST_TMPL_free is not defined.
  #endif
#endif
#ifndef LIST_TMPL_omit_push
  #ifndef LIST_TMPL_alloc_node
    #error LIST_TMPL_alloc_node is not defined.
  #endif
#endif
#ifndef LIST_TMPL_omit_delete_node
  #ifndef LIST_TMPL_free_node
    #error LIST_TMPL_free_node is not defined.
  #endif
#endif
#ifndef LIST_TMPL_unpack_pointer
  #error LIST_TMPL_unpack_pointer is not defined.
#endif
#ifndef LIST_TMPL_pack_pointer
  #error LIST_TMPL_pack_pointer is not defined.
#endif

/* 10. implementation : optional */
#ifndef LIST_TMPL_free_item_data
  #define LIST_TMPL_free_item_data(pItem)
#endif
#ifndef LIST_TMPL_free_packed_list
  #define LIST_TMPL_free_packed_list(u) \
	LIST_TMPL_free(LIST_TMPL_unpack_list(u))
#endif
#ifndef LIST_TMPL_free_list_pointer
  #define LIST_TMPL_free_list_pointer(plist) \
	LIST_TMPL_free(plist)
#endif
#ifndef LIST_TMPL_free_packed_node
#define LIST_TMPL_free_packed_node(pknode) \
	LIST_TMPL_free_node(LIST_TMPL_unpack_node(pknode))
#endif
#ifndef LIST_TMPL_free_node_pointer
#define LIST_TMPL_free_node_pointer(node) \
	LIST_TMPL_free_node(node)
#endif
#ifndef LIST_TMPL_omit_clone
  #ifndef LIST_TMPL_clone_node
    #define LIST_TMPL_clone_node(pn) LIST_TMPL_alloc_node(pn->LIST_TMPL_item)
  #endif
#endif

/* 11. implementation : insertion / extraction */
#ifndef LIST_TMPL_omit_unpack_list
  #ifndef LIST_TMPL_unpack_list
    #define LIST_TMPL_unpack_list(x) LIST_TMPL_NS(unpack_list)(runtime, x)
  #endif
LIST_TMPL_prefix LIST_TMPL_list_ptr_t
LIST_TMPL_NS(unpack_list)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
) {
	(void)runtime;
	void * c = LIST_TMPL_unpack_pointer(hl);
	LIST_TMPL_list_ptr_t ret = (LIST_TMPL_list_ptr_t)c;
	TREEDB_printf8("unpack_list : %lu -> %p\n"
		, (uintptr_t)hl, (void *)(uintptr_t)ret);
	return ret;
}
#endif
#ifndef LIST_TMPL_omit_pack_list
  #ifndef LIST_TMPL_pack_list
    #define LIST_TMPL_pack_list(x) LIST_TMPL_NS(pack_list)(runtime, x)
  #endif
LIST_TMPL_prefix LIST_TMPL_packed_list_ptr_t
LIST_TMPL_NS(pack_list)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t p
) {
	(void)runtime;
	LIST_TMPL_packed_list_ptr_t ret = LIST_TMPL_pack_pointer(p);
	TREEDB_printf8("pack_list : %p -> %lu\n"
		, (void *)(uintptr_t)p, (uintptr_t)ret);
	return ret;
}
#endif
#ifndef LIST_TMPL_omit_unpack_node
  #ifndef LIST_TMPL_unpack_node
    #define LIST_TMPL_unpack_node(x) LIST_TMPL_NS(unpack_node)(runtime, x)
  #endif
LIST_TMPL_prefix LIST_TMPL_node_ptr_t
LIST_TMPL_NS(unpack_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_node_ptr_t hn
) {
	(void)runtime;
	void * c = LIST_TMPL_unpack_pointer(hn);
	LIST_TMPL_node_ptr_t ret = (LIST_TMPL_node_ptr_t)c;
	TREEDB_printf8("unpack_node : %lu -> %p\n"
		, (uintptr_t)hn, (void *)(uintptr_t)ret);
	return ret;
}
#endif
#ifndef LIST_TMPL_omit_pack_node
  #ifndef LIST_TMPL_pack_node
    #define LIST_TMPL_pack_node(x) LIST_TMPL_NS(pack_node)(runtime, x)
  #endif
LIST_TMPL_prefix LIST_TMPL_packed_node_ptr_t
LIST_TMPL_NS(pack_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_node_ptr_t pn
) {
	(void)runtime;
	LIST_TMPL_packed_node_ptr_t ret = LIST_TMPL_pack_pointer(pn);
	TREEDB_printf8("pack_node : %p -> %lu\n"
		, (void *)(uintptr_t)pn, (uintptr_t)ret);
	return ret;
}
#endif

/**
Initialise a list.

The storage used must be write locked.
*/
LIST_TMPL_prefix LIST_TMPL_list_ptr_t LIST_TMPL_NS(init)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
) {
	pl->LIST_TMPL_head = pl->LIST_TMPL_tail
		= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
#ifdef LIST_TMPL_have_count
	pl->LIST_TMPL_count = 0;
#endif
	return pl;
}

#ifndef LIST_TMPL_omit_free
/**
Free a list and it's nodes.

The storage used must be write locked.
*/
LIST_TMPL_prefix void LIST_TMPL_NS(free)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
) {
	LIST_TMPL_NS(clear)(runtime, hl);
	LIST_TMPL_free_packed_list(hl);
	/*L2LIST = 0;*/
}
#endif
/**
Free list nodes.

The storage used must be write locked.
*/
LIST_TMPL_prefix void LIST_TMPL_NS(clear)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
) {
	LIST_TMPL_node_ptr_t node
		= LIST_TMPL_unpack_node(LIST_TMPL_unpack_list(hl)->LIST_TMPL_head);
	LIST_TMPL_packed_node_ptr_t next, pknode;
	(void)pknode; /* Its usage depends on the macros - keep the compiler happy*/
	for(; node; node = LIST_TMPL_unpack_node(next)) {
		next = node->LIST_TMPL_next;
		/* Store the offset as the memory may move. */
		pknode = LIST_TMPL_pack_node(node);
		LIST_TMPL_free_item_data(node->LIST_TMPL_item);
		LIST_TMPL_free_packed_node(pknode);
	}
	LIST_TMPL_NS(init)(runtime, LIST_TMPL_unpack_list(hl));
}
#ifndef LIST_TMPL_omit_clone
/** Make a copy (clone) of another list.

The storage used must be write locked.

The destination list must be initialised first.

If the destination list isn't empty, it is cleared.

If the allocator runs out of memory, the copy is cleared and clone() fails.
*/
LIST_TMPL_prefix int LIST_TMPL_NS(clone)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl_to
, LIST_TMPL_packed_list_ptr_t hl_from
) {
	LIST_TMPL_node_ptr_t node2
		= LIST_TMPL_unpack_node(LIST_TMPL_unpack_list(hl_to)->LIST_TMPL_head);
	if(node2)
		LIST_TMPL_NS(clear)(runtime, hl_to);
	LIST_TMPL_node_ptr_t node
		= LIST_TMPL_unpack_node(LIST_TMPL_unpack_list(hl_from)->LIST_TMPL_head);
	LIST_TMPL_packed_node_ptr_t next;
	for(; node; node = LIST_TMPL_unpack_node(next)) {
		next = node->LIST_TMPL_next;
		node2 = LIST_TMPL_clone_node(node);
		if(!node2) {
			LIST_TMPL_NS(clear)(runtime, hl_to);
			return 1;
		}
		LIST_TMPL_NS(push_back_node)(runtime, LIST_TMPL_unpack_list(hl_to), node2);
	}
	return 0;
}
#endif

LIST_TMPL_prefix LIST_TMPL_size_t LIST_TMPL_NS(count)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
) {
#ifdef LIST_TMPL_have_count
	(void)runtime;
	return pl->LIST_TMPL_count;
#else
	LIST_TMPL_size_t res = 0;
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(pl->LIST_TMPL_head);
	while(node) {
		++res;
		node = LIST_TMPL_unpack_node(node->LIST_TMPL_next);
	}
	return res;
#endif
}

LIST_TMPL_node_ptr_t LIST_TMPL_NS(push_back_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t newnode
) {
	newnode->LIST_TMPL_next = newnode->LIST_TMPL_prev
		= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
	LIST_TMPL_packed_node_ptr_t u = LIST_TMPL_pack_node(newnode);

	if(!LIST_TMPL_unpack_node(pl->LIST_TMPL_tail)) {
		pl->LIST_TMPL_head = pl->LIST_TMPL_tail = u;
#ifdef LIST_TMPL_have_count
		pl->LIST_TMPL_count = 1;
#endif
		return newnode;
	}
	LIST_TMPL_unpack_node(pl->LIST_TMPL_tail)->LIST_TMPL_next = u;
	newnode->LIST_TMPL_prev = pl->LIST_TMPL_tail;
	pl->LIST_TMPL_tail = u;
#ifdef LIST_TMPL_have_count
	++pl->LIST_TMPL_count;
#endif
	return newnode;
}
LIST_TMPL_prefix LIST_TMPL_node_ptr_t LIST_TMPL_NS(push_front_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t newnode
) {
	newnode->LIST_TMPL_next = newnode->LIST_TMPL_prev
		= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
	LIST_TMPL_packed_node_ptr_t u = LIST_TMPL_pack_node(newnode);

	if(!LIST_TMPL_unpack_node(pl->LIST_TMPL_head)) {
		pl->LIST_TMPL_head = pl->LIST_TMPL_tail = u;
#ifdef LIST_TMPL_have_count
		pl->LIST_TMPL_count = 1;
#endif
		return newnode;
	}
	LIST_TMPL_unpack_node(pl->LIST_TMPL_head)->LIST_TMPL_prev = u;
	newnode->LIST_TMPL_next = pl->LIST_TMPL_head;
	pl->LIST_TMPL_head = u;
#ifdef LIST_TMPL_have_count
	++pl->LIST_TMPL_count;
#endif
	return newnode;
}
LIST_TMPL_prefix void LIST_TMPL_NS(insert_node_before)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t node
, LIST_TMPL_node_ptr_t newnode
) {
	if(!node) {
		/* Insert before <null> means push_back - before nothing. */
		LIST_TMPL_NS(push_back_node)(runtime, pl, newnode);
		return;
	}
	if(node == LIST_TMPL_unpack_node(pl->LIST_TMPL_head)) {
		LIST_TMPL_NS(push_front_node)(runtime, pl, newnode);
		return;
	}
	/* node isn't at the head, so newnode has nodes before and after it. */
	newnode->LIST_TMPL_next = LIST_TMPL_pack_node(node);
	newnode->LIST_TMPL_prev = node->LIST_TMPL_prev;
	node->LIST_TMPL_prev = LIST_TMPL_unpack_node(newnode->LIST_TMPL_prev)->LIST_TMPL_next
		= LIST_TMPL_pack_node(newnode);
#ifdef LIST_TMPL_have_count
	++pl->LIST_TMPL_count;
#endif
}
LIST_TMPL_prefix void LIST_TMPL_NS(insert_node_after)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t node
, LIST_TMPL_node_ptr_t newnode
) {
	if(!node) {
		/* Insert after <null> means push_front - after nothing. */
		LIST_TMPL_NS(push_front_node)(runtime, pl, newnode);
		return;
	}
	if(node == LIST_TMPL_unpack_node(pl->LIST_TMPL_tail)) {
		LIST_TMPL_NS(push_back_node)(runtime, pl, newnode);
		return;
	}
	/* node isn't at the tail, so newnode has nodes before and after it. */
	newnode->LIST_TMPL_prev = LIST_TMPL_pack_node(node);
	newnode->LIST_TMPL_next = node->LIST_TMPL_next;
	node->LIST_TMPL_next = LIST_TMPL_unpack_node(newnode->LIST_TMPL_next)->LIST_TMPL_prev
		= LIST_TMPL_pack_node(newnode);
#ifdef LIST_TMPL_have_count
	++pl->LIST_TMPL_count;
#endif
}
LIST_TMPL_prefix void LIST_TMPL_NS(relink_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t node
) {
	if(!node)
		return; /* ? */
	if(node->LIST_TMPL_prev)
		LIST_TMPL_NS(insert_node_after)(runtime, pl
			, LIST_TMPL_unpack_node(node->LIST_TMPL_prev), node);
	else
		LIST_TMPL_NS(insert_node_before)(runtime, pl
			, LIST_TMPL_unpack_node(node->LIST_TMPL_next), node);
}
#ifndef LIST_TMPL_omit_push
LIST_TMPL_prefix LIST_TMPL_node_ptr_t LIST_TMPL_NS(push_back)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_input_t d
) {
	LIST_TMPL_node_ptr_t newnode = LIST_TMPL_alloc_node(d);
	if(!newnode)
		return newnode;
	return LIST_TMPL_NS(push_back_node)
		(runtime, LIST_TMPL_unpack_list(hl), newnode);
}
LIST_TMPL_prefix LIST_TMPL_node_ptr_t LIST_TMPL_NS(push_front)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_input_t d
) {
	LIST_TMPL_node_ptr_t newnode = LIST_TMPL_alloc_node(d);
	if(!newnode)
		return newnode;
	return LIST_TMPL_NS(push_front_node)
		(runtime, LIST_TMPL_unpack_list(hl), newnode);
}
#endif
#ifndef LIST_TMPL_omit_remove_nodes
LIST_TMPL_prefix int LIST_TMPL_NS(remove_nodes)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_packed_node_ptr_t start
, LIST_TMPL_size_t count
) {
	if(!start)
		return 1;
  #ifdef LIST_TMPL_have_count
	LIST_TMPL_list_ptr_t pl = LIST_TMPL_unpack_list(hl);
	if(count > pl->LIST_TMPL_count)
		return 2;
  #endif
	LIST_TMPL_count_t remaining = 0;
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(start);
	while(node) {
		++remaining;
		node = LIST_TMPL_unpack_node(node->LIST_TMPL_next);
		if(!node)
			return 3;
	}
	if(!node)
		return 4;
	--remaining;
	if(remaining < count)
		return 5;
	while(count) {
		node = LIST_TMPL_unpack_node(start);
		start = node->LIST_TMPL_next;
		LIST_TMPL_list_ptr_t pl = LIST_TMPL_unpack_list(hl);
		LIST_TMPL_NS(unlink_node)(runtime, pl, node);
		LIST_TMPL_NS(delete_node)(runtime, hl, node);
		--count;
	}
  #ifdef LIST_TMPL_have_count
	pl = LIST_TMPL_unpack_list(hl);
	pl->LIST_TMPL_count -= count;
  #endif
	return 0;
}
#endif
#ifndef LIST_TMPL_omit_remove_many
LIST_TMPL_prefix int LIST_TMPL_NS(remove_many)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_size_t where
, LIST_TMPL_size_t count
) {
	if(!count)
		return 0;
	LIST_TMPL_list_ptr_t pl = LIST_TMPL_unpack_list(hl);
  #ifdef LIST_TMPL_have_count
	if((where + count - 1) >= pl->LIST_TMPL_count)
		return 1;
  #endif
	if(!pl->LIST_TMPL_tail)
		return 2;
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(pl->LIST_TMPL_head);
	if(!node)
		return 3;
	LIST_TMPL_count_t n = 0;
	while(n < where) {
		++n;
		node = LIST_TMPL_unpack_node(node->LIST_TMPL_next);
		if(!node)
			return 4;
	}
	return LIST_TMPL_NS(remove_nodes)(runtime, hl, LIST_TMPL_pack_node(node), count)
		? 5 : 0;
}
LIST_TMPL_prefix int LIST_TMPL_NS(remove)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_size_t where
) {
	return LIST_TMPL_NS(remove_many)(runtime, hl, where, 1);
}
#endif
#ifndef LIST_TMPL_omit_pop
LIST_TMPL_prefix int LIST_TMPL_NS(pop_back)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
) {
	LIST_TMPL_list_ptr_t pl = LIST_TMPL_unpack_list(hl);
	if(!pl->LIST_TMPL_tail)
		return 1;
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(pl->LIST_TMPL_tail);
	if(pl->LIST_TMPL_tail == pl->LIST_TMPL_head) {
		/* Store the offset as the memory may move. */
		LIST_TMPL_packed_node_ptr_t pknode = LIST_TMPL_pack_node(node);
		LIST_TMPL_free_item_data(node->LIST_TMPL_item);
		LIST_TMPL_free_packed_node(pknode);
		pl = LIST_TMPL_unpack_list(hl);
		pl->LIST_TMPL_tail = pl->LIST_TMPL_head
			= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
  #ifdef LIST_TMPL_have_count
		pl->LIST_TMPL_count = 0;
  #endif
		return 0;
	}
	LIST_TMPL_unpack_node(node->LIST_TMPL_prev)->LIST_TMPL_next
		= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
	pl->LIST_TMPL_tail = node->LIST_TMPL_prev;
	/* Store the offset as the memory may move. */
	LIST_TMPL_packed_node_ptr_t pknode = LIST_TMPL_pack_node(node);
	LIST_TMPL_free_item_data(node->LIST_TMPL_item);
	LIST_TMPL_free_packed_node(pknode);
  #ifdef LIST_TMPL_have_count
	pl = LIST_TMPL_unpack_list(hl);
	--pl->LIST_TMPL_count;
  #endif
	return 0;
}
LIST_TMPL_prefix int LIST_TMPL_NS(pop_back_many)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_size_t count
) {
	if(count > LIST_TMPL_NS(count)(runtime, LIST_TMPL_unpack_list(hl)))
		return 1;
	while(count) {
		LIST_TMPL_NS(pop_back)(runtime, hl);
		--count;
	}
	return 0;
}
LIST_TMPL_prefix int LIST_TMPL_NS(pop_front)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
) {
	LIST_TMPL_list_ptr_t pl = LIST_TMPL_unpack_list(hl);
	if(!pl->LIST_TMPL_head)
		return 1;
	LIST_TMPL_node_ptr_t node
		= LIST_TMPL_unpack_node(pl->LIST_TMPL_head);
	if(pl->LIST_TMPL_tail == pl->LIST_TMPL_head) {
		/* Store the offset as the memory may move. */
		LIST_TMPL_packed_node_ptr_t pknode = LIST_TMPL_pack_node(node);
		LIST_TMPL_free_item_data(node->LIST_TMPL_item);
		LIST_TMPL_free_packed_node(pknode);
		pl = LIST_TMPL_unpack_list(hl);
		pl->LIST_TMPL_tail = pl->LIST_TMPL_head
			= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
  #ifdef LIST_TMPL_have_count
		pl->LIST_TMPL_count = 0;
  #endif
		return 0;
	}
	LIST_TMPL_unpack_node(node->LIST_TMPL_next)->LIST_TMPL_prev
		= LIST_TMPL_pack_node((LIST_TMPL_node_ptr_t)0);
	pl->LIST_TMPL_head = node->LIST_TMPL_next;
	/* Store the offset as the memory may move. */
	LIST_TMPL_packed_node_ptr_t pknode = LIST_TMPL_pack_node(node);
	LIST_TMPL_free_item_data(node->LIST_TMPL_item);
	LIST_TMPL_free_packed_node(pknode);
  #ifdef LIST_TMPL_have_count
	pl = LIST_TMPL_unpack_list(hl);
	--pl->LIST_TMPL_count;
  #endif
	return 0;
}
LIST_TMPL_prefix int LIST_TMPL_NS(pop_front_many)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_size_t count
) {
	if(count > LIST_TMPL_NS(count)(runtime, LIST_TMPL_unpack_list(hl)))
		return 1;
	while(count) {
		LIST_TMPL_NS(pop_front)(runtime, hl);
		--count;
	}
	return 0;
}
#endif
LIST_TMPL_prefix int LIST_TMPL_NS(reverse_some)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_size_t where
, LIST_TMPL_size_t count
) {
	if(!pl->LIST_TMPL_tail)
		return 1;
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(pl->LIST_TMPL_head);
	if(!node)
		return 2;
	LIST_TMPL_count_t n = 0;
	while(n < where) {
		++n;
		node = LIST_TMPL_unpack_node(node->LIST_TMPL_next);
		if(!node)
			return 2;
	}
	LIST_TMPL_count_t remaining = 0;
	LIST_TMPL_node_ptr_t node2 = node;
	while(node2) {
		++remaining;
		node2 = LIST_TMPL_unpack_node(node2->LIST_TMPL_next);
		if(!node2)
			return 2;
	}
	if(!node2)
		return 2;
	--remaining;
	if(remaining < count)
		return 3;
	LIST_TMPL_packed_node_ptr_t prev = node->LIST_TMPL_prev;
	LIST_TMPL_packed_node_ptr_t next = node2->LIST_TMPL_next;
	LIST_TMPL_packed_node_ptr_t u;
	node2 = node;
	while(count) {
		u = node->LIST_TMPL_next;
		node->LIST_TMPL_next = node->LIST_TMPL_prev;
		node->LIST_TMPL_prev = u;
		node = LIST_TMPL_unpack_node(u);
		--count;
	}
	if(prev)
		LIST_TMPL_unpack_node(prev)->LIST_TMPL_next = LIST_TMPL_pack_node(node);
	else
		pl->LIST_TMPL_head = LIST_TMPL_pack_node(node);
	if(next)
		LIST_TMPL_unpack_node(next)->LIST_TMPL_prev = LIST_TMPL_pack_node(node2);
	else
		pl->LIST_TMPL_tail = LIST_TMPL_pack_node(node2);
	return 0;
}
LIST_TMPL_prefix void LIST_TMPL_NS(reverse)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
) {
	LIST_TMPL_node_ptr_t node = LIST_TMPL_unpack_node(pl->LIST_TMPL_head);
	LIST_TMPL_packed_node_ptr_t u;
	while(node) {
		u = node->LIST_TMPL_next;
		node->LIST_TMPL_next = node->LIST_TMPL_prev;
		node->LIST_TMPL_prev = u;
		node = LIST_TMPL_unpack_node(u);
	}
	u = pl->LIST_TMPL_head;
	pl->LIST_TMPL_head = pl->LIST_TMPL_tail;
	pl->LIST_TMPL_tail = u;
}
LIST_TMPL_prefix void LIST_TMPL_NS(unlink_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_list_ptr_t pl
, LIST_TMPL_node_ptr_t node
) {
	if(node->LIST_TMPL_prev)
		LIST_TMPL_unpack_node(node->LIST_TMPL_prev)->LIST_TMPL_next
			= node->LIST_TMPL_next;
	else
		pl->LIST_TMPL_head = node->LIST_TMPL_next;

	if(node->LIST_TMPL_next)
		LIST_TMPL_unpack_node(node->LIST_TMPL_next)->LIST_TMPL_prev
			= node->LIST_TMPL_prev;
	else
		pl->LIST_TMPL_tail = node->LIST_TMPL_prev;
#ifdef LIST_TMPL_have_count
	--pl->LIST_TMPL_count;
#endif
}

#ifndef LIST_TMPL_omit_delete_node
LIST_TMPL_prefix void LIST_TMPL_NS(delete_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_packed_list_ptr_t hl
, LIST_TMPL_node_ptr_t node
) {
	if(!node)
		return;
	LIST_TMPL_NS(unlink_node)(runtime, LIST_TMPL_unpack_list(hl), node);
	/* Store the offset as the memory may move. */
	LIST_TMPL_packed_node_ptr_t pknode = LIST_TMPL_pack_node(node);
	LIST_TMPL_free_item_data(node->LIST_TMPL_item);
	LIST_TMPL_free_packed_node(pknode);
}
#endif
