/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/offset.hpp>

#ifndef LIST_NS
  #define LIST_NS(x) TREEDB_NS(IntList_##x)
#endif

#ifndef LIST_NS_unpack_node_DEFAULT
  #define LIST_NS_unpack_node_DEFAULT(x) \
    (LIST_NS(node_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef LIST_NS_unpack_node
  #define LIST_NS_unpack_node(x) LIST_NS_unpack_node_default(x)
#endif

#ifndef LIST_NS_unpack_list_DEFAULT
  #define LIST_NS_unpack_list_DEFAULT(x) \
    (LIST_NS(tree_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef LIST_NS_unpack_list
  #define LIST_NS_unpack_list(x) LIST_NS_unpack_list_default(x)
#endif

#ifndef MAKE_LIST
  #define MAKE_LIST(x) (& runtime->m_pTreedb->x)
#endif

#ifndef MAKE_PACKED_LIST
  #define MAKE_PACKED_LIST(NS, X) v3c_offsetof(TREEDB_NS(treedb_t), X)
#endif

#ifndef LIST_NO_TYPES

  #ifndef LIST_MEMBER
    #error Define LIST_MEMBER to something like m_int_list.
  #endif
  #ifndef LIST
    #define LIST (& runtime->m_pTreedb->LIST_MEMBER)
  #endif

  #ifndef LIST_omit_treedb_impl

    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) LIST_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER LIST_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(list_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef LIST_omit_treedb_impl */

  #include <treedb/list-defines.h>

  #ifndef LIST_omit_runtime_t_typedef
    #ifdef __cplusplus
extern "C" {
    #endif

typedef TREEDB_NS(runtime_t) LIST_NS(runtime_t);

    #ifdef __cplusplus
} // extern "C" {
    #endif
  #endif /* #ifndef LIST_omit_runtime_t_typedef */

  #ifdef DOXYGEN_processing
{
  #endif

  #include "list-template.h"
  #include "list-template-cleardefs.h"

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef LIST_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef LIST_NO_TYPES */

#ifndef LIST_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/list-defines.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifndef LIST_omit_impl_alloc_node
    #ifdef LIST_CAN_CLONE_POINTER

/** LIST_TMPL_NS(impl_alloc_node)

We need to take extra steps in case we're called from clone() as we're passed
a pointer to data in the heap.
*/
LIST_TMPL_prefix LIST_TMPL_NS(node_ptr_t) LIST_TMPL_NS(impl_alloc_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_input_t d
) {
	LIST_TMPL_input_t data = d;
	LIST_TMPL_packed_ptr_t hdata = 0;
	int in_heap = TREEDB_in_heap(d);
	if(in_heap)
		hdata = TREEDB_pack_pointer(data);
	size_t sz = LIST_NS_ALLOC_SIZE(runtime, d);
	LIST_TMPL_NS(node_ptr_t) ret
		= (LIST_TMPL_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	if(in_heap)
		data = (LIST_TMPL_input_t)TREEDB_unpack_pointer(hdata);
	LIST_NS_STORE_DATA(ret, data);
	return ret;
}
    #else
LIST_TMPL_prefix LIST_TMPL_NS(node_ptr_t) LIST_TMPL_NS(impl_alloc_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_TMPL_input_t d
) {
	size_t sz = LIST_NS_ALLOC_SIZE(runtime, d);
	LIST_NS(node_ptr_t) ret = (LIST_NS(node_ptr_t))TREEDB_malloc(sz);
	if(!ret)
		return 0;
	LIST_NS_STORE_DATA(ret, d);
	return ret;
}
    #endif /* #ifdef AVL_CAN_CLONE_POINTER */
  #endif /* #ifndef AVL_omit_impl_alloc_node */

  #ifndef LIST_omit_impl_free_node
void LIST_NS(impl_free_node)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_NS(node_ptr_t) p
) {
	(void)runtime;
	if(p) TREEDB_free(p);
}
  #endif

  #ifndef LIST_omit_impl_free_list
void LIST_NS(impl_free_list)
( LIST_TMPL_runtime_ptr_t runtime
, LIST_NS(list_ptr_t) p
) {
	(void)runtime;
	(void)p;
	if(p) TREEDB_free(p);
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/list-template-impl.h>
  #include <treedb/list-template-cleardefs.h>

  #ifndef LIST_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef LIST_NO_IMPL */

#ifndef LIST_NO_CLEARDEFS
  #include <treedb/list-cleardefs.h>
#else
  #undef LIST_NO_CLEARDEFS
#endif
