/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "multi-varray-checkdefs.h"

#ifdef DOXYGEN_processing
}
#endif

#ifndef MVARRAY_NS
  #define MVARRAY_NS(x) TREEDB_NS(MVarrayString_##x)
  #define MVARRAY_NS_UNPACK(x) TREEDB_PAYLOAD_NS(unpack)(runtime, x)
  #define STRING_MVARRAY (& runtime->m_pTreedb->m_mvarray)
  #define PACKED_STRING_MVARRAY \
    TREEDB_NS(impl_pack_pointer)(runtime, STRING_MVARRAY)
#endif

#ifndef MVARRAY_NO_TYPES
  #ifndef TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) TREEDB_NS(MVarrayString_##x)
      #define TREEDB_PAYLOAD_FIRST_MEMBER m_mvarray
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(array_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include "treedb/ns-types.h"

    #ifdef DOXYGEN_processing
}
    #endif

  #endif

  #define MVARRAY_NS(x)              TREEDB_NS(MVarrayString_##x)
  #define MVARRAY_size_t             TREEDB_NS_CONCAT(uint,_t)
  #define MVARRAY_input_t            MVARRAY_const_char_ptr_t
  #define MVARRAY_OFFSET_data_ptr_t  MVARRAY_size_ptr_t
  #define MVARRAY_PAYLOAD_data_ptr_t MVARRAY_char_ptr_t

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) MVARRAY_NS(runtime_t);
typedef TREEDB_NS(runtime_ptr_t) MVARRAY_NS(runtime_ptr_t);
typedef MVARRAY_size_t * MVARRAY_size_ptr_t;
typedef char * MVARRAY_char_ptr_t;
typedef const char * MVARRAY_const_char_ptr_t;

  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include "multi-varray.h"
  #include "multi-varray-helper.h"
  #include "multi-varray-helper-cleardefs.h"

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef TREEDB_MULTIPLE_PAYLOAD_ENTRIES
	#include "treedb/storage.h"
  #else
	#ifndef TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
	  #include "treedb/storage.h"
	#endif
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef MVARRAY_NO_TYPES */

#ifndef MVARRAY_NO_IMPL

  #define MVARRAY_NS(x)              TREEDB_NS(MVarrayString_##x)
  #define MVARRAY_size_t             TREEDB_NS_CONCAT(uint,_t)
  #define MVARRAY_input_t            MVARRAY_const_char_ptr_t
  #define MVARRAY_OFFSET_data_ptr_t  MVARRAY_size_ptr_t
  #define MVARRAY_PAYLOAD_data_ptr_t MVARRAY_char_ptr_t

  #ifdef DOXYGEN_processing
{
  #endif

  #include "multi-varray-helper-defines.h"

  #define MVARRAY_clear_entries(ha, begin, size) 0
  #define MVARRAY_entry_align 1
  #include "multi-varray-impl.h"
  #include "multi-varray-helper.h"

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

PVOID MVARRAY_NS(impl_alloc)
( MVARRAY_NS(runtime_ptr_t) runtime
, MVARRAY_size_t size
) {
	return TREEDB_malloc(size);
}
void MVARRAY_NS(impl_free)
( MVARRAY_NS(runtime_ptr_t) runtime
, PVOID p
) {
	if(p) TREEDB_free(p);
}
PVOID MVARRAY_NS(impl_realloc)
( MVARRAY_NS(runtime_ptr_t) runtime
, PVOID pv
, MVARRAY_size_t size
) {
	return TREEDB_realloc(pv, size);
}
int MVARRAY_NS(offset_impl_realloc_packed)
( MVARRAY_NS(runtime_ptr_t) runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_count_t count
) {
	MVARRAY_count_t size = count * sizeof(MVARRAY_count_t);
	MVARRAY_NS(varray_offset_array_ptr_t) pa
		= MVARRAY_NS(varray_offset_unpack_array)(runtime, ha);
	MVARRAY_count_t * pd
		= (MVARRAY_count_t *)TREEDB_realloc
			(MVARRAY_NS(varray_offset_unpack_data)(runtime, pa->m_items), size);
	if(!pd)
		return 1;
	pa = MVARRAY_NS(varray_offset_unpack_array)(runtime, ha);
	pa->m_items = MVARRAY_NS(varray_offset_pack_data)(runtime, pd);
	return 0;
}
int MVARRAY_NS(payload_impl_realloc_packed)
( MVARRAY_NS(runtime_ptr_t) runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_count_t count
) {
	MVARRAY_count_t size = count;
	MVARRAY_NS(varray_payload_array_ptr_t) pa
		= MVARRAY_NS(varray_payload_unpack_array)(runtime, ha);
	char * pd
		= (char *)TREEDB_realloc
			(MVARRAY_NS(varray_payload_unpack_data)(runtime, pa->m_items), size);
	if(!pd)
		return 1;
	pa = MVARRAY_NS(varray_payload_unpack_array)(runtime, ha);
	pa->m_items = MVARRAY_NS(varray_payload_pack_data)(runtime, pd);
	return 0;
}
  #ifdef __cplusplus
} // extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include "multi-varray-helper-cleardefs.h"

  #ifndef TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
	#include "treedb-impl.h"
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef MVARRAY_NO_IMPL */

#ifndef TREEDB_NO_TYPES
  #include "comet-guids.h"
#endif

#ifdef TREEDB_MULTIPLE_PAYLOAD_ENTRIES
  #ifndef TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
    #define TREEDB_MULTIPLE_PAYLOAD_ENTRIES_SAW_FIRST_ENTRY
  #endif
#endif
