/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_treedb_h_included
  #error Include "treedb.h" before this file.
#endif

/* 4. must-defines */
#ifndef MVARRAY_NS
  #error MVARRAY_NS is not defined. e.g. #define MVARRAY_NS(x) v3c_##x.
#endif

/* 5. types */
#ifndef MVARRAY_runtime_ptr_t
  #define MVARRAY_runtime_ptr_t MVARRAY_NS(runtime_ptr_t)
#endif
#ifndef MVARRAY_size_t
  #define MVARRAY_size_t uintptr_t
#endif
#ifndef MVARRAY_entry_size_t
  #define MVARRAY_entry_size_t MVARRAY_size_t
#endif
#ifndef MVARRAY_count_t
  #define MVARRAY_count_t MVARRAY_size_t
#endif
#ifndef MVARRAY_array_ptr_t
  #define MVARRAY_array_ptr_t MVARRAY_NS(array_ptr_t)
#endif
#ifndef MVARRAY_packed_array_ptr_t
  #define MVARRAY_packed_array_ptr_t MVARRAY_count_t
#endif
#ifndef MVARRAY_data_t
  #define MVARRAY_data_t MVARRAY_NS(data_t)
#endif
#ifndef MVARRAY_data_ptr_t
  #define MVARRAY_data_ptr_t MVARRAY_NS(data_ptr_t)
#endif
#ifndef MVARRAY_packed_data_ptr_t
  #define MVARRAY_packed_data_ptr_t MVARRAY_count_t
#endif
#ifndef MVARRAY_packed_ptr_t
  #define MVARRAY_packed_ptr_t MVARRAY_count_t
#endif
#ifndef MVARRAY_input_t
  #define MVARRAY_input_t MVARRAY_NS(input_t)
#endif

/* 6. optional */
#ifndef MVARRAY_prefix
  #define MVARRAY_prefix extern
#endif
#ifndef MVARRAY_init_DEFAULT
/* These defaults are completely off the top of my head :) */
  #define MVARRAY_init_DEFAULT \
	{ 0, 0, 128 * sizeof(MVARRAY_count_t), 32 * sizeof(MVARRAY_count_t) \
	, 16 * sizeof(MVARRAY_count_t), 8 * sizeof(MVARRAY_count_t) \
	, 4 * sizeof(MVARRAY_count_t), AVL_TMPL_init }
#endif
#ifndef MVARRAY_init
  #define MVARRAY_init MVARRAY_init_DEFAULT
#endif

/* 7. varray_t members */
#ifndef MVARRAY_count
  #define MVARRAY_count m_count
#endif
#ifndef MVARRAY_length
  #define MVARRAY_length m_length
#endif
#ifndef MVARRAY_max_size
  #define MVARRAY_max_size m_max_size
#endif
#ifndef MVARRAY_payload_reserve
  #define MVARRAY_payload_reserve m_payload_reserve
#endif
#ifndef MVARRAY_payload_increment
  #define MVARRAY_payload_increment m_payload_increment
#endif
#ifndef MVARRAY_payload_average
  #define MVARRAY_payload_average m_payload_average
#endif
#ifndef MVARRAY_offset_increment
  #define MVARRAY_offset_increment m_offset_increment
#endif
#ifndef MVARRAY_root
  #define MVARRAY_root m_root
#endif
