/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "multi-varray-defines.h"

#ifdef DOXYGEN_processing
}
#endif

#ifndef MVARRAY_RETURN
  #define MVARRAY_RETURN(x) return x
#endif

#define VARRAY_NS(x) MVARRAY_NS(varray_##x)
#define VARRAY_prefix static
#define VARRAY_runtime_ptr_t MVARRAY_runtime_ptr_t
#define VARRAY_clear_entries(ha, begin, size) \
  MVARRAY_clear_entries(ha, begin, size)

#define VARRAY_omit_init_empty_ptr
#define VARRAY_omit_new
#define VARRAY_omit_free
#define VARRAY_omit_push_back
#define VARRAY_omit_push_front
#define VARRAY_omit_pop_back
//#define VARRAY_omit_pop_back_many
#define VARRAY_omit_pop_front
#define VARRAY_omit_reverse_some
#define VARRAY_omit_reverse

#define VARRAY_OFFSET_data_ptr_t MVARRAY_OFFSET_data_ptr_t
#define VARRAY_OFFSET_alloc(sz) MVARRAY_alloc(sz)
#define VARRAY_OFFSET_free(pv) MVARRAY_free(pv)
#define VARRAY_OFFSET_realloc_packed(ha, count) \
  MVARRAY_OFFSET_realloc_packed(ha, count)

#define VARRAY_PAYLOAD_data_ptr_t MVARRAY_PAYLOAD_data_ptr_t
#define VARRAY_PAYLOAD_alloc(sz) MVARRAY_alloc(sz)
#define VARRAY_PAYLOAD_free(pv) MVARRAY_free(pv)
#define VARRAY_PAYLOAD_realloc_packed(ha, count) \
  MVARRAY_PAYLOAD_realloc_packed(ha, count)

#define VARRAY_alloc(sz) MVARRAY_alloc(sz)
#define VARRAY_free(pv) MVARRAY_free(pv)

#define VARRAY_unpack_pointer(p) MVARRAY_unpack_pointer(p)
#define VARRAY_pack_pointer(p) MVARRAY_pack_pointer(p)

#define VARRAY_size_t MVARRAY_size_t
#define VARRAY_count_t MVARRAY_count_t
#define VARRAY_input_t MVARRAY_input_t

//#define VARRAY_want_OFFSET_pop_back_many

#ifndef MVARRAY_VARRAY_item
  #define MVARRAY_VARRAY_item(pa, n) \
	MVARRAY_NS(varray_payload_unpack_data)(runtime, (pa)->m_payload.m_items \
		+ MVARRAY_NS(varray_offset_unpack_data)(runtime \
			, (pa)->m_offset.m_items)[n])
#endif
#ifndef MVARRAY_VARRAY_assign
  #define MVARRAY_VARRAY_assign(dest, src, size) memcpy(dest, src, size)
#endif
#define VARRAY_item(pa, n) MVARRAY_VARRAY_item(pa, n)
#define VARRAY_assign(dest, src, size) MVARRAY_VARRAY_assign(dest, src, size)

#ifdef DOXYGEN_processing
{
#endif

#include "varray-impl.h"
#include "varray-cleardefs.h"

#ifdef DOXYGEN_processing
}
#endif

#undef VARRAY_NS

#define AVL_TMPL_NS(x) MVARRAY_NS(tree_##x)
#define AVL_TMPL_prefix static
#define AVL_TMPL_size_t MVARRAY_size_t
#define AVL_TMPL_count_t MVARRAY_count_t
#define AVL_TMPL_input_t MVARRAY_count_t
#define AVL_TMPL_key_t MVARRAY_count_t
#define AVL_TMPL_data_t MVARRAY_NS(tree_item_t)
#define AVL_TMPL_data_ptr_t MVARRAY_NS(tree_item_ptr_t)
#define AVL_TMPL_runtime_ptr_t MVARRAY_NS(tree_runtime_ptr_t)

#define AVL_TMPL_omit_insert

#ifdef __cplusplus
extern "C" {
#endif

static AVL_TMPL_NS(node_ptr_t) AVL_TMPL_NS(alloc_node)
( MVARRAY_NS(tree_runtime_ptr_t) runtime
, AVL_TMPL_input_t d
) {
	size_t sz = sizeof(AVL_TMPL_NS(node_t));
	AVL_TMPL_NS(node_ptr_t) ret
		= (AVL_TMPL_NS(node_ptr_t))MVARRAY_runtime_alloc(runtime->m_runtime, sz);
	if(!ret)
		return 0;
	MVARRAY_NS(array_ptr_t) pa = MVARRAY_NS(unpack_array)(runtime->m_runtime
		, runtime->m_handle);
	AVL_TMPL_count_t ha = MVARRAY_runtime_pack_pointer(runtime->m_runtime
		, & ret->m_item.m_varray);
	if(MVARRAY_NS(varray_init)(runtime->m_runtime, ha
			, pa->MVARRAY_payload_reserve
			, pa->MVARRAY_payload_increment
			, pa->MVARRAY_payload_average
		)
	) {
		MVARRAY_runtime_free(runtime->m_runtime, ret);
		return 0;
	}
	ret->m_item.m_index = d;
	return ret;
}
static AVL_TMPL_NS(node_ptr_t) AVL_TMPL_NS(clone_node)
( MVARRAY_NS(tree_runtime_ptr_t) runtime
, AVL_TMPL_NS(node_ptr_t) pn
) {
	AVL_TMPL_count_t length_offset = pn->m_item.m_length_offset;
	AVL_TMPL_count_t hn = AVL_TMPL_NS(pack_node)(runtime, pn);
	AVL_TMPL_NS(node_ptr_t) ret
		= AVL_TMPL_NS(alloc_node)(runtime, pn->m_item.m_index);
	if(!ret)
		return ret;
	ret->m_item.m_length_offset = length_offset;
	AVL_TMPL_count_t hret = AVL_TMPL_NS(pack_node)(runtime, ret);
	MVARRAY_NS(array_ptr_t) pa = MVARRAY_NS(unpack_array)(runtime->m_runtime
		, runtime->m_handle);

	MVARRAY_count_t ha_to
		= hret + v3c_offsetof(AVL_TMPL_NS(node_t), m_item)
				+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray);
	if(MVARRAY_NS(varray_init)(runtime->m_runtime, ha_to
			, pa->MVARRAY_payload_reserve
			, pa->MVARRAY_payload_increment
			, pa->MVARRAY_payload_average
		)
	) {
		MVARRAY_runtime_free(runtime->m_runtime
			, AVL_TMPL_NS(unpack_node)(runtime, hret));
		return 0;
	}
	MVARRAY_count_t ha_from
		= hn + v3c_offsetof(AVL_TMPL_NS(node_t), m_item)
				+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray);
	if(MVARRAY_NS(varray_clone)(runtime->m_runtime, ha_to, ha_from)) {
		MVARRAY_runtime_free(runtime->m_runtime
			, AVL_TMPL_NS(unpack_node)(runtime, hret));
		return 0;
	}
	ret = AVL_TMPL_NS(unpack_node)(runtime, hret);
	return ret;
}
static void AVL_TMPL_NS(free_node_data)
( MVARRAY_NS(tree_runtime_ptr_t) runtime
, AVL_TMPL_NS(node_ptr_t) pn
) {
	MVARRAY_NS(varray_reset)(runtime->m_runtime
		, MVARRAY_runtime_pack_pointer(runtime->m_runtime
			, & pn->m_item.m_varray));
}
#define AVL_TMPL_alloc_node(d) AVL_TMPL_NS(alloc_node)(runtime, d)
#define AVL_TMPL_free_node(pv) MVARRAY_runtime_free(runtime->m_runtime, pv)
#define AVL_TMPL_free(pv) MVARRAY_runtime_free(runtime->m_runtime, pv)
#define AVL_TMPL_pack_pointer(p) \
	MVARRAY_runtime_pack_pointer(runtime->m_runtime, p)
#define AVL_TMPL_unpack_pointer(u) \
	MVARRAY_runtime_unpack_pointer(runtime->m_runtime, u)
#define AVL_TMPL_cmp(a, b) a > b ? 1 : a < b ? -1 : 0
#define AVL_TMPL_unpack_key(pNode) (pNode)->m_item.m_index
#define AVL_TMPL_clone_node(pn) AVL_TMPL_NS(clone_node)(runtime, pn)
#define AVL_TMPL_free_item_data(pn) AVL_TMPL_NS(free_node_data)(runtime, pn)

#ifdef __cplusplus
} /*extern "C" {*/
#endif

  #define AVL_TMPL_omit_pack_tree
  #define AVL_TMPL_omit_insert
  #define AVL_TMPL_omit_remove
  #define AVL_TMPL_omit_distance
  #define AVL_TMPL_omit_free
  #define AVL_TMPL_omit_index
  #define AVL_TMPL_omit_search
  #define AVL_TMPL_omit_search_lt
  #define AVL_TMPL_omit_search_gt

#ifdef DOXYGEN_processing
{
#endif

#include "avl-template-impl.h"
#include "avl-cleardefs.h"

#ifdef DOXYGEN_processing
}
#endif

/* 9. optional */
#ifndef MVARRAY_exceeds_count_limit
  #ifdef TREEDB_need_exceed_check
	#define MVARRAY_exceeds_count_limit(x) \
	  ((x) > ((MVARRAY_size_t)((MVARRAY_count_t)-1)))
  #else
	#define MVARRAY_exceeds_count_limit(x) 0
  #endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* 10. pointer pack / unpack
*/
#ifndef MVARRAY_unpack_array
  #define MVARRAY_unpack_array(x) MVARRAY_NS(unpack_array)(runtime, x)
MVARRAY_prefix MVARRAY_array_ptr_t
MVARRAY_NS(unpack_array)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t p
) {
	MVARRAY_array_ptr_t ret = (MVARRAY_array_ptr_t)MVARRAY_unpack_pointer(p);
	TREEDB_printf2("mvarray::unpack_array : %lu[0x%lx] -> %p\n"
		, (uintptr_t)p
		, (uintptr_t)p, (void *)(uintptr_t)ret);
	return ret;
}
#endif

#ifndef MVARRAY_pack_array
  #define MVARRAY_pack_array(x) MVARRAY_NS(pack_array)(runtime, x)
MVARRAY_prefix MVARRAY_packed_array_ptr_t
MVARRAY_NS(pack_array)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t p
) {
	MVARRAY_packed_array_ptr_t ret = MVARRAY_pack_pointer(p);
	TREEDB_printf2("mvarray::pack_array : %p -> %lu[0x%lx]\n"
		, (void *)(uintptr_t)p, (uintptr_t)ret
		, (uintptr_t)ret);
	return ret;
}
#endif

#define TREE_ITEM_TO_NODE(pitem) \
	((pitem) ? ((MVARRAY_NS(tree_node_ptr_t))((char *)pitem \
		- v3c_offsetof(MVARRAY_NS(tree_node_t), m_item))) \
	: 0)
static MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(new_tree_item_before)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_NS(tree_item_ptr_t) * pptree_item
) {
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(* pptree_item);
	MVARRAY_NS(tree_runtime_t) sub_runtime = { runtime, ha };
	MVARRAY_count_t index, length_offset;
	if(pn && pn->m_prev) {
		MVARRAY_NS(tree_node_ptr_t) pn_prev = MVARRAY_NS(tree_unpack_node)
			(& sub_runtime, pn->m_prev);
		index = pn_prev->m_item.m_index
			+ pn_prev->m_item.m_varray.m_offset.m_count;
		length_offset = pn_prev->m_item.m_length_offset
			+ pn_prev->m_item.m_varray.m_payload.m_count;
	}else
		index = length_offset = 0;
	MVARRAY_count_t hn = MVARRAY_pack_pointer(pn);
	MVARRAY_NS(tree_node_ptr_t) pnew = MVARRAY_NS(tree_alloc_node)(& sub_runtime
		, index);
	if(!pnew)
		return 0;
	pnew->m_item.m_length_offset = length_offset;
	MVARRAY_NS(tree_tree_ptr_t) tree = MVARRAY_NS(tree_unpack_tree)
		(& sub_runtime
		, ha + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
	pn = (MVARRAY_NS(tree_node_ptr_t))MVARRAY_unpack_pointer(hn);
	MVARRAY_NS(tree_insert_node_before)(& sub_runtime, tree, pn, pnew);
	if(pn)
		* pptree_item = & pn->m_item;
	return & pnew->m_item;
}
static MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(new_tree_item_after)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_NS(tree_item_ptr_t) * pptree_item
) {
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(* pptree_item);
	MVARRAY_NS(tree_runtime_t) sub_runtime = { runtime, ha };
	MVARRAY_count_t index, length_offset;
	if(pn && pn->m_next) {
		index = pn->m_item.m_index
			+ pn->m_item.m_varray.m_offset.m_count;
		length_offset = pn->m_item.m_length_offset
			+ pn->m_item.m_varray.m_payload.m_count;
	}else
		index = length_offset = 0;
	MVARRAY_count_t hn = MVARRAY_pack_pointer(pn);
	MVARRAY_NS(tree_node_ptr_t) pnew = MVARRAY_NS(tree_alloc_node)(& sub_runtime
		, index);
	if(!pnew)
		return 0;
	pnew->m_item.m_length_offset = length_offset;
	MVARRAY_NS(tree_tree_ptr_t) tree = MVARRAY_NS(tree_unpack_tree)
		(& sub_runtime
		, ha + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
	pn = (MVARRAY_NS(tree_node_ptr_t))MVARRAY_unpack_pointer(hn);
	MVARRAY_NS(tree_insert_node_after)(& sub_runtime, tree, pn, pnew);
	if(pn)
		* pptree_item = & pn->m_item;
	return & pnew->m_item;
}
static void MVARRAY_NS(delete_tree_item)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_NS(tree_item_ptr_t) ptree_item
) {
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(ptree_item);
	MVARRAY_NS(tree_runtime_t) sub_runtime = { runtime, ha };
	MVARRAY_NS(tree_delete_node)(& sub_runtime
		, ha + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root), pn);
}
MVARRAY_prefix MVARRAY_size_t MVARRAY_NS(tree_item_count)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
) {
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, MVARRAY_pack_array(pa) };
	return MVARRAY_NS(tree_count)(& sub_runtime, & pa->m_root);
}
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(tree_item_for)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_size_t index
) {
	if(index > pa->MVARRAY_count) /* Allow 1-past-end lookup. */
		return 0;
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, MVARRAY_pack_array(pa) };
	MVARRAY_NS(tree_tree_ptr_t) tree = MVARRAY_NS(tree_unpack_tree)
		(& sub_runtime
		, sub_runtime.m_handle
			+ v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
	MVARRAY_NS(tree_node_ptr_t) pn;
	TreedbSearchResult res
		= MVARRAY_NS(tree_search_le)(& sub_runtime, tree, index, & pn);
	if(res != eTreedbSearchLess)
		return 0;
	return & pn->m_item;
}
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(next_tree_item)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_NS(tree_item_ptr_t) pitem
) {
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(pitem);
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, MVARRAY_pack_array(pa) };
	if(!pn->m_next)
		return 0;
	MVARRAY_NS(tree_node_ptr_t) pn2 = MVARRAY_NS(tree_unpack_node)
		(& sub_runtime, pn->m_next);
	return & pn2->m_item;
}
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(prev_tree_item)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_NS(tree_item_ptr_t) pitem
) {
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(pitem);
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, MVARRAY_pack_array(pa) };
	if(!pn->m_prev)
		return 0;
	MVARRAY_NS(tree_node_ptr_t) pn2
		= MVARRAY_NS(tree_unpack_node)(& sub_runtime, pn->m_prev);
	return & pn2->m_item;
}
MVARRAY_prefix int MVARRAY_NS(tree_item_count_for_range)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_size_t where
, MVARRAY_size_t count
, MVARRAY_entry_size_t * pres
) {
	if(!pres)
		return 1;
	if((where + count - 1) >= pa->MVARRAY_count)
		return 2;
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, MVARRAY_pack_array(pa) };
	MVARRAY_NS(tree_tree_ptr_t) tree = MVARRAY_NS(tree_unpack_tree)
		(& sub_runtime
		, sub_runtime.m_handle
			+ v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
	MVARRAY_NS(tree_node_ptr_t) pn1;
	TreedbSearchResult res
		= MVARRAY_NS(tree_search_ge)(& sub_runtime, tree, where, & pn1);
	if((res == eTreedbSearchLess) || !pn1)
		return 3;
	MVARRAY_NS(tree_node_ptr_t) pn2;
	res = MVARRAY_NS(tree_search_ge)(& sub_runtime, tree, where + count, & pn2);
	if((res == eTreedbSearchLess) || !pn2)
		return 4;
	MVARRAY_size_t ret_count = 0;
	/* TODO use distance(). */
	for(; pn1 && (pn1 != pn2); pn1 = MVARRAY_NS(tree_unpack_node)
			(& sub_runtime, pn1->m_next))
		++ret_count;
	if(!pn1)
		return 5; /* Shouldn't happen. */
	*pres = ret_count;
	return 0;
}

MVARRAY_prefix int MVARRAY_NS(init)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t payload_max
, MVARRAY_size_t payload_reserve
, MVARRAY_size_t payload_increment
, MVARRAY_size_t payload_average
) {
	if(!payload_max)
		payload_max = 128 * sizeof(MVARRAY_count_t);
	else if(MVARRAY_exceeds_count_limit(payload_max))
		return 1;
	if(!payload_reserve)
		payload_reserve = 32 * sizeof(MVARRAY_count_t);
	else if(MVARRAY_exceeds_count_limit(payload_reserve))
		return 2;
	if(!payload_increment)
		payload_increment = 16 * sizeof(MVARRAY_count_t);
	else if(MVARRAY_exceeds_count_limit(payload_increment))
		return 3;
	if(!payload_average)
		payload_average = 8 * sizeof(MVARRAY_count_t);
	else if(MVARRAY_exceeds_count_limit(payload_average))
		return 4;

	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	MVARRAY_NS(tree_tree_t) temp = AVL_TMPL_init;
	pa->MVARRAY_root = temp;
	pa->MVARRAY_max_size = payload_max;
	pa->MVARRAY_payload_reserve = payload_reserve;
	pa->MVARRAY_payload_increment = payload_increment;
	pa->MVARRAY_payload_average = payload_average;
	pa->MVARRAY_offset_increment = payload_increment / payload_average;
	return 0;
}
#ifndef MVARRAY_omit_free_DECLARE
MVARRAY_prefix void MVARRAY_NS(free)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
) {
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, ha };
	MVARRAY_NS(tree_clear)(& sub_runtime
		, ha + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
	MVARRAY_free(MVARRAY_unpack_array(ha));
}
#endif
MVARRAY_prefix void MVARRAY_NS(clear)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
) {
	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, ha };
	MVARRAY_NS(tree_clear)(& sub_runtime
		, ha + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root));
}
MVARRAY_prefix int MVARRAY_NS(clone)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha_to
, MVARRAY_packed_array_ptr_t ha_from
) {
	/* TODO or this?
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha_from);
	MVARRAY_NS(init)(runtime, ha_to
	, pa->MVARRAY_max_size
	, pa->MVARRAY_payload_reserve
	, pa->MVARRAY_payload_increment
	, pa->MVARRAY_payload_average);
	*/
	MVARRAY_NS(clear)(runtime, ha_to);
	MVARRAY_array_ptr_t pa_to = MVARRAY_unpack_array(ha_to);
	MVARRAY_array_ptr_t pa_from = MVARRAY_unpack_array(ha_to);
	pa_to->MVARRAY_max_size          = pa_from->MVARRAY_max_size;
	pa_to->MVARRAY_payload_reserve   = pa_from->MVARRAY_payload_reserve;
	pa_to->MVARRAY_payload_increment = pa_from->MVARRAY_payload_increment;
	pa_to->MVARRAY_payload_average   = pa_from->MVARRAY_payload_average;

	MVARRAY_NS(tree_runtime_t) sub_runtime
		= { runtime, ha_to };
	return MVARRAY_NS(tree_clone)(& sub_runtime
		, ha_to + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root)
		, ha_from + v3c_offsetof(MVARRAY_NS(array_t), MVARRAY_root)
	);
}
static int MVARRAY_NS(split)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
) {
	if(MVARRAY_exceeds_count_limit(where0))
		return 1;

	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem)
		return 2;
	MVARRAY_count_t where = where0 - pitem->m_index;
	if((!where) || (where == (pitem->m_varray.m_offset.m_count - 1)))
		return 0;
	MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
	MVARRAY_count_t * offsets;
	MVARRAY_count_t n, count;
	/* Try to minimize the total allocation size. */
	if(where < pitem->m_varray.m_offset.m_items / 2) {
		/* Split the items before into a new varray. */
		count = where - 1;
		MVARRAY_entry_size_t sizes[where - 1];
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		for(n = 0; n < count; ++n)
			sizes[n] = offsets[n + 1] - offsets[n];
		MVARRAY_count_t below_size = offsets[where];
		MVARRAY_NS(tree_item_ptr_t) before_pitem
			= MVARRAY_NS(new_tree_item_before)(runtime, ha, &pitem);
		if(!before_pitem)
			return 3;
		MVARRAY_count_t before_hitem = MVARRAY_pack_pointer(before_pitem);
		if(MVARRAY_NS(varray_push_back_many)
				( runtime
				, before_hitem
					+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, count, sizes)) {
			MVARRAY_NS(delete_tree_item)(runtime, ha, before_pitem);
			return 4;
		}
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		before_pitem = (MVARRAY_NS(tree_item_ptr_t))
			MVARRAY_unpack_pointer(before_hitem);
		/* Copy the items en-masse to the previous varray */
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		char * data = (char *)
			MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
		MVARRAY_count_t *before_offsets
			= MVARRAY_NS(varray_offset_unpack_data)
				(runtime, before_pitem->m_varray.m_offset.m_items);
		char * before_data = (char *)
			MVARRAY_unpack_pointer(before_pitem->m_varray.m_payload.m_items);
		/*TODO check*/
		memcpy(before_data + before_offsets
			[ before_pitem->m_varray.m_payload.m_count - where ]
			, data + offsets[where]
			, offsets[where + 1]);
		/* remove the items from this varray. */
		MVARRAY_NS(varray_pop_front_many)(runtime, hitem
				+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
			, where);
		/* Adjust the m_index and m_length_offset of this tree_item. */
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pitem->m_index -= where;
		pitem->m_length_offset -= below_size;
	}else{
		/* Split the items after into a new varray. */
		count = pitem->m_varray.m_offset.m_count - where - 1;
		MVARRAY_entry_size_t sizes[count];
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		for(n = 0; n < count; ++n)
			sizes[n] = offsets[n + where + 1] - offsets[where + n];
		MVARRAY_count_t above_size = offsets
			[ pitem->m_varray.m_offset.m_count - where - 1];
		MVARRAY_NS(tree_item_ptr_t) after_pitem
			= MVARRAY_NS(new_tree_item_after)(runtime, ha, &pitem);
		if(!after_pitem)
			return 3;
		MVARRAY_count_t after_hitem = MVARRAY_pack_pointer(after_pitem);
		if(MVARRAY_NS(varray_push_back_many)
				( runtime
				, after_hitem
					+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, count, sizes)) {
			MVARRAY_NS(delete_tree_item)(runtime, ha, after_pitem);
			return 4;
		}
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		after_pitem = (MVARRAY_NS(tree_item_ptr_t))
			MVARRAY_unpack_pointer(after_hitem);
		/* Copy the items en-masse to the next varray */
		MVARRAY_count_t * offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		char * data = (char *)
			MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
		char * after_data = (char *)
			MVARRAY_unpack_pointer(after_pitem->m_varray.m_payload.m_items);
		/*TODO check*/
		memcpy(after_data, data + offsets[where], offsets[where]);
		/* remove the items from this varray. */
		MVARRAY_NS(varray_pop_front_many)(runtime, hitem
				+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
			, where);
		/* Adjust the m_index and m_length_offset of this tree_item. */
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		after_pitem
			= (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(after_hitem);
		after_pitem->m_index = where;
		after_pitem->m_length_offset = pitem->m_length_offset + above_size;
	}
	return 0;
}
static void MVARRAY_NS(maybe_join)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where
) {
	if(MVARRAY_exceeds_count_limit(where))
		return;
	MVARRAY_array_ptr_t pa;
	MVARRAY_NS(tree_item_ptr_t) prev_pitem, pitem;
	MVARRAY_count_t hitem;
	MVARRAY_count_t prev_hitem;
redo:
	pa = MVARRAY_unpack_array(ha);
	pitem = MVARRAY_NS(tree_item_for)(runtime, pa, where);
	if(!pitem)
		return;
	if(where != pitem->m_index)
		return; /* Not on a boundary. */
	prev_pitem = MVARRAY_NS(prev_tree_item)(runtime, pa, pitem);
	if(!prev_pitem)
		return;
	if((pitem->m_varray.m_payload.m_count
				+ prev_pitem->m_varray.m_payload.m_count)
			> pa->MVARRAY_max_size)
		return;
	hitem = MVARRAY_pack_pointer(pitem);
	prev_hitem = MVARRAY_pack_pointer(prev_pitem);
	if(pitem->m_varray.m_payload.m_count
			< prev_pitem->m_varray.m_payload.m_count) {
		/* Append this tree_items contents to the previous tree_item. */
		MVARRAY_count_t n, count = pitem->m_varray.m_offset.m_count - 1;
		MVARRAY_entry_size_t sizes[count];
		MVARRAY_count_t * offsets
			= MVARRAY_NS(varray_offset_unpack_data)
				(runtime, pitem->m_varray.m_offset.m_items);
		for(n = 0; n < count; ++n)
			sizes[n] = offsets[n + 1] - offsets[n];
		if(MVARRAY_NS(varray_push_back_many)(runtime
			, prev_hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
			, count, sizes))
			return;
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		prev_pitem
			= (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(prev_hitem);
		/* Copy the items en-masse to the previous varray */
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		char * data = (char *)
			MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
		MVARRAY_count_t * prev_offsets
			= MVARRAY_NS(varray_offset_unpack_data)
				(runtime, prev_pitem->m_varray.m_offset.m_items);
		char * prev_data = (char *)
			MVARRAY_unpack_pointer(prev_pitem->m_varray.m_payload.m_items);
		/*TODO check*/
		memcpy(prev_data + prev_offsets[where - pitem->m_index]
			, data
			, pitem->m_varray.m_payload.m_count);
		/* Delete this varray. */
		MVARRAY_NS(delete_tree_item)(runtime, ha, pitem);
		/* Join up previous items to consolidate at the start. */
		prev_pitem
			= (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(prev_hitem);
		where = prev_pitem->m_index;
		goto redo;
	}else{
		/* Prepend the previous tree_items contents to this tree_item.*/
		MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
		MVARRAY_count_t n, count = prev_pitem->m_varray.m_offset.m_count - 1;
		MVARRAY_entry_size_t sizes[count];
		MVARRAY_count_t * offsets
			= MVARRAY_NS(varray_offset_unpack_data)
				(runtime, prev_pitem->m_varray.m_offset.m_items);
		for(n = 0; n < count; ++n)
			sizes[n] = offsets[n + 1] - offsets[n];
		if(MVARRAY_NS(varray_push_front_many)(runtime
			, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
			, count, sizes))
			return;
		/* Copy the items en-masse to this varray */
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		char * data = (char *)
			MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
		char * prev_data = (char *)
			MVARRAY_unpack_pointer(prev_pitem->m_varray.m_payload.m_items);
		MVARRAY_count_t prev_size = pitem->m_varray.m_payload.m_count;
		/*TODO check*/
		memcpy(data, prev_data, prev_size);
		/* Delete the previous varray. */
		MVARRAY_NS(delete_tree_item)(runtime, ha, prev_pitem);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pitem->m_index -= count;
		pitem->m_length_offset -= prev_size;
		/* Join up previous items to consolidate at the start. */
		pitem
			= (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		prev_pitem = MVARRAY_NS(prev_tree_item)(runtime, pa, pitem);
		where = prev_pitem->m_index;
		goto redo;
	}
}
#ifndef MVARRAY_omit_resize
MVARRAY_prefix int MVARRAY_NS(resize)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
, MVARRAY_input_t d
, MVARRAY_entry_size_t size0
) {
	if(MVARRAY_exceeds_count_limit(where0))
		return 1;
	if(MVARRAY_exceeds_count_limit(size0))
		return 2;
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	MVARRAY_count_t size
		= V3C_ROUND_UP_T2(MVARRAY_count_t, size0, MVARRAY_entry_align);
	if((size >= pa->MVARRAY_max_size))
		return 3;
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem)
		return 4;
	MVARRAY_count_t where = where0 - pitem->m_index;
	MVARRAY_count_t * offsets
		= MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
	MVARRAY_count_t old_size = offsets[where + 1] - offsets[where];
	MVARRAY_count_t diff;
	if(old_size == size) {
		/* No significant size change. */
		/* Copy the data in. */
		MVARRAY_VARRAY_assign(MVARRAY_VARRAY_item(& pitem->m_varray, where)
			, d, size0);
	}else if(old_size < size) {
		/* Size increase. */
		diff = size - old_size;
		if((pitem->m_varray.m_payload.m_count + diff) <= pa->MVARRAY_max_size) {
			/* We can accommodate the increase. */
			MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
			if(MVARRAY_NS(varray_resize)(runtime
					, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
					, where, d, size))
				return 5;
			pa = MVARRAY_unpack_array(ha);
			pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
			pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
			for(; pitem
				; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
				pitem->m_length_offset += diff;
			}
			pa->MVARRAY_length += diff;
		}else{
			if((offsets[where] + size) <= pa->MVARRAY_max_size) {
				/* Split above. */
				if(MVARRAY_NS(split)(runtime, ha, where0 + 1))
					return 6;
			}else if((pitem->m_varray.m_payload.m_count - offsets[where] + diff)
					 <= pa->MVARRAY_max_size) {
				/* Split below. */
				if(MVARRAY_NS(split)(runtime, ha, where0))
					return 7;
			}else{
				/* Split below and above. */
				if(MVARRAY_NS(split)(runtime, ha, where0))
					return 8;
				if(MVARRAY_NS(split)(runtime, ha, where0 + 1))
					return 9;
			}
			pa = MVARRAY_unpack_array(ha);
			pitem = MVARRAY_NS(tree_item_for)(runtime, pa, where0);
			where = where0 - pitem->m_index;
			pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
			for(; pitem
				; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
				pitem->m_length_offset += diff;
			}
			pa->MVARRAY_length += diff;
			MVARRAY_NS(maybe_join)(runtime, ha, pitem->m_index);
		}
	}else{
		/* Size decrease. */
		diff = old_size - size;
		MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
		if(MVARRAY_NS(varray_resize)(runtime
				, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where, d, size))
			return 10;
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
			pitem->m_length_offset -= diff;
		}
		pa->MVARRAY_length -= diff;
		MVARRAY_NS(maybe_join)(runtime, ha, pitem->m_index);
	}
	return 0;
}
#endif
#ifndef MVARRAY_omit_insert
/** MVARRAY_NS(insert)

The algorithm is a trade-off between having all the varrays maximally populated
(slow) versus having a varray for every entry (big).
Here are the things to consider:
	 -# Running out of memory is always a possibility\n
		Plan ahead and be able to undo changes while preserving existing data.
	 -# Will the item fit the current varray?
		If so then easy peasy.
	 -# What about the next or previous varray?\n
		Can we move preceeding items back to make room?\n
		Can we move succeeding items forward to make room?\n
		The decision to move back or forward depends on
		 -# if there are previous or next varrays
		 -# the sizes of the preceeding and succeeding entries
		 -# whether the adjustment meets the max-size constraint
	 -# Otherwise create a new varray for the insert\n
		It will be either before or after the current varray - pick the one that
		moves the least amount of memory.
*/
MVARRAY_prefix int MVARRAY_NS(insert)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
, MVARRAY_input_t d
, MVARRAY_entry_size_t size0
) {
	if(MVARRAY_exceeds_count_limit(size0))
		MVARRAY_RETURN(1);
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	MVARRAY_count_t size
		= V3C_ROUND_UP_T2(MVARRAY_count_t, size0, MVARRAY_entry_align);
	if(where0 > pa->MVARRAY_count)
		MVARRAY_RETURN(2);
	if((size >= pa->MVARRAY_max_size))
		MVARRAY_RETURN(3);
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem) {
		/* The mvarray is empty. */
		pitem = MVARRAY_NS(new_tree_item_after)(runtime, ha, & pitem);
		if(!pitem)
			MVARRAY_RETURN(4);
	}
	MVARRAY_count_t where = where0 - pitem->m_index;
	if((pitem->m_varray.m_payload.m_count + size) <= pa->MVARRAY_max_size) {
		MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
		if(MVARRAY_NS(varray_insert)(runtime
				, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where, d, size0))
			MVARRAY_RETURN(5);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		pa = MVARRAY_unpack_array(ha);
		for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
			++pitem->m_index;
			pitem->m_length_offset += size;
		}
		++pa->MVARRAY_count;
		pa->MVARRAY_length += size;
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		MVARRAY_NS(maybe_join)(runtime, ha, pitem->m_index);
		MVARRAY_RETURN(0);
	}
	/* See if there are previous or next tree nodes. */
	MVARRAY_NS(tree_node_ptr_t) pn = TREE_ITEM_TO_NODE(pitem);
	MVARRAY_count_t before_avail = 0, after_avail = 0;
	MVARRAY_count_t before_needed = 0, after_needed = 0;
	MVARRAY_NS(tree_item_ptr_t) before_pitem, after_pitem;
	if(pn->m_prev) {
		before_pitem = MVARRAY_NS(prev_tree_item)(runtime, pa, pitem);
		before_avail
			= pa->MVARRAY_max_size - before_pitem->m_varray.m_payload.m_count;
	}else
		before_pitem = 0;
	if(pn->m_next) {
		after_pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		after_avail
			= pa->MVARRAY_max_size - after_pitem->m_varray.m_payload.m_count;
	}else
		after_pitem = 0;

	MVARRAY_count_t *offsets = MVARRAY_NS(varray_offset_unpack_data)
		(runtime, pitem->m_varray.m_offset.m_items);
	before_needed = offsets[where] + size;
	after_needed = offsets[pitem->m_varray.m_offset.m_count - 1]
		- offsets[where] + size;
	MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
	MVARRAY_count_t before_hitem = MVARRAY_pack_pointer(before_pitem);
	MVARRAY_count_t after_hitem = MVARRAY_pack_pointer(after_pitem);
	int tried_before = 0, tried_after = 0, node_created = 0, recurse = 0;
	if(before_needed < after_needed) {
try_before:
		if(before_avail >= before_needed) {
			/* Store the preceeding items along with the item to be inserted in
			the previous varray. */
			/*TODO check*/
split_before:
			MVARRAY_count_t n, count
				= where;
			MVARRAY_entry_size_t sizes[count + !recurse];
			for(n = 0; n < count; ++n)
				sizes[n] = offsets[n + 1] - offsets[n];
			if(!recurse) {
				sizes[n] = size;
				++count;
			}
			if(MVARRAY_NS(varray_push_back_many)
					( runtime
					, before_hitem
						+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
					, count, sizes)) {
				if(node_created) {
					MVARRAY_NS(delete_tree_item)(runtime, ha, before_pitem);
					MVARRAY_RETURN(6);
				}
				tried_before = 1;
				if(!tried_after)
					goto try_after;
			}
			pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
			before_pitem = (MVARRAY_NS(tree_item_ptr_t))
				MVARRAY_unpack_pointer(before_hitem);
			/* Copy the preceeding items en-masse to the previous varray */
			offsets = MVARRAY_NS(varray_offset_unpack_data)
				(runtime, pitem->m_varray.m_offset.m_items);
			char * data = (char *)
				MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
			MVARRAY_count_t *before_offsets
				= MVARRAY_NS(varray_offset_unpack_data)
					(runtime, before_pitem->m_varray.m_offset.m_items);
			char * before_data = (char *)
				MVARRAY_unpack_pointer(before_pitem->m_varray.m_payload.m_items);
			/*TODO check*/
			memcpy(before_data + before_offsets
				[ before_pitem->m_varray.m_payload.m_count - where ]
				, data + offsets[where]
				, offsets[where + 1]);
			if(!recurse) {
				/* Insert the item in the previous varray. */
				/* Copy the data in. */
				MVARRAY_VARRAY_assign(MVARRAY_VARRAY_item(
					& before_pitem->m_varray
					, before_pitem->m_varray.m_payload.m_count - where + 1)
				, d, size0);
			}
			/* remove the items from this varray. */
			MVARRAY_NS(varray_pop_front_many)(runtime, hitem
					+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where);
			/* Adjust the m_index and m_length_offset of this and all succeeding
			tree_items. */
			pa = MVARRAY_unpack_array(ha);
			pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
			pitem->m_index -= where - recurse;
			pitem->m_length_offset += before_needed - (recurse ? size : 0);
			if(!recurse) {
				for(; pitem
					; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
					++pitem->m_index;
					pitem->m_length_offset += size;
				}
				++pa->MVARRAY_count;
				pa->MVARRAY_length += size;
				MVARRAY_NS(maybe_join)(runtime, ha, where0 - where);
				MVARRAY_RETURN(0);
			}else{
				return MVARRAY_NS(insert)(runtime, ha, where0, d, size0);
			}
		}
	}else{
try_after:
		if(after_avail >= after_needed) {
			/* Store the succeeding items along with the item to be inserted in
			the next varray. */
			/*TODO check*/
split_after:
			MVARRAY_count_t n, count
				= pitem->m_varray.m_offset.m_count - where - 1;
			MVARRAY_entry_size_t sizes[count + !recurse];
			if(!recurse) {
				TREEDB_printf2("Not recursing: sizes[0] == %lu.\n"
					, (size_t)size);
				sizes[0] = size;
				++count;
			}
			for(n = recurse; n < count; ++n) {
				sizes[n] = offsets[where + n + recurse + 1]
					- offsets[where + n + recurse];
				TREEDB_printf2("sizes[%lu] == "
					"(offsets[where(%lu) + n(%lu) "
						"+ recurse(%lu) + 1 (%lu)])(%lu) - "
					"(offsets[where(%lu) + n(%lu) "
						"+ recurse(%lu) (%lu)])(%lu) == %lu.\n"
					, (size_t)n
					, (size_t)where
					, (size_t)n
					, (size_t)recurse
					, (size_t)(where + n + recurse + 1)
					, (size_t)(offsets[where + n + recurse + 1])
					, (size_t)where
					, (size_t)n
					, (size_t)recurse
					, (size_t)(where + n + recurse)
					, (size_t)(offsets[where + n + recurse])
					, (size_t)(sizes[n])
				);
			}
			if(MVARRAY_NS(varray_push_front_many)
					( runtime
					, after_hitem
						+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
					, count, sizes)) {
				if(node_created) {
					MVARRAY_NS(delete_tree_item)(runtime, ha, after_pitem);
					MVARRAY_RETURN(7);
				}
				tried_after = 1;
				if(!tried_before)
					goto try_before;
			}
			pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
			after_pitem = (MVARRAY_NS(tree_item_ptr_t))
				MVARRAY_unpack_pointer(after_hitem);
			/* Copy the succeeding items en-masse to the next varray */
			offsets = MVARRAY_NS(varray_offset_unpack_data)
				(runtime, pitem->m_varray.m_offset.m_items);
			char * data = (char *)
				MVARRAY_unpack_pointer(pitem->m_varray.m_payload.m_items);
			char * after_data = (char *)
				MVARRAY_unpack_pointer(after_pitem->m_varray.m_payload.m_items);
			/*TODO check*/
			memcpy(after_data + (recurse ? 0 : size)
				, data + offsets[where]
				, offsets[where + 1]);
			if(!recurse) {
				/* Insert the item in this varray. */
				/* Copy the data in. */
				MVARRAY_VARRAY_assign(MVARRAY_VARRAY_item(
					& before_pitem->m_varray
					, 0), d, size0);
			}
			/* remove the items from this varray. */
			MVARRAY_NS(varray_pop_back_many)(runtime, hitem
					+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where);
			/* Adjust the m_index and m_length_offset of all succeeding
			tree_items. */
			pa = MVARRAY_unpack_array(ha);
			pitem = (MVARRAY_NS(tree_item_ptr_t))
				MVARRAY_unpack_pointer(after_hitem);
			pitem->m_index -= where - recurse;
			pitem->m_length_offset += after_needed - (recurse ? size : 0);
			if(!recurse) {
				for(; pitem
					; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
					++pitem->m_index;
					pitem->m_length_offset += size;
				}
				++pa->MVARRAY_count;
				pa->MVARRAY_length += size;
				MVARRAY_NS(maybe_join)(runtime, ha, where0 - where);
				MVARRAY_RETURN(0);
			}else{
				return MVARRAY_NS(insert)(runtime, ha, where0, d, size0);
			}
		}
	}
	/* We need to create a new tree node. */
	node_created = 1;
	if(before_needed < after_needed) {
		before_pitem = MVARRAY_NS(new_tree_item_before)(runtime, ha, &pitem);
		if(!before_pitem)
			MVARRAY_RETURN(8);
		if(before_needed <= pa->MVARRAY_max_size) {
			/* Insert a node before the current tree node containing the
			preceeding items along with the item to be inserted. */
			goto split_before;
		}else{
			/* Split the varray in two and recurse. */
			recurse = 1;
			goto split_before;
		}
	}else{
		after_pitem = MVARRAY_NS(new_tree_item_after)(runtime, ha, &pitem);
		if(!after_pitem)
			MVARRAY_RETURN(9);
		if(after_needed <= pa->MVARRAY_max_size) {
			/* Insert a node after the current tree node containing the
			succeeding items along with the item to be inserted. */
			goto split_after;
		}else{
			/* Split the varray in two and recurse. */
			recurse = 1;
			goto split_after;
		}
	}
}
#endif
MVARRAY_prefix int MVARRAY_NS(insert_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
, MVARRAY_size_t count
, const MVARRAY_entry_size_t * sizes
) {
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	if(((where0 + count - 1) >= pa->MVARRAY_count))
		return 3;
	MVARRAY_count_t n;
	MVARRAY_size_t total_size = 0;
	for(n = 0; n < count; ++n) {
		total_size
			+= V3C_ROUND_UP_T2(MVARRAY_size_t, sizes[n], MVARRAY_entry_align);
	}
	if(MVARRAY_exceeds_count_limit(total_size))
		return 5;
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem)
		return 6;
	MVARRAY_count_t where = where0 - pitem->m_index;
	if((pitem->m_varray.m_payload.m_count + total_size) <= pa->MVARRAY_max_size)
	{
		MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
		if(MVARRAY_NS(varray_insert_many)(runtime
				, ha + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where, count, sizes))
			return 7;
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
			pitem->m_index += count;
			pitem->m_length_offset += total_size;
		}
		pa->MVARRAY_count += count;
		pa->MVARRAY_length += total_size;
		MVARRAY_NS(maybe_join)(runtime, ha, where0 - where);
		return 0;
	}
	/* If we fail at any stage we must restore the original state. */
	MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
	MVARRAY_count_t first_hitem = hitem;
	MVARRAY_count_t items_count = 0, nodes_count = 0, next_hitem = 0;
	MVARRAY_count_t added_size = 0, to_add_size, to_add_total;
	MVARRAY_NS(tree_item_ptr_t) next_pitem;
	MVARRAY_size_t rem_count = count;
	const MVARRAY_entry_size_t * rem_sizes = sizes;
	if(!where) {
insert_before:
		/* No need to split: we're already at the start. */
		while(total_size) {
			next_pitem
				= MVARRAY_NS(new_tree_item_before)(runtime, ha, &pitem);
			if(!next_pitem)
				goto abort_before;
			++nodes_count;
			/* Figure out how many items will fit into this varray. */
			to_add_total = 0;
			for(n = 0; n < rem_count; ++n) {
				to_add_size
					= V3C_ROUND_UP_T2(MVARRAY_size_t, rem_sizes[n]
						, MVARRAY_entry_align);
				if((to_add_total + to_add_size) > pa->MVARRAY_max_size)
					break;
				to_add_total += to_add_size;
			}
			next_hitem = MVARRAY_pack_pointer(next_pitem);
			if(MVARRAY_NS(varray_insert_many)(runtime
					, next_hitem
						+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
					, 0, n, rem_sizes))
				goto abort_before;
			total_size -= to_add_total;
		}
		/* Adjust the m_index and m_length_offset of all succeeding
		tree_items. */
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))
			MVARRAY_unpack_pointer(next_hitem);
		pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
			pitem->m_index += count;
			pitem->m_length_offset += total_size;
		}
		pa->MVARRAY_count += count;
		pa->MVARRAY_length += total_size;
		MVARRAY_NS(maybe_join)(runtime, ha, where0);
		return 0;
	}else if(where == (pitem->m_varray.m_offset.m_count - 1)) {
		/* TODO try to add items to the existing varray. It complicates the
		cleanup. */
		/* No need to split: we're already at the end. */
		while(total_size) {
			next_pitem
				= MVARRAY_NS(new_tree_item_after)(runtime, ha, &pitem);
			if(!next_pitem)
				goto abort_after;
			++nodes_count;
			/* Figure out how many items will fit into this varray. */
			to_add_total = 0;
			for(n = 0; n < rem_count; ++n) {
				to_add_size
					= V3C_ROUND_UP_T2(MVARRAY_size_t, rem_sizes[n]
						, MVARRAY_entry_align);
				if((to_add_total + to_add_size) > pa->MVARRAY_max_size)
					break;
				to_add_total += to_add_size;
			}
			next_hitem = MVARRAY_pack_pointer(next_pitem);
			if(MVARRAY_NS(varray_insert_many)(runtime
					, next_hitem
						+ v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
					, 0, n, rem_sizes))
				goto abort_after;
			total_size -= to_add_total;
		}
		/* Adjust the m_index and m_length_offset of all succeeding
		tree_items. */
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))
			MVARRAY_unpack_pointer(next_hitem);
		pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
			pitem->m_index += count;
			pitem->m_length_offset += total_size;
		}
		pa->MVARRAY_count += count;
		pa->MVARRAY_length += total_size;
		MVARRAY_NS(maybe_join)(runtime, ha, where0);
		return 0;
	}else{
		if(MVARRAY_NS(split)(runtime, ha, where0))
			return 8;
		pitem
			= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
		goto insert_before;
	}
abort_before:
	pa = MVARRAY_unpack_array(ha);
	pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(first_hitem);
	pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
	for(n = 0; n < nodes_count; ++n) {
		next_pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem);
		hitem = MVARRAY_pack_pointer(next_pitem);
		MVARRAY_NS(delete_tree_item)(runtime, ha, pitem);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pa = MVARRAY_unpack_array(ha);
	}
	pa->MVARRAY_count -= items_count;
	pa->MVARRAY_length -= added_size;
	MVARRAY_NS(maybe_join)(runtime, ha, where0);
	return 9;
abort_after:
	pa = MVARRAY_unpack_array(ha);
	pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(first_hitem);
	pitem = MVARRAY_NS(prev_tree_item)(runtime, pa, pitem);
	for(n = 0; n < nodes_count; ++n) {
		next_pitem = MVARRAY_NS(prev_tree_item)(runtime, pa, pitem);
		hitem = MVARRAY_pack_pointer(next_pitem);
		MVARRAY_NS(delete_tree_item)(runtime, ha, pitem);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
		pa = MVARRAY_unpack_array(ha);
	}
	pa->MVARRAY_count -= items_count;
	pa->MVARRAY_length -= added_size;
	MVARRAY_NS(maybe_join)(runtime, ha, where0);
	return 10;
}
#ifndef MVARRAY_omit_remove
MVARRAY_prefix int MVARRAY_NS(remove)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
) {
	/* TODO try to join up adjacent varrays if possible. */
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	if(where0 >= pa->MVARRAY_count)
		return 1;
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem)
		return 2;
	MVARRAY_count_t where = where0 - pitem->m_index;
	MVARRAY_count_t size;
	MVARRAY_count_t * offsets;
	if(pitem->m_varray.m_offset.m_count == 2) {
		/* We can delete this tree_item. */
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		size = offsets[1];
		MVARRAY_NS(delete_tree_item)(runtime, ha, pitem);
	}else{
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		size = offsets[where + 1] - offsets[where];
		MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
		/* Correct the next node, not this one. */
		if(where != (pitem->m_varray.m_offset.m_count - 1))
			where0 = pitem->m_varray.m_offset.m_count - 1;
		MVARRAY_NS(varray_remove)(runtime
			, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
			, where);
	}
	pa = MVARRAY_unpack_array(ha);
	pitem = MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
		--pitem->m_index;
		pitem->m_length_offset -= size;
	}
	--pa->MVARRAY_count;
	pa->MVARRAY_length -= size;
	MVARRAY_NS(maybe_join)(runtime, ha, where0 - where);
	return 0;
}
#endif
MVARRAY_prefix int MVARRAY_NS(remove_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
, MVARRAY_size_t count
) {
	if(!count)
		return 0;
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	if((where0 + count - 1) >= pa->MVARRAY_count)
		return 1;
	MVARRAY_NS(tree_item_ptr_t) pitem
		= MVARRAY_NS(tree_item_for)(runtime, pa, where0);
	if(!pitem)
		return 2;
	MVARRAY_count_t where = where0 - pitem->m_index;
	MVARRAY_count_t hitem = MVARRAY_pack_pointer(pitem);
	MVARRAY_count_t size = 0, sub_count;
	MVARRAY_count_t * offsets;
	int whole_node = 0;
	while(count) {
		sub_count = count - where;
		offsets = MVARRAY_NS(varray_offset_unpack_data)
			(runtime, pitem->m_varray.m_offset.m_items);
		if(sub_count > (pitem->m_varray.m_offset.m_count - where - 1)) {
			sub_count = pitem->m_varray.m_offset.m_count - where - 1;
			whole_node = 1;
		}else
			whole_node = 0;
		size += offsets[sub_count + 1] - offsets[where];
		hitem = MVARRAY_pack_pointer(
			MVARRAY_NS(next_tree_item)(runtime, pa, pitem)
		);
		if(!whole_node) {
			MVARRAY_NS(varray_remove_many)(runtime
				, hitem + v3c_offsetof(MVARRAY_NS(tree_item_t), m_varray)
				, where, sub_count);
		}else
			MVARRAY_NS(delete_tree_item)(runtime, ha, pitem);
		count -= sub_count;
		where = 0;
		pa = MVARRAY_unpack_array(ha);
		pitem = (MVARRAY_NS(tree_item_ptr_t))MVARRAY_unpack_pointer(hitem);
	}
	pa = MVARRAY_unpack_array(ha);
	for(; pitem
			; pitem = MVARRAY_NS(next_tree_item)(runtime, pa, pitem)) {
		pitem->m_index -= count;
		pitem->m_length_offset -= size;
	}
	pa->MVARRAY_count -= count;
	pa->MVARRAY_length -= size;
	MVARRAY_NS(maybe_join)(runtime, ha, pitem->m_index);
	return 0;
}
#ifndef MVARRAY_omit_push_back
MVARRAY_prefix int MVARRAY_NS(push_back)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_input_t d
, MVARRAY_entry_size_t size
) {
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	return MVARRAY_NS(insert)(runtime, ha, pa->MVARRAY_count, d, size);
}
#endif
#ifndef MVARRAY_omit_push_back_many
MVARRAY_prefix int MVARRAY_NS(push_back_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_count_t count
, const MVARRAY_count_t * sizes
) {
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	return MVARRAY_NS(insert_many)(runtime, ha, pa->MVARRAY_count, count, sizes);
}
#endif
#ifndef MVARRAY_omit_push_front
MVARRAY_prefix int MVARRAY_NS(push_front)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_input_t d
, MVARRAY_entry_size_t size
) {
	return MVARRAY_NS(insert)(runtime, ha, 0, d, size);
}
#endif
#ifndef MVARRAY_omit_push_front_many
MVARRAY_prefix int MVARRAY_NS(push_front_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
, const MVARRAY_entry_size_t * sizes
) {
	return MVARRAY_NS(insert_many)(runtime, ha, 0, count, sizes);
}
#endif
#ifndef MVARRAY_omit_pop_back
MVARRAY_prefix int MVARRAY_NS(pop_back)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
) {
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	if(!pa->MVARRAY_count)
		return 1;
	return MVARRAY_NS(remove)(runtime, ha, pa->MVARRAY_count - 1);
}
#endif
#ifndef MVARRAY_omit_pop_back_many
MVARRAY_prefix int MVARRAY_NS(pop_back_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
) {
	MVARRAY_array_ptr_t pa = MVARRAY_unpack_array(ha);
	if(pa->MVARRAY_count < count)
		return 1;
	return MVARRAY_NS(remove_many)(runtime, ha, pa->MVARRAY_count - count - 1
		, count);
}
#endif
#ifndef MVARRAY_omit_pop_front
MVARRAY_prefix int MVARRAY_NS(pop_front)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
) {
	return MVARRAY_NS(remove)(runtime, ha, 0);
}
#endif
#ifndef MVARRAY_omit_pop_front_many
MVARRAY_prefix int MVARRAY_NS(pop_front_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
) {
	return MVARRAY_NS(remove_many)(runtime, ha, 0, count);
}
#endif
#if 0
TODO later!
#ifndef MVARRAY_omit_reverse_some_DECLARE
MVARRAY_prefix int MVARRAY_NS(reverse_some)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_count_t where
, MVARRAY_count_t count
);
#endif
#ifndef MVARRAY_omit_reverse_DECLARE
MVARRAY_prefix void MVARRAY_NS(reverse)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
);
#endif
#endif

#ifdef __cplusplus
} /* extern "C" { */
#endif
