/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "multi-varray-defines.h"

#define VARRAY_NS(x) MVARRAY_NS(varray_##x)
#define VARRAY_size_t MVARRAY_size_t
#define VARRAY_entry_size_t MVARRAY_entry_size_t
#define VARRAY_count_t MVARRAY_count_t
#define VARRAY_input_t MVARRAY_input_t
#define VARRAY_data_t MVARRAY_data_t
#define VARRAY_OFFSET_data_ptr_t MVARRAY_OFFSET_data_ptr_t
#define VARRAY_PAYLOAD_data_ptr_t MVARRAY_PAYLOAD_data_ptr_t

#define VARRAY_prefix static
#define VARRAY_runtime_ptr_t MVARRAY_runtime_ptr_t

#define VARRAY_omit_init_empty_ptr_DECLARE
#define VARRAY_omit_new_DECLARE
#define VARRAY_omit_free_DECLARE
#define VARRAY_omit_push_back_DECLARE
#define VARRAY_omit_push_back_many_DECLARE
#define VARRAY_omit_push_front_DECLARE
#define VARRAY_omit_pop_back_DECLARE
#define VARRAY_omit_pop_front_DECLARE
#define VARRAY_omit_reverse_some_DECLARE
#define VARRAY_omit_reverse_DECLARE

//#define VARRAY_want_OFFSET_pop_back_many_DECLARE

#include "varray.h"

#ifdef DOXYGEN_processing
}
#endif

#ifndef MVARRAY_omit_varray_defines

#ifdef __cplusplus
extern "C" {
#endif

typedef struct MVARRAY_NS(tree_item_t) MVARRAY_NS(tree_item_t)
, * MVARRAY_NS(tree_item_ptr_t);
struct MVARRAY_NS(tree_item_t) {
	MVARRAY_count_t m_index, m_length_offset;
	VARRAY_NS(array_t) m_varray;
};

typedef struct MVARRAY_NS(tree_runtime_t) MVARRAY_NS(tree_runtime_t)
, * MVARRAY_NS(tree_runtime_ptr_t);
struct MVARRAY_NS(tree_runtime_t) {
	MVARRAY_NS(runtime_ptr_t) m_runtime;
	MVARRAY_packed_array_ptr_t m_handle;
};

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef MVARRAY_omit_varray_defines */

#ifdef DOXYGEN_processing
{
#endif

#include "varray-cleardefs.h"

/******************************************************************************/
/* multi-varray tree                                                          */
/******************************************************************************/
#ifndef MVARRAY_omit_array_t_member_defines

  #define AVL_TMPL_NS(x) MVARRAY_NS(tree_##x)
  #define AVL_TMPL_prefix static
  #define AVL_TMPL_size_t MVARRAY_size_t
  #define AVL_TMPL_input_t MVARRAY_count_t
  #define AVL_TMPL_key_t MVARRAY_count_t
  #define AVL_TMPL_data_t MVARRAY_NS(tree_item_t)
  #define AVL_TMPL_data_ptr_t MVARRAY_NS(tree_item_ptr_t)
  #define AVL_TMPL_runtime_ptr_t MVARRAY_NS(tree_runtime_ptr_t)

  #define AVL_TMPL_omit_pack_tree_DECLARE
  #define AVL_TMPL_omit_insert_DECLARE
  #define AVL_TMPL_omit_remove_DECLARE
  #define AVL_TMPL_omit_distance_DECLARE
  #define AVL_TMPL_omit_free_DECLARE
  #define AVL_TMPL_omit_index_DECLARE
  #define AVL_TMPL_omit_search_DECLARE
  #define AVL_TMPL_omit_search_lt_DECLARE
  #define AVL_TMPL_omit_search_gt_DECLARE

  #include "avl-template.h"
  #include "avl-template-cleardefs.h"

#ifdef DOXYGEN_processing
}
#endif

#endif /* #ifndef MVARRAY_omit_array_t_member_defines */
/******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MVARRAY_omit_array_t
  #ifndef MVARRAY_omit_array_t_typedefs
typedef struct MVARRAY_NS(array_t) MVARRAY_NS(array_t)
	, * MVARRAY_NS(array_ptr_t);
  #endif
struct MVARRAY_NS(array_t) {
	MVARRAY_count_t MVARRAY_count;
	MVARRAY_count_t MVARRAY_length;
	MVARRAY_count_t MVARRAY_max_size;
	MVARRAY_count_t MVARRAY_payload_reserve;
	MVARRAY_count_t MVARRAY_payload_increment;
	MVARRAY_count_t MVARRAY_payload_average;
	MVARRAY_count_t MVARRAY_offset_increment;
	MVARRAY_NS(tree_tree_t) MVARRAY_root;
};
#endif

#ifndef MVARRAY_omit_unpack_array_DECLARE
MVARRAY_prefix MVARRAY_array_ptr_t
MVARRAY_NS(unpack_array)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t p
)
;
#endif
#ifndef MVARRAY_omit_pack_array_DECLARE
MVARRAY_prefix MVARRAY_packed_array_ptr_t
MVARRAY_NS(pack_array)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t p
);
#endif

MVARRAY_prefix MVARRAY_size_t MVARRAY_NS(tree_item_count)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
);
MVARRAY_prefix int MVARRAY_NS(tree_item_count_for_range)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_size_t where
, MVARRAY_size_t count
, MVARRAY_entry_size_t * pres
);
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(tree_item_for)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_size_t index
);
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(next_tree_item)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_NS(tree_item_ptr_t) pitem
);
MVARRAY_prefix MVARRAY_NS(tree_item_ptr_t) MVARRAY_NS(prev_tree_item)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_NS(tree_item_ptr_t) pitem
);
MVARRAY_prefix int MVARRAY_NS(init)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t payload_max
, MVARRAY_size_t payload_reserve
, MVARRAY_size_t payload_increment
, MVARRAY_size_t payload_average
);
#ifndef MVARRAY_omit_free_DECLARE
MVARRAY_prefix void MVARRAY_NS(free)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
);
#else
  #define MVARRAY_omit_free
#endif
MVARRAY_prefix void MVARRAY_NS(clear)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
);
MVARRAY_prefix int MVARRAY_NS(clone)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha_to
, MVARRAY_packed_array_ptr_t ha_from
);
#ifndef MVARRAY_omit_resize_DECLARE
MVARRAY_prefix int MVARRAY_NS(resize)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where0
, MVARRAY_input_t d
, MVARRAY_entry_size_t size0
);
#else
  #define VARRAY_omit_resize
#endif
#ifndef MVARRAY_omit_insert_DECLARE
MVARRAY_prefix int MVARRAY_NS(insert)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where
, MVARRAY_input_t d
, MVARRAY_size_t size
);
#else
  #define MVARRAY_omit_insert
#endif
MVARRAY_prefix int MVARRAY_NS(insert_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where
, MVARRAY_size_t count
, const MVARRAY_entry_size_t * sizes
);
#ifndef MVARRAY_omit_remove_DECLARE
MVARRAY_prefix int MVARRAY_NS(remove)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where
);
#else
  #define MVARRAY_omit_remove
#endif
MVARRAY_prefix int MVARRAY_NS(remove_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t where
, MVARRAY_size_t count
);
#ifndef MVARRAY_omit_push_back_DECLARE
MVARRAY_prefix int MVARRAY_NS(push_back)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_input_t d
, MVARRAY_size_t size
);
#else
  #define MVARRAY_omit_push_back
#endif
#ifndef MVARRAY_omit_push_back_many_DECLARE
MVARRAY_prefix int MVARRAY_NS(push_back_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
, const MVARRAY_entry_size_t * sizes
);
#else
  #define MVARRAY_omit_push_back_many
#endif
#ifndef MVARRAY_omit_push_front_DECLARE
MVARRAY_prefix int MVARRAY_NS(push_front)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_input_t d
, MVARRAY_size_t size
);
#else
  #define MVARRAY_omit_push_front
#endif
#ifndef MVARRAY_omit_push_front_many_DECLARE
MVARRAY_prefix int MVARRAY_NS(push_front_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
, const MVARRAY_entry_size_t * sizes
);
#else
  #define MVARRAY_omit_push_front_many
#endif
#ifndef MVARRAY_omit_pop_back_DECLARE
MVARRAY_prefix int MVARRAY_NS(pop_back)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
);
#else
  #define MVARRAY_omit_pop_back
#endif
#ifndef MVARRAY_omit_pop_back_many_DECLARE
MVARRAY_prefix int MVARRAY_NS(pop_back_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
);
#else
  #define MVARRAY_omit_pop_back_many
#endif
#ifndef MVARRAY_omit_pop_front_DECLARE
MVARRAY_prefix int MVARRAY_NS(pop_front)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
);
#else
  #define MVARRAY_omit_pop_front
#endif
#ifndef MVARRAY_omit_pop_front_many_DECLARE
MVARRAY_prefix int MVARRAY_NS(pop_front_many)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_packed_array_ptr_t ha
, MVARRAY_size_t count
);
#else
  #define MVARRAY_omit_pop_front_many
#endif
#if 0
TODO later!
#ifndef MVARRAY_omit_reverse_some_DECLARE
MVARRAY_prefix int MVARRAY_NS(reverse_some)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
, MVARRAY_count_t where
, MVARRAY_count_t count
);
#else
  #define MVARRAY_omit_reverse_some
#endif
#ifndef MVARRAY_omit_reverse_DECLARE
MVARRAY_prefix void MVARRAY_NS(reverse)
( MVARRAY_runtime_ptr_t runtime
, MVARRAY_array_ptr_t pa
);
#else
  #define MVARRAY_omit_reverse
#endif
#endif

#ifdef __cplusplus
} /* extern "C" { */
#endif
