/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#define TREEDB_STORAGE_RUNTIME_MEMBERS \
  TREEDB_STORAGE_RUNTIME_PREFIX_MEMBERS \
  TREEDB_STORAGE_RUNTIME_BASE_MEMBERS \
  pthread_mutex_t m_mx; \
  TREEDB_STORAGE_RUNTIME_CONDITION_MEMBERS \
  TREEDB_STORAGE_RUNTIME_OFFSET_MEMBERS \
  unsigned int m_open_flags; \
  unsigned int m_map_protect; \
  unsigned int m_map_flags; \
  TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS \
  TREEDB_STORAGE_RUNTIME_SUFFIX_MEMBERS

#define TREEDB_STORAGE_RUNTIME_INIT_BARE \
  TREEDB_STORAGE_RUNTIME_PREFIX_MEMBERS_INIT \
  TREEDB_STORAGE_RUNTIME_BASE_MEMBERS_INIT \
  , PTHREAD_MUTEX_INITIALIZER \
  TREEDB_STORAGE_RUNTIME_CONDITION_MEMBERS_INIT \
  TREEDB_STORAGE_RUNTIME_OFFSET_MEMBERS_INIT \
  , eHeapOpenRead, 0, 0 \
  TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS_INIT \
  TREEDB_STORAGE_RUNTIME_SUFFIX_MEMBERS_INIT

#define TREEDB_STORAGE_RUNTIME_INIT \
{ TREEDB_STORAGE_RUNTIME_INIT_BARE }

#ifndef TREEDB_STORAGE_RUNTIME_PREFIX_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_PREFIX_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_PREFIX_MEMBERS_INIT
#endif
#ifndef TREEDB_STORAGE_RUNTIME_SUFFIX_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_SUFFIX_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_SUFFIX_MEMBERS_INIT
#endif
#ifndef TREEDB_STORAGE_RUNTIME_BASE_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_BASE_MEMBERS \
    union { \
      char * m_pBase; \
      TREEDB_NS(treedb_ptr_t) m_pTreedb; \
    }; \
    size_t m_uSize;

  #define TREEDB_STORAGE_RUNTIME_BASE_MEMBERS_INIT {}, 0
#endif
#ifndef TREEDB_STORAGE_RUNTIME_CONDITION_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_CONDITION_MEMBERS \
    pthread_cond_t m_cond; \
    uint16_t m_uReadersActive, m_uWritersWaiting; \
    pthread_t m_active_writer_thread;

  #define TREEDB_STORAGE_RUNTIME_CONDITION_MEMBERS_INIT \
    , PTHREAD_COND_INITIALIZER \
    , 0, 0, 0
#endif
#ifndef TREEDB_STORAGE_RUNTIME_OFFSET_MEMBERS
  #define TREEDB_STORAGE_RUNTIME_OFFSET_MEMBERS \
    size_t m_offset;
  #define TREEDB_STORAGE_RUNTIME_OFFSET_MEMBERS_INIT , 0
#endif
#ifndef TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS
  #ifdef TREEDB_SHARED
    #define TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS\
      FileLockState m_fls /* Process-wide lock. */
    #define TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS_INIT \
      , FILE_LOCK_INIT
  #else
    #define TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS
    #define TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS_INIT
  #endif /* #ifdef TREEDB_SHARED */
#endif /* #ifndef TREEDB_STORAGE_RUNTIME_FILELOCK_MEMBERS */
