/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef TREEDB_NS
#error Do not include this file directly - include a file that defines "TREEDB_NS".
#endif

#if !(defined(OMIT_AVL_allocator_t) || defined(TREEDB_NO_TYPES))
#include "avl-allocator.h"
#endif

#if !(defined(OMIT_TREEDB_treedb_t) || defined(TREEDB_NO_TYPES))
struct TREEDB_NS(treedb_t)
{
	TreedbHeader m_header;
	TREEDB_NS(allocator_t) m_allocator;
	TREEDB_PAYLOAD;
};
#endif

#include <treedb/storage-defines.h>
#include <v3c/file-lock.h>

#if !(defined(OMIT_TREEDB_runtime_t) || defined(TREEDB_NO_TYPES))
struct TREEDB_NS(runtime_t)
{
	TREEDB_STORAGE_RUNTIME_MEMBERS;
};
#endif

#ifndef OMIT_TREEDB_functions

TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_just_open)
( TREEDB_NS(runtime_ptr_t) runtime
, const char * name
, unsigned int open_flags
, unsigned int access_flags
, size_t offset
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_just_open_fd)
( TREEDB_NS(runtime_ptr_t) runtime
, int fd
, unsigned int open_flags
, unsigned int access_flags
, size_t offset
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_open)
( TREEDB_NS(runtime_ptr_t) runtime
, const uuid_t uSchema
, const char * name
, unsigned int open_flags
, unsigned int access_flags
, size_t offset
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_open_fd)
( TREEDB_NS(runtime_ptr_t) runtime
, const uuid_t uSchema
, int fd
, unsigned int open_flags
, unsigned int access_flags
, size_t offset
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_create)
( TREEDB_NS(runtime_ptr_t) runtime
, const uuid_t uSchema
, const char * name
, unsigned int open_flags
, unsigned int create_permissions
, unsigned int access_flags
, size_t offset
, size_t size
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_create2)
( TREEDB_NS(runtime_ptr_t) runtime
, const uuid_t uSchema
, const char * name
, unsigned int open_flags
, unsigned int create_permissions
, unsigned int access_flags
, int dev_zero_fd
, size_t offset
, size_t size
, size_t dev_zero_size
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_init_fd)
( TREEDB_NS(runtime_ptr_t) runtime
, int fd
, unsigned int open_flags
, unsigned int access_flags
, size_t offset
, size_t size
);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_close)(TREEDB_NS(runtime_ptr_t) runtime);
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_read_lock)
	( TREEDB_NS(runtime_ptr_t) runtime );
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_read_lock_at)
	( TREEDB_NS(runtime_ptr_t) runtime, void * vp );
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_write_lock)
	( TREEDB_NS(runtime_ptr_t) runtime );
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_write_lock_at)
	( TREEDB_NS(runtime_ptr_t) runtime, void * vp );
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_unlock)
	( TREEDB_NS(runtime_ptr_t) runtime );
TREEDB_NS_declare_prefix TreedbHeapStatus TREEDB_NS(heap_relock)
	( TREEDB_NS(runtime_ptr_t) runtime, int fd);
#endif /* #ifndef OMIT_TREEDB_functions */
