/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/string_utils.h> /* for v3c_strcpy */

#ifdef DOXYGEN_processing
{
#endif

/* LIST - define macros we use. */

#ifndef STRING_LIST_NS
  #define STRING_LIST_NS(x) TREEDB_NS(StringList_##x)
#endif
#ifndef STRING_LIST_MEMBER
  #define STRING_LIST_MEMBER m_string_list
#endif
#ifndef STRING_LIST
  #define STRING_LIST MAKE_LIST(STRING_LIST_MEMBER)
#endif
#ifndef PACKED_STRING_LIST
  #define PACKED_STRING_LIST \
	MAKE_PACKED_LIST(STRING_LIST_NS, STRING_LIST_MEMBER)
#endif

#define STRING_LIST_NS_unpack_tree(x) \
	(STRING_LIST_NS(list_ptr_t))TREEDB_unpack_pointer(x)
#define STRING_LIST_NS_unpack_node(x) \
	(STRING_LIST_NS(node_ptr_t))TREEDB_unpack_pointer(x)

/* LIST - define macros list.h uses - it will undefine them. */

#define LIST_NS_ALLOC_SIZE(ctx, data) \
	(offsetof(STRING_LIST_NS(node_t), LIST_TMPL_item) + strlen(data) + 1)
#define LIST_NS_STORE_DATA(ret, data) v3c_strcpy(ret->LIST_TMPL_item, data)

#define LIST_NS(x) STRING_LIST_NS(x)
#define LIST STRING_LIST
#define PACKED_LIST PACKED_STRING_LIST
#define LIST_MEMBER STRING_LIST_MEMBER
#define LIST_NS_CAN_CLONE_POINTER
#define LIST_input_t const char *
#define LIST_data_t char
#define LIST_TMPL_item_SUFFIX []
#define LIST_NS_cmp(a, b) strcmp(a,b)

#include <treedb/list.h>

#ifdef DOXYGEN_processing
}
#endif
