/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include <v3c/string_utils.h>

#ifdef DOXYGEN_processing
{
#endif

/* LIST - define macros we use. */

#ifndef STRUCT_LIST_NS
  #define STRUCT_LIST_NS(x) TREEDB_NS(StructList_##x)
#endif
#ifndef STRUCT_LIST_MEMBER
  #define STRUCT_LIST_MEMBER m_struct_list
#endif
#ifndef STRUCT_LIST
  #define STRUCT_LIST MAKE_LIST(STRUCT_LIST_MEMBER)
#endif
#ifndef PACKED_STRUCT_LIST
  #define PACKED_STRUCT_LIST \
	MAKE_PACKED_LIST(STRUCT_LIST_NS, STRUCT_LIST_MEMBER)
#endif

#define STRUCT_LIST_NS_unpack_list(x) \
	(STRUCT_LIST_NS(list_ptr_t))TREEDB_unpack_pointer(x)
#define STRUCT_LIST_NS_unpack_node(x) \
	(STRUCT_LIST_NS(node_ptr_t))TREEDB_unpack_pointer(x)

/* LIST - define macros list.h uses - it will undefine them. */

#define LIST_NS_ALLOC_SIZE(ctx, data) \
	(offsetof(STRUCT_LIST_NS(node_t), LIST_TMPL_item) \
	+ sizeof(STRUCT_LIST_NS(data_t)) \
	+ strlen(data->m_string) + 1)
#define LIST_NS_STORE_DATA(ret, data) \
	v3c_strcpy(ret->LIST_TMPL_item.m_string, data->m_string); \
	ret->LIST_TMPL_item.m_int = data->m_int;

#define LIST_NS(x) STRUCT_LIST_NS(x)
#define LIST LIST_STRUCT
#define PACKED_LIST PACKED_STRUCT_LIST
#define LIST_MEMBER STRUCT_LIST_MEMBER
#define LIST_NS_CAN_CLONE_POINTER
#define LIST_input_t STRUCT_LIST_NS(input_ptr_t)
#define LIST_data_t STRUCT_LIST_NS(data_t)

#ifndef STRUCT_LIST_NO_TYPES

  #ifndef LIST_omit_treedb_impl

    #include <treedb/ns-types.h>

  #endif /* #ifndef LIST_omit_treedb_impl */

typedef struct STRUCT_LIST_NS(data_t) {
	int32_t m_int;
	char m_string[];
} STRUCT_LIST_NS(data_t), * STRUCT_LIST_NS(data_ptr_t);
typedef const STRUCT_LIST_NS(data_t) * STRUCT_LIST_NS(const_data_ptr_t);

typedef struct STRUCT_LIST_NS(input_t) {
	const char * m_string;
	int32_t m_int;
} STRUCT_LIST_NS(input_t), * STRUCT_LIST_NS(input_ptr_t);
typedef const STRUCT_LIST_NS(input_t) * STRUCT_LIST_NS(const_input_ptr_t);

  #ifdef STRUCT_LIST_NO_IMPL
    #define LIST_NO_IMPL
    #define LIST_NO_CLEARDEFS
    #include <treedb/list.h>
  #endif

#endif /* #ifndef STRUCT_LIST_NO_TYPES */

#ifndef STRUCT_LIST_NO_IMPL

  #include <treedb/list-defines.h>

#ifdef __cplusplus
extern "C" {
#endif

LIST_TMPL_prefix struct LIST_TMPL_NS(node_t) * LIST_TMPL_NS(impl_clone_node)
( LIST_TMPL_runtime_ptr_t runtime
, const LIST_TMPL_data_t * pd
);

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef STRUCT_LIST_NO_IMPL */

#define LIST_NO_CLEARDEFS
#include <treedb/list.h>

#ifndef STRUCT_LIST_NO_IMPL

  #include <treedb/list-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

LIST_TMPL_prefix struct LIST_TMPL_NS(node_t) * LIST_TMPL_NS(impl_clone_node)
( LIST_TMPL_runtime_ptr_t runtime
, const LIST_TMPL_data_t * pd
) {
	STRUCT_LIST_NS(input_t) in = { pd->m_string, pd->m_int };
	return LIST_TMPL_NS(impl_alloc_node)(runtime, & in);
}

  #ifdef __cplusplus
} /* extern "C" { */
  #endif

#endif /* #ifndef STRUCT_LIST_NO_IMPL */

#ifndef STRUCT_LIST_NO_CLEARDEFS
  #undef STRUCT_LIST_NS
  #undef STRUCT_LIST_MEMBER
  #undef STRUCT_LIST
  #undef PACKED_STRUCT_LIST
  #undef STRUCT_LIST_NS_unpack_list
  #undef STRUCT_LIST_NS_unpack_node

  #include <treedb/list-cleardefs.h>
#else
  #undef STRUCT_LIST_NO_CLEARDEFS
#endif

#ifdef DOXYGEN_processing
}
#endif
