/* Copyright (C) 2011  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef TREEDB_NS_size_t
  #define TREEDB_NS_size_t size_t
#endif
#ifndef TREEDB_NS_ssize_t
  #define TREEDB_NS_ssize_t ssize_t
#endif
#ifndef TREEDB_NS_prefix
  #define TREEDB_NS_prefix
#endif
#ifndef TREEDB_CHECK_HEAP
  #define TREEDB_CHECK_HEAP(runtime) TREEDB_NS(check_heap)(runtime)
#endif
#ifndef TREEDB_ALLOC_set_errno
  #define TREEDB_ALLOC_set_errno(x) v3c_treedb_allocator_abort(x)
#endif
#ifndef TREEDB_UNPACK_ALLOCATOR_ERRNO
  #define TREEDB_UNPACK_ALLOCATOR_ERRNO(a) (a)->m_errno
#endif
#ifndef TREEDB_NS_offset_out_of_range
  #define TREEDB_NS_offset_out_of_range(x) (x) >= (TREEDB_NS(count_t))-1
#endif
#ifndef TREEDB_STORAGE_base
  #define TREEDB_STORAGE_base (runtime->m_pBase)
#endif
#ifndef TREEDB_STORAGE_size
  #define TREEDB_STORAGE_size runtime->m_uSize
#endif
#ifndef TREEDB_ALLOCATOR
  #define TREEDB_ALLOCATOR runtime->m_pTreedb->m_allocator
#endif

#ifndef TREEDB_ALLOC_node_prev
  #define TREEDB_ALLOC_node_prev(p) (p)->m_offset_prev
#endif
#ifndef TREEDB_ALLOC_node_set_prev
  #define TREEDB_ALLOC_node_set_prev(p, v) (p)->m_offset_prev = v
#endif
#ifndef TREEDB_ALLOC_node_and_prev
  #define TREEDB_ALLOC_node_and_prev(p, v) (p)->m_offset_prev &= v
#endif
#ifndef TREEDB_ALLOC_node_next
  #define TREEDB_ALLOC_node_next(p) (p)->m_offset_next
#endif
#ifndef TREEDB_ALLOC_node_set_next
  #define TREEDB_ALLOC_node_set_next(p, v) (p)->m_offset_next = v
#endif
#ifndef TREEDB_ALLOC_node_and_next
  #define TREEDB_ALLOC_node_and_next(p, v) (p)->m_offset_next &= v
#endif
#ifndef TREEDB_ALLOC_node_length
  #define TREEDB_ALLOC_node_length(p) (p)->m_uLength
#endif
#ifndef TREEDB_ALLOC_node_set_length
  #define TREEDB_ALLOC_node_set_length(p, v) (p)->m_uLength = v
#endif
#ifndef TREEDB_ALLOC_node_length_add
  #define TREEDB_ALLOC_node_length_add(p, v) (p)->m_uLength += v
#endif
#ifndef TREEDB_ALLOC_node_length_sub
  #define TREEDB_ALLOC_node_length_sub(p, v) (p)->m_uLength -= v
#endif
#ifndef TREEDB_MINSIZE
  #define TREEDB_MINSIZE sizeof(TREEDB_NS(treedb_t))
#endif
#ifndef TREEDB_item_offset
  #define TREEDB_item_offset(item) ((item) & ~((TREEDB_NS(count_t))1))
#endif
#ifndef TREEDB_packed_item_offset
  #define TREEDB_packed_item_offset(item) \
	((item) & ~((TREEDB_NS(count_t))1))
#endif
#ifndef TREEDB_node_isfree
  #define TREEDB_node_isfree(item) ((item) & ((TREEDB_NS(count_t))1))
#endif
#ifndef TREEDB_packed_node_isfree
  #define TREEDB_packed_node_isfree(item) TREEDB_node_isfree(item)
#endif
#ifndef TREEDB_node_setfree
  #define TREEDB_node_setfree(item) ((item) | ((TREEDB_NS(count_t))1))
#endif
#ifndef TREEDB_packed_node_setfree
  #define TREEDB_packed_node_setfree(item) \
	((item) | ((TREEDB_NS(count_t))1))
#endif
#ifndef TREEDB_ALLOC_used_head
  #define TREEDB_ALLOC_used_head \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_used.m_head)
#endif
#ifndef TREEDB_ALLOC_used_tail
  #define TREEDB_ALLOC_used_tail \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_used.m_tail)
#endif
#ifndef TREEDB_ALLOC_used_top
  #define TREEDB_ALLOC_used_top \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_used.m_top)
#endif
#ifndef TREEDB_ALLOC_free_head
  #define TREEDB_ALLOC_free_head \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_free.m_head)
#endif
#ifndef TREEDB_ALLOC_free_tail
  #define TREEDB_ALLOC_free_tail \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_free.m_tail)
#endif
#ifndef TREEDB_ALLOC_free_top
  #define TREEDB_ALLOC_free_top \
	TREEDB_NSA_unpack_node(TREEDB_ALLOCATOR.m_free.m_top)
#endif
#ifndef TREEDB_node_next
  #define TREEDB_node_next(p) TREEDB_NSA_unpack_node((p)->m_next)
#endif
#ifndef TREEDB_page_alloc
  #define TREEDB_page_alloc(sz) TREEDB_NS(impl_page_alloc)(runtime, sz)
#endif
#ifndef TREEDB_page_free
  #define TREEDB_page_free(sz) TREEDB_NS(impl_page_free)(runtime, sz)
#endif
#ifndef TREEDB_post_free
  #define TREEDB_post_free(p, sz) TREEDB_NS(impl_post_free)(runtime, p, sz)
#endif
