/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef VARRAY_TMPL_NS
  #define VARRAY_TMPL_NS(x) VARRAY_NS(x)
#endif
#ifndef VARRAY_prefix
  #define VARRAY_prefix static inline
#endif

#ifdef VARRAY_TMPL_prefix
  #define VARRAY_TMPL_prefix VARRAY_prefix
#endif

#ifdef VARRAY_size_t
  #define VARRAY_TMPL_size_t VARRAY_size_t
#else
  #define VARRAY_TMPL_size_t uintptr_t
#endif
#ifdef VARRAY_count_t
  #define VARRAY_TMPL_count_t VARRAY_count_t
#else
  #define VARRAY_TMPL_count_t TREEDB_NS_CONCAT(uint,_t)
#endif

#ifdef VARRAY_data_t
  #define VARRAY_TMPL_data_t VARRAY_data_t
#else
  #define VARRAY_TMPL_data_t char
#endif

#ifdef VARRAY_input_t
  #define VARRAY_TMPL_input_t VARRAY_input_t
#else
  #define VARRAY_TMPL_input_t const VARRAY_data_t *
#endif

#ifdef VARRAY_OFFSET_data_ptr_t
  #define VARRAY_TMPL_OFFSET_data_ptr_t VARRAY_OFFSET_data_ptr_t
#else
  #define VARRAY_TMPL_OFFSET_data_ptr_t VARRAY_TMPL_size_ptr_t
#endif

#define VARRAY_OFFSET_unpack_array(h) \
  (VARRAY_TMPL_NS(offset_array_ptr_t))(VARRAY_TMPL_unpack_pointer(h))
#define VARRAY_PAYLOAD_unpack_array(h) \
  (VARRAY_TMPL_NS(payload_array_ptr_t))(VARRAY_TMPL_unpack_pointer(h))

#define VARRAY_OFFSET_unpack_data(h) \
  (VARRAY_OFFSET_data_ptr_t)(VARRAY_TMPL_unpack_pointer(h))
#define VARRAY_PAYLOAD_unpack_data(h) \
  (VARRAY_data_t *)(VARRAY_TMPL_unpack_pointer(h))

#ifndef VARRAY_TMPL_memmove
  #define VARRAY_TMPL_memmove(to, from, size) \
    VARRAY_TMPL_memmove(to, from, size)
#endif
#ifndef VARRAY_TMPL_clear_entries
  #define VARRAY_TMPL_clear_entries(ha, begin, size) 0
#endif
#ifndef VARRAY_TMPL_entry_align
  #define VARRAY_TMPL_entry_align 1
#endif

#ifndef VARRAY_NS_ALLOC_SIZE
  #define VARRAY_NS_ALLOC_SIZE(ctx, d) sizeof(VARRAY_NS(node_t))
#endif
#ifndef VARRAY_NS_STORE_DATA
  #define VARRAY_NS_STORE_DATA(ret, d) ret->VARRAY_TMPL_item = d
#endif

#ifndef VARRAY_TMPL_alloc
  #define VARRAY_TMPL_alloc(sz) VARRAY_TMPL_NS(impl_alloc)(runtime, sz)
#endif
#ifndef VARRAY_TMPL_free
  #define VARRAY_TMPL_free(pv) VARRAY_TMPL_NS(impl_free)(runtime, pv)
#endif
#ifndef VARRAY_TMPL_realloc
  #define VARRAY_TMPL_realloc(pv, sz) \
    VARRAY_TMPL_NS(impl_realloc)(runtime, pv, sz)
#endif

#ifndef VARRAY_TMPL_unpack_pointer
  #define VARRAY_TMPL_unpack_pointer(h) \
    TREEDB_NS(impl_unpack_pointer)(runtime, h)
#endif
#ifndef VARRAY_TMPL_pack_pointer
  #define VARRAY_TMPL_pack_pointer(p) \
    TREEDB_NS(impl_pack_pointer)(runtime, p)
#endif

#ifndef VARRAY_TMPL_runtime_ptr_t
  #define VARRAY_TMPL_runtime_ptr_t TREEDB_NS(runtime_ptr_t)
#endif

#include <treedb/varray-template-defines.h>
