/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "varray-template-defines.h"

#ifdef DOXYGEN_processing
}
#endif

#include <v3c/offset.hpp>

/* 7. optional */
#ifndef VARRAY_TMPL_entry_align
  #define VARRAY_TMPL_entry_align TREEDB_ALIGN
#endif
#ifndef VARRAY_TMPL_clear_entries
  #define VARRAY_TMPL_clear_entries(ha, begin, count) \
    VARRAY_TMPL_NS(clear_entries)(runtime, ha, begin, count)
#endif

#ifdef VARRAY_TMPL_omit_init_empty_ptr
  #ifndef VARRAY_TMPL_omit_init_empty
    #define VARRAY_TMPL_omit_init_empty
  #endif
#endif

#ifdef VARRAY_TMPL_omit_reverse_some
  #ifndef VARRAY_TMPL_omit_reverse
    #define VARRAY_TMPL_omit_reverse
  #endif
#endif

#ifndef VARRAY_TMPL_omit_array_t_member_impl

/******************************************************************************/
/* Offset array                                                               */
/******************************************************************************/
#define ARRAY_NS(x) VARRAY_TMPL_NS(offset_##x)
#define ARRAY_prefix VARRAY_TMPL_prefix
#define ARRAY_size_t VARRAY_TMPL_size_t
#define ARRAY_count_t VARRAY_TMPL_count_t
#define ARRAY_input_t VARRAY_TMPL_count_t
#define ARRAY_data_t VARRAY_TMPL_count_t

#ifndef VARRAY_TMPL_want_OFFSET_pop_back_many
  #define ARRAY_TMPL_omit_pop_back_many
#endif

#define ARRAY_TMPL_omit_pack_array

#ifdef VARRAY_TMPL_omit_init_empty_ptr
  #define ARRAY_TMPL_omit_init_empty_ptr
#endif
#define ARRAY_TMPL_omit_init_empty
#define ARRAY_TMPL_omit_new
#define ARRAY_TMPL_omit_free
#define ARRAY_TMPL_omit_push_back_many
#define ARRAY_TMPL_omit_push_front
#define ARRAY_TMPL_omit_push_front_many
#define ARRAY_TMPL_omit_pop_back

#define ARRAY_TMPL_omit_pop_front
#define ARRAY_TMPL_omit_pop_front_many
#define ARRAY_TMPL_omit_reverse

#ifdef VARRAY_TMPL_omit_reverse
  #define ARRAY_TMPL_omit_reverse_some
#endif

#define ARRAY_NO_TYPES
#define ARRAY_omit_treedb_impl
#define ARRAY_omit_impl_realloc_packed

#ifdef DOXYGEN_processing
{
#endif

#include "array.h"

#ifdef DOXYGEN_processing
}
#endif

/******************************************************************************/
/* Payload array                                                              */
/******************************************************************************/
#define ARRAY_NS(x) VARRAY_TMPL_NS(payload_##x)
#define ARRAY_prefix VARRAY_TMPL_prefix
#define ARRAY_size_t VARRAY_TMPL_size_t
#define ARRAY_count_t VARRAY_TMPL_count_t
#define ARRAY_input_t VARRAY_TMPL_input_t
#define ARRAY_data_t VARRAY_TMPL_data_t

#ifndef VARRAY_TMPL_want_PAYLOAD_pop_back_many
  #define ARRAY_TMPL_omit_pop_back_many
#endif

#define ARRAY_TMPL_omit_pack_array
#ifdef VARRAY_TMPL_omit_init_empty_ptr
  #define ARRAY_TMPL_omit_init_empty_ptr
#endif
#define ARRAY_TMPL_omit_init_empty
#define ARRAY_TMPL_omit_new
#define ARRAY_TMPL_omit_free
#define ARRAY_TMPL_omit_insert
#define ARRAY_TMPL_omit_remove

#ifndef VARRAY_TMPL_want_PAYLOAD_push_back
  #define ARRAY_TMPL_omit_push_back
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_push_back_many
  #define ARRAY_TMPL_omit_push_back_many
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_push_front
  #define ARRAY_TMPL_omit_push_front
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_push_front_many
  #define ARRAY_TMPL_omit_push_front_many
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_pop_back
  #define ARRAY_TMPL_omit_pop_back
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_pop_front
  #define ARRAY_TMPL_omit_pop_front
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_pop_front_many
  #define ARRAY_TMPL_omit_pop_front_many
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_reverse
  #define ARRAY_TMPL_omit_reverse
#endif

#ifdef VARRAY_TMPL_omit_reverse
  #define ARRAY_TMPL_omit_reverse_some
#endif

#ifdef VARRAY_TMPL_omit_init_empty_ptr
  #ifndef ARRAY_TMPL_omit_init_empty_ptr
    #define ARRAY_TMPL_omit_init_empty_ptr
  #endif
#endif
#ifndef VARRAY_TMPL_want_PAYLOAD_pop_back_many
  #define ARRAY_TMPL_omit_pop_back_many
#endif

#define ARRAY_NO_TYPES
#define ARRAY_omit_treedb_impl
#define ARRAY_omit_impl_realloc_packed

#define ARRAY_TMPL_clear_entries(ha, begin, size) 0

#ifdef DOXYGEN_processing
{
#endif

#include "array.h"

#ifdef DOXYGEN_processing
}
#endif

#endif /* #ifndef VARRAY_TMPL_omit_array_t_member_impl */

/******************************************************************************/
#ifndef VARRAY_TMPL_item
  #define VARRAY_TMPL_item(pa, n) \
    VARRAY_TMPL_NS(payload_unpack_data)(runtime \
      , (pa)->VARRAY_TMPL_payload.m_items \
        + VARRAY_TMPL_NS(offset_unpack_data)(runtime \
            , (pa)->VARRAY_TMPL_offset.m_items)[n] * sizeof(VARRAY_TMPL_data_t))
#endif
#ifndef VARRAY_TMPL_assign
  #define VARRAY_TMPL_assign(dest, src, size) memcpy(dest, src, size)
#endif
#ifndef VARRAY_TMPL_assign_count
  #define VARRAY_TMPL_assign_count(dest, src, count) \
    VARRAY_TMPL_assign(dest, src, (count) * sizeof(VARRAY_TMPL_data_t))
#endif


#ifndef VARRAY_TMPL_print_offsets
  #define VARRAY_TMPL_print_offsets(x)
#else
  #ifdef VARRAY_TMPL_print_offsets_SIGNATURE
    VARRAY_TMPL_print_offsets_SIGNATURE;
  #endif
#endif

/* 9. optional */
#ifndef VARRAY_TMPL_exceeds_count_limit
  #ifdef TREEDB_need_exceed_check
    #define VARRAY_TMPL_exceeds_count_limit(x) \
      ((x) > ((VARRAY_TMPL_size_t)((VARRAY_TMPL_count_t)-1)))
  #else
    #define VARRAY_TMPL_exceeds_count_limit(x) 0
  #endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* 10. pointer pack / unpack */
#ifndef VARRAY_TMPL_omit_unpack_array
  #define VARRAY_TMPL_unpack_varray(x) VARRAY_TMPL_NS(unpack_array)(runtime, x)
VARRAY_TMPL_prefix VARRAY_TMPL_varray_ptr_t
VARRAY_TMPL_NS(unpack_array)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t p
) {
	VARRAY_TMPL_varray_ptr_t ret
	  = (VARRAY_TMPL_varray_ptr_t)VARRAY_TMPL_unpack_pointer(p);
	TREEDB_printf8("varray::unpack_array : %lu[0x%lx] -> %p\n"
		, (uintptr_t)p
		, (uintptr_t)p, (void *)(uintptr_t)ret);
	return ret;
}
#endif

#ifndef VARRAY_TMPL_omit_pack_array
  #define VARRAY_TMPL_pack_varray(x) VARRAY_TMPL_NS(pack_array)(runtime, x)
VARRAY_TMPL_prefix VARRAY_TMPL_packed_varray_ptr_t
VARRAY_TMPL_NS(pack_array)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_varray_ptr_t p
) {
	VARRAY_TMPL_packed_varray_ptr_t ret = VARRAY_TMPL_pack_varray(p);
	TREEDB_printf8("varray::pack_array : %p -> %lu[0x%lx]\n"
		, (void *)(uintptr_t)p, (uintptr_t)ret
		, (uintptr_t)ret);
	return ret;
}
#endif
static void VARRAY_TMPL_NS(cleanup)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	VARRAY_TMPL_NS(offset_reset)(runtime, ha);
	VARRAY_TMPL_NS(payload_reset)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload));
	/* Reset the values too, so they don't get freed twice. */
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	pa->VARRAY_TMPL_offset.m_count = 0;
	pa->VARRAY_TMPL_offset.m_items = 0;
	pa->VARRAY_TMPL_payload.m_count = 0;
	pa->VARRAY_TMPL_payload.m_items = 0;
}

/**
Allocate array item storage.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(init)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t payload_reserve
, VARRAY_TMPL_size_t payload_increment
, VARRAY_TMPL_size_t payload_average
) {
	if(!payload_reserve)
		payload_reserve = 1;
	else if(VARRAY_TMPL_exceeds_count_limit(payload_reserve))
		return 1;
	if(!payload_increment)
		payload_increment = 1;
	else if(VARRAY_TMPL_exceeds_count_limit(payload_increment))
		return 2;
	if(!payload_average)
		payload_average = payload_reserve;
	else if(VARRAY_TMPL_exceeds_count_limit(payload_average))
		return 3;
	if(VARRAY_TMPL_NS(offset_init)(runtime, ha
			, payload_reserve / payload_average + 1
			, payload_increment / payload_average)) {
		VARRAY_TMPL_NS(cleanup)(runtime, ha);
		return 4;
	}
	if(VARRAY_TMPL_NS(payload_init)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, payload_reserve, payload_increment))
		return 5;
	if(VARRAY_TMPL_NS(offset_push_back)(runtime, ha, 0)) {
		VARRAY_TMPL_NS(cleanup)(runtime, ha);
		return 6;
	}
	return 0;
}
#ifndef VARRAY_TMPL_omit_init_empty_ptr
/**
Set up an empty array.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(init_empty_ptr)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_varray_ptr_t pa
, VARRAY_TMPL_size_t payload_increment
, VARRAY_TMPL_size_t payload_average
) {
	if(!payload_increment)
		payload_increment = 1;
	else if(VARRAY_TMPL_exceeds_count_limit(payload_increment))
		return 1;
	if(!payload_average)
		payload_average = payload_increment;
	else if(VARRAY_TMPL_exceeds_count_limit(payload_average))
		return 2;
	VARRAY_TMPL_NS(offset_init_empty_ptr)(runtime, & pa->VARRAY_TMPL_offset
			, payload_increment / payload_average);
	VARRAY_TMPL_NS(payload_init_empty_ptr)(runtime, & pa->VARRAY_TMPL_payload
		, payload_increment);
	return 0;
}
#endif
#ifndef VARRAY_TMPL_omit_init_empty
/**
Set up an empty array.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(init_empty)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t increment
, VARRAY_TMPL_size_t average
) {
	return VARRAY_TMPL_NS(init_empty_ptr)(runtime, VARRAY_TMPL_unpack_varray(ha)
		, increment, average);
}
#endif
#ifndef VARRAY_TMPL_omit_new
/**
Allocate an array.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix VARRAY_TMPL_packed_varray_ptr_t VARRAY_TMPL_NS(new)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_size_t reserve
, VARRAY_TMPL_size_t increment
, VARRAY_TMPL_size_t average
) {
	VARRAY_TMPL_varray_ptr_t pa
		= (VARRAY_TMPL_varray_ptr_t)
			VARRAY_TMPL_alloc(sizeof(VARRAY_TMPL_NS(varray_t)));
	if(!pa)
		return 0;
	VARRAY_TMPL_packed_varray_ptr_t ha = VARRAY_TMPL_pack_varray(pa);
	if(VARRAY_TMPL_NS(init)(runtime, ha, reserve, increment, average)) {
		VARRAY_TMPL_free(VARRAY_TMPL_unpack_varray(ha));
		return 0;
	}
	return ha;
}
#endif

/**
Free an array's entries.

The storage used must be write locked.
*/
static void VARRAY_TMPL_NS(reset)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	VARRAY_TMPL_NS(offset_reset)(runtime, ha);
	VARRAY_TMPL_NS(payload_reset)(runtime
		, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload));
}

#ifndef VARRAY_TMPL_omit_free
/**
Free an array.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix void VARRAY_TMPL_NS(free)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	VARRAY_TMPL_NS(reset)(runtime, ha);
	VARRAY_TMPL_free(VARRAY_TMPL_unpack_varray(ha));
}
#endif

/**
Clear (empty) the array.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(clear)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if(pa->VARRAY_TMPL_offset.m_count > 1) {
		VARRAY_TMPL_NS(offset_remove_many)(runtime, ha, 1
			, pa->VARRAY_TMPL_offset.m_count - 1);
		VARRAY_TMPL_NS(offset_unpack_data)(runtime
			, pa->VARRAY_TMPL_offset.m_items)[0] = 0;
	}else if(pa->VARRAY_TMPL_offset.m_count == 1) {
		VARRAY_TMPL_NS(offset_unpack_data)(runtime
			, pa->VARRAY_TMPL_offset.m_items)[0] = 0;
	}else{
		if(VARRAY_TMPL_NS(offset_push_back)(runtime, ha, 0)) {
			VARRAY_TMPL_NS(cleanup)(runtime, ha);
			return 1;
		}
	}
	VARRAY_TMPL_NS(payload_clear)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload));
	return 0;
}
/** Make a copy (clone) of another varray.

The storage used must be write locked.

This is a "shallow copy" of the raw array data.

You may need to take extra steps to ensure that the copy is a consistant shallow
or deep copy.

If cloning fails, the offset array still needs to allocate one entry, which can
fail too, leaving the varray in an inconsistent state.

So if you take steps to recover from the error, call clear() and check its
return value seperately.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(clone)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha_to
, VARRAY_TMPL_packed_varray_ptr_t ha_from
) {
	if(VARRAY_TMPL_NS(offset_clone)(runtime, ha_to, ha_from)) {
		if(VARRAY_TMPL_NS(clear)(runtime, ha_to)) {
			VARRAY_TMPL_NS(cleanup)(runtime, ha_to);
			return 2;
		}
		return 1;
	}
	if(VARRAY_TMPL_NS(payload_clone)(runtime
			, ha_to
				+ v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, ha_from
				+ v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			)) {
		if(VARRAY_TMPL_NS(clear)(runtime, ha_to)) {
			VARRAY_TMPL_NS(cleanup)(runtime, ha_to);
			return 4;
		}
		return 3;
	}
	return 0;
}
#ifndef VARRAY_TMPL_omit_resize
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(resize)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_size_t count
, VARRAY_data_t ** ppData
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= pa->VARRAY_TMPL_offset.m_count)
			|| VARRAY_TMPL_exceeds_count_limit(where))
		return 1;
	VARRAY_TMPL_count_t * offsets
		= VARRAY_TMPL_NS(offset_unpack_data)(runtime
			, pa->VARRAY_TMPL_offset.m_items);
	VARRAY_TMPL_count_t old_count = offsets[where + 1] - offsets[where];
	VARRAY_TMPL_count_t diff;
	if(old_count == count) {
		/* No significant size change. */
		if(ppData) {
			VARRAY_TMPL_data_t * data =
				VARRAY_TMPL_NS(payload_unpack_data)(runtime
					, pa->VARRAY_TMPL_payload.m_items);
			//VARRAY_TMPL_assign_count(data + offsets[where], d, count);
			*ppData = data + offsets[where];
		}
	}else if(old_count < count) {
		/* Size increase. */
		diff = count - old_count;
		if(VARRAY_TMPL_NS(payload_insert_many)(runtime
				, ha
				  + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
				, offsets[where+1]
				, diff
			)
		)
			return 2;
		pa = VARRAY_TMPL_unpack_varray(ha);
		offsets = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items);
		VARRAY_TMPL_count_t n;
		for(n = where + 1; n < pa->VARRAY_TMPL_offset.m_count; ++n)
			offsets[n] += diff;
		if(ppData) {
			VARRAY_TMPL_data_t * data =
				VARRAY_TMPL_NS(payload_unpack_data)(runtime
					, pa->VARRAY_TMPL_payload.m_items);
			//VARRAY_TMPL_assign_count(data + offsets[where], d, count);
			*ppData = data + offsets[where];
		}
	}else{
		/* Size decrease. */
		diff = old_count - count;
		VARRAY_TMPL_NS(payload_remove_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, offsets[where+1] - diff
			, diff
		);
		pa = VARRAY_TMPL_unpack_varray(ha);
		offsets = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items);
		VARRAY_TMPL_count_t n;
		for(n = where + 1; n < pa->VARRAY_TMPL_offset.m_count; ++n)
			offsets[n] -= diff;
		if(ppData) {
			VARRAY_TMPL_data_t * data =
				VARRAY_TMPL_NS(payload_unpack_data)(runtime
					, pa->VARRAY_TMPL_payload.m_items);
			//VARRAY_TMPL_assign_count(data + offsets[where], d, count);
			*ppData = data + offsets[where];
		}
	}
	return 0;
}
#endif
#ifndef VARRAY_TMPL_omit_insert
/**
Insert an item.

The storage used must be write locked.
*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(insert)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_input_t d
, VARRAY_TMPL_size_t count
) {
	// TODO 
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= pa->VARRAY_TMPL_offset.m_count)
		|| VARRAY_TMPL_exceeds_count_limit(
			(where + count - 1) * sizeof(VARRAY_TMPL_data_t)))
		return 1;
	if(VARRAY_TMPL_NS(payload_insert_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, count
		)
	)
		return 3;
	/* Insert the new offset and adjust the succeeding indeces. */
	pa = VARRAY_TMPL_unpack_varray(ha);
	if(VARRAY_TMPL_NS(offset_insert)(runtime
			, ha
			, where
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
		)
	) {
		VARRAY_TMPL_NS(payload_remove_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, count);
		return 4;
	}
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where + 1;
	VARRAY_TMPL_count_t *q = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)
					+ pa->VARRAY_TMPL_offset.m_count;
	for(; p < q; ++p)
		*p += count;
	/* Copy the data in. */
	VARRAY_TMPL_assign_count(VARRAY_TMPL_item(pa, where), d, count);
	return 0;
}
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(reserve)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_size_t count
, VARRAY_data_t ** ppData
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= pa->VARRAY_TMPL_offset.m_count)
			|| VARRAY_TMPL_exceeds_count_limit(where))
		return 1;
#ifdef TREEDB_need_exceed_check
	VARRAY_TMPL_size_t size = count * sizeof(VARRAY_TMPL_data_t);
	if(VARRAY_TMPL_exceeds_count_limit(size))
		return 2;
#endif
	if(VARRAY_TMPL_NS(payload_insert_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, count
		)
	)
		return 3;
	/* Insert the new offset and adjust the succeeding indeces. */
	pa = VARRAY_TMPL_unpack_varray(ha);
	if(VARRAY_TMPL_NS(offset_insert)(runtime
			, ha
			, where
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
		)
	) {
		VARRAY_TMPL_NS(payload_remove_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, count);
		return 4;
	}
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where + 1;
	VARRAY_TMPL_count_t *q = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)
					+ pa->VARRAY_TMPL_offset.m_count;
	for(; p < q; ++p)
		*p += count;

	if(ppData)
		* ppData = VARRAY_TMPL_item(pa, where);
	return 0;
}
#endif
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(insert_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_size_t count
, const VARRAY_TMPL_count_t * counts
) {
	if(!count)
		return 0;
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= pa->VARRAY_TMPL_offset.m_count)
		|| VARRAY_TMPL_exceeds_count_limit(
			(where + count - 1) * sizeof(VARRAY_TMPL_data_t)))
		return 1;
	VARRAY_TMPL_count_t n, total_entry_count = 0;
	for(n = 0; n < count; ++n) {
#ifdef TREEDB_need_exceed_check
		VARRAY_TMPL_size_t entry_size = counts[n] * sizeof(VARRAY_TMPL_data_t);
		if(VARRAY_TMPL_exceeds_count_limit(entry_size))
			return 2;
#endif
		total_entry_count += counts[n];
	}
	/* Reserve space for the data, meeting the alignment constraint. */
	if(VARRAY_TMPL_NS(payload_insert_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, total_entry_count
		)
	)
		return 3;
	/* Insert the new offsets and adjust the succeeding indeces. */
	pa = VARRAY_TMPL_unpack_varray(ha);
	if(VARRAY_TMPL_NS(offset_insert_many)(runtime
			, ha
			, where
			, count
		)
	) {
		VARRAY_TMPL_NS(payload_remove_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, total_entry_count);
		return 4;
	}
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where;
	VARRAY_TMPL_count_t *q = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)
					+ pa->VARRAY_TMPL_offset.m_count;
	/* Get the first offset after the insert - we will add to it. */
	VARRAY_TMPL_count_t count2;
	if(where)
		count2 = p[count];
	else
		count2 = 0;
	for(n = 0; n < count; ++n, ++p) {
		*p = count2;
		count2 += counts[n];
	}
	for(; p < q; ++p)
		*p += total_entry_count;
	return 0;
}
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(insert_many_with_offsets)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_size_t count
, const VARRAY_TMPL_count_t * offsets
) {
	if(!count)
		return 0;
	VARRAY_TMPL_count_t hoffsets;
	int offsets_in_storage = TREEDB_NS(in_heap)(runtime, offsets);
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= pa->VARRAY_TMPL_offset.m_count)
		|| VARRAY_TMPL_exceeds_count_limit(
			(where + count - 1) * sizeof(VARRAY_TMPL_data_t)))
		return 1;
	VARRAY_TMPL_count_t n, total_entry_count = offsets[count] - offsets[0];
	if(offsets_in_storage)
		hoffsets = VARRAY_TMPL_pack_pointer(offsets);
	/* Reserve space for the data, meeting the alignment constraint. */
	if(VARRAY_TMPL_NS(payload_insert_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, total_entry_count
		)
	)
		return 3;
	/* Insert the new offsets and adjust the succeeding indeces. */
	pa = VARRAY_TMPL_unpack_varray(ha);
	if(VARRAY_TMPL_NS(offset_insert_many)(runtime
			, ha
			, where
			, count
		)
	) {
		VARRAY_TMPL_NS(payload_remove_many)(runtime
			, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
			, VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)[where]
			, total_entry_count);
		return 4;
	}
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where;
	VARRAY_TMPL_count_t *q = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items)
					+ pa->VARRAY_TMPL_offset.m_count;
	/* Get the first offset after the insert - we will add to it. */
	VARRAY_TMPL_count_t count2;
	if(where)
		count2 = p[count];
	else
		count2 = 0;

	if(offsets_in_storage)
		offsets = (const VARRAY_TMPL_count_t *)VARRAY_TMPL_unpack_pointer(hoffsets);

	for(n = 0; n < count; ++n, ++p) {
		*p = count2;
		count2 += offsets[n+1] - offsets[n];
	}
	for(; p < q; ++p)
		*p += total_entry_count;
	return 0;
}
#ifndef VARRAY_TMPL_omit_remove
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(remove)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if((where >= (VARRAY_TMPL_size_t)(pa->VARRAY_TMPL_offset.m_count-1))
			|| VARRAY_TMPL_exceeds_count_limit(where))
		return 1;
	if(VARRAY_TMPL_clear_entries(ha, where, 1))
		pa = VARRAY_TMPL_unpack_varray(ha); /* Just in case. */
	VARRAY_TMPL_count_t offset = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[where];
	VARRAY_TMPL_count_t count = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[where + 1] - offset;
	VARRAY_TMPL_NS(payload_remove_many)(runtime
		, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
		, offset, count);
	VARRAY_TMPL_NS(offset_remove)(runtime, ha, where);
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t n;
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where;
	for(n = where; n < pa->VARRAY_TMPL_offset.m_count; ++n, ++p)
		*p -= count;
	return 0;
}
#endif
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(remove_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t where
, VARRAY_TMPL_size_t count
) {
	if(!count)
		return 0;
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	if(((where + count - 1) >= pa->VARRAY_TMPL_offset.m_count)
			|| VARRAY_TMPL_exceeds_count_limit(where + count - 1))
		return 1;
	if(VARRAY_TMPL_clear_entries(ha, where, count))
		pa = VARRAY_TMPL_unpack_varray(ha); /* Just in case. */
	VARRAY_TMPL_count_t offset = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[where];
	VARRAY_TMPL_count_t size = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[where + count] - offset;
	VARRAY_TMPL_NS(payload_remove_many)(runtime
		, ha + v3c_offsetof(VARRAY_TMPL_NS(varray_t), VARRAY_TMPL_payload)
		, offset, size);
	VARRAY_TMPL_NS(offset_remove_many)(runtime, ha, where, count);
	pa = VARRAY_TMPL_unpack_varray(ha);
	VARRAY_TMPL_count_t n;
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + where;
	for(n = where; n < pa->VARRAY_TMPL_offset.m_count; ++n, ++p)
		*p -= size;
	return 0;
}
// Only within the same treedb for now.
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(copy_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha_to
, VARRAY_TMPL_size_t to_where
, VARRAY_TMPL_size_t to_count
, VARRAY_TMPL_packed_varray_ptr_t ha_from
, VARRAY_TMPL_size_t from_where
, VARRAY_TMPL_size_t from_count
) {
	VARRAY_TMPL_varray_ptr_t pa_to = 0;
	if(to_count == (VARRAY_TMPL_size_t)-1) {
		// Get the count.
		pa_to = VARRAY_TMPL_unpack_varray(ha_to);
		to_count = pa_to->VARRAY_TMPL_offset.m_count - 1;
		if(to_where > to_count)
			return 1; // Specifying past-the-end is invalid.
		to_count -= to_where;
	}
	VARRAY_TMPL_varray_ptr_t pa_from = 0;
	if(from_count == (VARRAY_TMPL_size_t)-1) {
		// Get the count.
		pa_from = VARRAY_TMPL_unpack_varray(ha_from);
		from_count = pa_from->VARRAY_TMPL_offset.m_count - 1;
		if(from_where > from_count)
			return 2; // Specifying past-the-end is invalid.
		from_count -= from_where;
	}
	// Fail if "to" and "from" overlap.
	if(ha_to == ha_from) {
		// Check that the source isn't within the destination.
		if(from_count && (from_where >= to_where)
				&& (from_where < (to_where + to_count)))
			return 3;
		// Check that the destination isn't within the source.
		if(to_count && (to_where >= from_where)
				&& (to_where < (from_where + from_count)))
			return 4;
	}
	if(!from_count) {
		if(!to_count)
			return 0;
		return VARRAY_TMPL_NS(remove_many)(runtime, ha_to, to_where, to_count);
	}
	if(!pa_from)
		pa_from = VARRAY_TMPL_unpack_varray(ha_from);
	VARRAY_TMPL_count_t *p = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa_from->VARRAY_TMPL_offset.m_items) + from_where;
	if(VARRAY_TMPL_NS(insert_many_with_offsets)(runtime, ha_to
			, to_where + to_count
			, from_count, p))
		return 5;

	// Copy the data in.
	pa_to = VARRAY_TMPL_unpack_varray(ha_to);
	VARRAY_TMPL_count_t * to_offsets
		= VARRAY_TMPL_NS(offset_unpack_data)(runtime
			, pa_to->VARRAY_TMPL_offset.m_items) + to_where + to_count;
	VARRAY_TMPL_data_t *q_to = VARRAY_TMPL_NS(payload_unpack_data)(runtime
				, pa_to->VARRAY_TMPL_payload.m_items) + to_offsets[0];

	pa_from = VARRAY_TMPL_unpack_varray(ha_from);
	VARRAY_TMPL_count_t * from_offsets
		= VARRAY_TMPL_NS(offset_unpack_data)(runtime
			, pa_from->VARRAY_TMPL_offset.m_items) + from_where;
	VARRAY_TMPL_data_t *q_from = VARRAY_TMPL_NS(payload_unpack_data)(runtime
				, pa_from->VARRAY_TMPL_payload.m_items) + from_offsets[0];
	memcpy(q_to, q_from
		, (from_offsets[from_count] - from_offsets[0]) * sizeof(VARRAY_TMPL_data_t));
	// Remove the elements that were overwritten.
	int ret = VARRAY_TMPL_NS(remove_many)(runtime, ha_to, to_where, to_count);
	if(ret)
		return 6;
	return 0;
}
// Only within the same treedb for now.
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(move_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha_to
, VARRAY_TMPL_size_t to_where
, VARRAY_TMPL_size_t to_count
, VARRAY_TMPL_packed_varray_ptr_t ha_from
, VARRAY_TMPL_size_t from_where
, VARRAY_TMPL_size_t from_count
) {
	if(VARRAY_TMPL_NS(copy_many)(runtime, ha_to, to_where, to_count, ha_from
			, from_where, from_count))
		return 1;
	if(VARRAY_TMPL_NS(remove_many)(runtime, ha_from, from_where, from_count))
		return 2;
	return 0;
}

#ifndef VARRAY_TMPL_omit_push_back
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(push_back)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_input_t d
, VARRAY_TMPL_size_t count
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	return VARRAY_TMPL_NS(insert)
		(runtime, ha, pa->VARRAY_TMPL_offset.m_count - 1, d, count);
}
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(push_back_reserve)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t count
, VARRAY_data_t ** ppData
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	return VARRAY_TMPL_NS(reserve)
		(runtime, ha, pa->VARRAY_TMPL_offset.m_count - 1, count, ppData);
}
#endif
#ifndef VARRAY_TMPL_omit_push_back_many
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(push_back_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t count
, const VARRAY_TMPL_count_t * sizes
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	return VARRAY_TMPL_NS(insert_many)(runtime, ha
		, pa->VARRAY_TMPL_offset.m_count - 1, count, sizes);
}
#endif
#ifndef VARRAY_TMPL_omit_push_front
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(push_front)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_input_t d
, VARRAY_TMPL_size_t count
) {
	return VARRAY_TMPL_NS(insert)(runtime, ha, 0, d, count);
}
#endif
#ifndef VARRAY_TMPL_omit_push_front_many
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(push_front_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t count
, const VARRAY_TMPL_count_t * counts
) {
	return VARRAY_TMPL_NS(insert_many)(runtime, ha, 0, count, counts);
}
#endif
#ifndef VARRAY_TMPL_omit_pop_back
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(pop_back)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	return VARRAY_TMPL_NS(remove)(runtime, ha
		, pa->VARRAY_TMPL_offset.m_count - 2);
}
#endif
#ifndef VARRAY_TMPL_omit_pop_back_many
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(pop_back_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t count
) {
	VARRAY_TMPL_varray_ptr_t pa = VARRAY_TMPL_unpack_varray(ha);
	return VARRAY_TMPL_NS(remove_many)(runtime, ha
		, pa->VARRAY_TMPL_offset.m_count - count - 1, count);
}
#endif
#ifndef VARRAY_TMPL_omit_pop_front
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(pop_front)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
) {
	return VARRAY_TMPL_NS(remove)(runtime, ha, 0);
}
#endif
#ifndef VARRAY_TMPL_omit_pop_front_many
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(pop_front_many)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_size_t count
) {
	return VARRAY_TMPL_NS(remove_many)(runtime, ha, 0, count);
}
#endif
#ifndef VARRAY_TMPL_omit_reverse_some
/** VARRAY_TMPL_NS(reverse_some)

Unfortunately there's no equivalent for VARRAY_TMPL_clear_entries here.

The easiest way I can see to do this is to reverse the entire span of the data
entries and then reverse the data items individually, resulting in a correct
reversal, although there may be a faster way to do it.
start\n
=====
- loc:  0  1  2  3  4
- off:  0  5  9 12 14
- len:  5  4  3  2

reverse_some 0,2\n
================
- loc:  0  1  2  3  4
- off0: 0  5  9 12 14
- len0: 5  4  3  2
- x:       4
- off:  0  4  9 12 14
- len:  4  5  3  2

reverse_some 1,2\n
================
- loc:  0  1  2  3  4
- off0: 0  5  9 12 14
- len0: 5  4  3  2
- x:          3
- off:  0  5  8 12 14
- len:  5  3  4  2

reverse_some 2,2\n
================
- loc:  0  1  2  3  4
- off0: 0  5  9 12 14
- len0: 5  4  3  2
- x:             2
- off:  0  5  9 11 14
- len:  5  4  2  3

reverse_some 1,3\n
================
- loc:  0  1  2  3  4
- off0: 0  5  9 12 14
- len0: 5  4  3  2
- x:          2  3
- off:  0  5  7 10 14
- len:  5  2  3  4

reverse_some 0,3\n
================
- loc:  0  1  2  3  4
- off0: 0  5  9 12 14
- len0: 5  4  3  2
- x0:      4  3
- x:       3  4
- off:  0  3  7 12 14
- len:  3  4  5  2

*/
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(reverse_some)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_varray_ptr_t pa
, VARRAY_TMPL_size_t lower
, VARRAY_TMPL_size_t count
) {
	if(count < 2)
		return 0;
	if(VARRAY_TMPL_exceeds_count_limit(lower + count - 1))
		return 1;
	(void)runtime;
	if(((lower + count - 1) >= pa->VARRAY_TMPL_offset.m_count)
			|| VARRAY_TMPL_exceeds_count_limit(lower + count - 1))
		return 1;
	VARRAY_TMPL_count_t offset = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[lower];
	VARRAY_TMPL_count_t num = VARRAY_TMPL_NS(offset_unpack_data)(runtime
		, pa->VARRAY_TMPL_offset.m_items)[lower + count] - offset;
	VARRAY_TMPL_NS(payload_reverse_some)(runtime, & pa->VARRAY_TMPL_payload
		, offset, num);
	VARRAY_TMPL_count_t *p0 = VARRAY_TMPL_NS(offset_unpack_data)(runtime
				, pa->VARRAY_TMPL_offset.m_items) + lower;
	VARRAY_TMPL_count_t *p = p0 + 1;
	VARRAY_TMPL_count_t n, upper = lower + count;
	/* Compute the x array. */
	VARRAY_TMPL_print_offsets("    before");
	for(n = lower + 1; n < upper; ++n, ++p)
		*p = p[1] - p[0];
	VARRAY_TMPL_print_offsets("         x");
	VARRAY_TMPL_NS(offset_reverse_some)
		(runtime, & pa->VARRAY_TMPL_offset, lower + 1, count - 1);
	VARRAY_TMPL_print_offsets("x reversed");
	p = p0 + 1;
	num = offset;
	for(n = lower + 1; n < upper; ++n, ++p) {
		VARRAY_TMPL_count_t temp = *p;
		num += temp;
		*p = num;
	}
	VARRAY_TMPL_print_offsets("     after");
	p = p0;
	for(n = lower; n < upper; ++n, ++p)
		VARRAY_TMPL_NS(payload_reverse_some)(runtime, & pa->VARRAY_TMPL_payload
			, *p, p[1] - p[0]);
	return 0;
}
#endif
#ifndef VARRAY_TMPL_omit_reverse
VARRAY_TMPL_prefix void VARRAY_TMPL_NS(reverse)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_varray_ptr_t pa
) {
	(void)VARRAY_TMPL_NS(reverse_some)
		(runtime, pa, 0, pa->VARRAY_TMPL_offset.m_count - 1);
}
#endif

#ifdef __cplusplus
} /* extern "C" { */
#endif
