/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef VARRAY_NS
  #define VARRAY_NS(x) TREEDB_NS(VarrayString_##x)
#endif

#ifndef VARRAY_NS_unpack_offset_array_DEFAULT
  #define VARRAY_NS_unpack_offset_array_DEFAULT(x) \
    (VARRAY_NS(offset_array_ptr_t))TREEDB_unpack_pointer(x)
#endif
#ifndef VARRAY_NS_unpack_offset_array
  #define VARRAY_NS_unpack_offset_array(x) \
    VARRAY_NS_unpack_offset_array_default(x)
#endif

#ifndef VARRAY_size_t
  #define VARRAY_size_t uintptr_t
#endif
#ifndef VARRAY_count_t
  #define VARRAY_count_t TREEDB_NS_CONCAT(uint,_t)
#endif

#ifndef VARRAY_OFFSET_data_ptr_t
  #define VARRAY_OFFSET_data_ptr_t VARRAY_size_ptr_t
#endif
#ifndef VARRAY_data_t
  #define VARRAY_data_t char
#endif
#ifndef VARRAY_input_t
  #define VARRAY_input_t const VARRAY_data_t *
#endif

#ifndef VARRAY_NO_TYPES

  #ifndef VARRAY_omit_treedb_impl

    #ifndef VARRAY_MEMBER
      #define VARRAY_MEMBER m_string_varray
    #endif

    #ifndef VARRAY
      #define VARRAY (& runtime->m_pTreedb->VARRAY_MEMBER)
    #endif
    #ifndef PACKED_VARRAY
      #define PACKED_VARRAY TREEDB_NS(impl_pack_pointer)(runtime, VARRAY)
    #endif

    #ifndef TREEDB_PAYLOAD_NS
      #define TREEDB_PAYLOAD_NS(x) VARRAY_NS(x)
    #endif
    #ifndef TREEDB_PAYLOAD_FIRST_MEMBER
      #define TREEDB_PAYLOAD_FIRST_MEMBER VARRAY_MEMBER
    #endif
    #ifndef TREEDB_PAYLOAD
      #define TREEDB_PAYLOAD \
        TREEDB_PAYLOAD_NS(varray_t) TREEDB_PAYLOAD_FIRST_MEMBER
    #endif

    #ifdef DOXYGEN_processing
{
    #endif

    #include <treedb/ns-types.h>

    #ifdef DOXYGEN_processing
}
    #endif

  #endif /* #ifndef VARRAY_omit_treedb_impl */

  #include <treedb/varray-defines.h>

  #ifdef __cplusplus
extern "C" {
  #endif

typedef TREEDB_NS(runtime_t) VARRAY_TMPL_NS(runtime_t);

typedef VARRAY_size_t * VARRAY_size_ptr_t;
typedef char * VARRAY_char_ptr_t;
typedef const char * VARRAY_const_char_ptr_t;

typedef uint8_t * uint8_ptr_t;
typedef uint16_t * uint16_ptr_t;
typedef uint32_t * uint32_ptr_t;
typedef uint64_t * uint64_ptr_t;

typedef const uint8_t * const_uint8_ptr_t;
typedef const uint16_t * const_uint16_ptr_t;
typedef const uint32_t * const_uint32_ptr_t;
typedef const uint64_t * const_uint64_ptr_t;

  #ifdef __cplusplus
} // extern "C" {
  #endif

#ifdef DOXYGEN_processing
{
#endif

  #include <treedb/varray-template.h>
  #include <treedb/varray-template-cleardefs.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #ifndef VARRAY_omit_treedb_storage
    #include <treedb/storage.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef VARRAY_NO_TYPES */

#ifndef VARRAY_NO_IMPL

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/varray-defines.h>

  #ifdef DOXYGEN_processing
}
  #endif

  #ifdef __cplusplus
extern "C" {
  #endif

VARRAY_TMPL_prefix PVOID VARRAY_TMPL_NS(impl_alloc)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_size_t size
) {
	return TREEDB_malloc(size);
}
VARRAY_TMPL_prefix void VARRAY_TMPL_NS(impl_free)
( VARRAY_TMPL_runtime_ptr_t runtime
, PVOID p
) {
	if(p) TREEDB_free(p);
}
VARRAY_TMPL_prefix PVOID VARRAY_TMPL_NS(impl_realloc)
( VARRAY_TMPL_runtime_ptr_t runtime
, PVOID pv
, VARRAY_TMPL_size_t size
) {
	return TREEDB_realloc(pv, size);
}
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(offset_impl_realloc_packed)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_count_t count
) {
	VARRAY_TMPL_count_t size = count * sizeof(VARRAY_TMPL_count_t);
	VARRAY_TMPL_NS(offset_array_ptr_t) pa = VARRAY_OFFSET_unpack_array(ha);
	VARRAY_TMPL_count_t * pd
		= (VARRAY_TMPL_count_t *)TREEDB_realloc
			(VARRAY_OFFSET_unpack_data(pa->m_items), size);
	if(!pd)
		return 1;
	pa = VARRAY_OFFSET_unpack_array(ha);
	pa->m_items = VARRAY_TMPL_pack_pointer(pd);
	return 0;
}
VARRAY_TMPL_prefix int VARRAY_TMPL_NS(payload_impl_realloc_packed)
( VARRAY_TMPL_runtime_ptr_t runtime
, VARRAY_TMPL_packed_varray_ptr_t ha
, VARRAY_TMPL_count_t count
) {
	VARRAY_TMPL_count_t size = count * sizeof(VARRAY_TMPL_data_t);
	VARRAY_TMPL_NS(payload_array_ptr_t) pa
		= VARRAY_PAYLOAD_unpack_array(ha);
	VARRAY_TMPL_data_t * pd
		= (VARRAY_TMPL_data_t *)TREEDB_realloc
			(VARRAY_PAYLOAD_unpack_data(pa->m_items), size);
	if(!pd)
		return 1;
	pa = VARRAY_PAYLOAD_unpack_array(ha);
	pa->m_items = VARRAY_TMPL_pack_pointer(pd);
	return 0;
}

  #ifdef __cplusplus
} /* extern "C" { */
  #endif

  #ifdef DOXYGEN_processing
{
  #endif

  #include <treedb/varray-template-impl.h>

  #include <treedb/varray-template-cleardefs.h>
  #ifndef VARRAY_omit_treedb_impl
    #include <treedb/treedb-impl.h>
  #else
    #include <treedb/treedb-defines.h>
  #endif

  #ifdef DOXYGEN_processing
}
  #endif

#endif /* #ifndef VARRAY_NO_IMPL */

#ifndef VARRAY_NO_CLEARDEFS
  #include <treedb/varray-cleardefs.h>
#else
  #undef VARRAY_NO_CLEARDEFS
#endif
